#!/usr/bin/perl

#use Win32::GUI::Carp qw/warningsToDialog fatalsToDialog/; # macht fehler mit B::Bytecode
use std;
use Getopt::Long; #for commandlineswitches
use IO::Socket;
use IO::Select;
use Tk;
use Tk::JPEG;
#use Tk::NoteBook;
use Tk::DynaTabFrame;
use Tk::StatusBar;
use Tk::LabFrame;
use Tk::Dialog;
use Tk::Balloon;
use Tk::Pane;
use Tk::Animation;
use Tk::Icon;
use Win32::GUI;
use Win32::GUI::DIBitmap;
use Win32::GUI::Constants qw(WM_PAINT WM_LBUTTONDOWN WM_LBUTTONUP WM_SYSCOMMAND);
use Win32::GuiTest;# qw(ShowWindow);
use Win32::Process;
use Win32::Shortcut;
use MIME::Base64; 
use Time::HiRes;
use String::Interpolate;
use Digest::SHA;
use Tk::BrowseEntry;
use Cwd;
#use Compress::Zlib;
#use IPC::Run3; #for_djpeg
#use threads;


#---- overall var's
my %sockhash;
my $version_info = '2.5';

#---- CHDIR to script-dir (no -x needed)
my $abs_file = std::rx_g(Cwd::abs_path($0),"\\\\","/");
chdir(substr($abs_file,0,rindex($abs_file,"/")+1));

#---- API Use's
use Win32::API;
use Win32::API::Callback;
#my $rep_movsb_repeated = Win32::API->new('./bin/move_dll/move.dll','rep_movsb_repeated','IIIIII'      ,'I');
#my $rep_movsb          = Win32::API->new('./bin/move_dll/move.dll','rep_movsb'         ,'III'         ,'I');
my $movsd               = Win32::API->new('./bin/move_dll/move.dll','movsd'             ,'II'          ,'I');
#my $CreateWindowEx     = Win32::API->new('User32.dll'  ,'CreateWindowEx'    ,'IIIIIIIIIIII','I');
#my $ShowWindow         = Win32::API->new('User32.dll'  ,'ShowWindow'        ,'II'          ,'I');
#my $UpdateWindow       = Win32::API->new('User32.dll'  ,'UpdateWindow'      ,'I'           ,'I');
#my $DeleteDC           = Win32::API->new('Gdi32.dll'   ,'DeleteDC'          ,'I'           ,'I');
#my $ReleaseDC          = Win32::API->new('Gdi32.dll'   ,'ReleaseDC'         ,'II'          ,'I');
#my $GetDC              = Win32::API->new('User32.dll'  ,'GetDC'             ,'I'           ,'I');
#my $AnimateWindow      = Win32::API->new('User32.dll'  ,'AnimateWindow'     ,'III'         ,'I');
#my $CreateCompatibleDC = Win32::API->new('Gdi32.dll'   ,'CreateCompatibleDC','I'           ,'I');
#my $CreateBitmap       = Win32::API->new('Gdi32.dll'   ,'CreateBitmap'      ,'IIIII'       ,'I');
#my $SelectObject       = Win32::API->new('Gdi32.dll'   ,'SelectObject'      ,'II'          ,'I');
#my $DeleteObject       = Win32::API->new('Gdi32.dll'   ,'DeleteObject'      ,'I'           ,'I');
my $AllocConsole        = Win32::API->new('Kernel32.dll','AllocConsole'      ,''            ,'N');
my $SetConsoleTitle     = Win32::API->new('Kernel32.dll','SetConsoleTitle'   ,'P'           ,'N');
my $AppendMenu          = Win32::API->new('User32.dll'  ,'AppendMenu'        ,'IIIP'        ,'I');
my $CreateMenu          = Win32::API->new('User32.dll'  ,'CreateMenu'        ,''            ,'I');
my $CreatePopupMenu     = Win32::API->new('User32.dll'  ,'CreatePopupMenu'   ,''            ,'I');
my $SetMenu             = Win32::API->new('User32.dll'  ,'SetMenu'           ,'II'          ,'I');
my $DestroyMenu         = Win32::API->new('User32.dll'  ,'DestroyMenu'       ,'I'           ,'I');
my $RemoveMenu          = Win32::API->new('User32.dll'  ,'RemoveMenu'        ,'III'         ,'I');
my $InsertMenu          = Win32::API->new('User32.dll'  ,'InsertMenu'        ,'IIIIP'       ,'I');
my $ModifyMenu          = Win32::API->new('User32.dll'  ,'ModifyMenu'        ,'IIIIP'       ,'I');
my $LoadImage           = Win32::API->new('User32.dll'  ,'LoadImageA'        ,'IPIIII'      ,'I');
my $SetMenuItemBitmaps  = Win32::API->new('User32.dll'  ,'SetMenuItemBitmaps','IIIII'       ,'I');
my $GetSystemMetrics    = Win32::API->new('User32.dll'  ,'GetSystemMetrics'  ,'I'           ,'I');
my $GetKeyboardState    = Win32::API->new('User32.dll'  ,'GetKeyboardState'  ,'P'           ,'I');
my $EnumDisplayMonitors = Win32::API->new('User32.dll', 'EnumDisplayMonitors','IIKI'        ,'I');
my $GetMonitorInfo      = Win32::API->new('User32.dll', 'GetMonitorInfo'     ,'IP'          ,'I');

#==== Eary commandswitches readout
GetOptions ("tray_login_gui" => \$traylogingui,
            "openwindow=s{,}" => \@openwindow,
            "openthumbs=s{,}" => \@openthumbs);
print "switch: -tray_login_gui\n" if $traylogingui;
print "switch: -openwindow\n" if @openwindow;
print "switch: -openthumbs\n" if @openthumbs;

########################################################
########################################### TRAYICON ###
#my $id = 1;
#my $hwnd = Win32::GUI::GetPerlWindow(); #Win32::GUI::Hide($hwnd);
my $icon = new Win32::GUI::Icon('images/Flip_client.ico');
my $main = Win32::GUI::Window->new(
    -name   => 'Main',
    -text   => 'Perl',
    -width  => 200,
    -height => 200,
    -visible => 0,
);
my $ni = $main->AddNotifyIcon(
    -name => "systray",
    #-id   => $id,
    -icon => $icon,
    -tip  => "-----------\nVirtual\nDisplay\nManager\n-----------\nClient\n-----------",
);
my $systray_menu = Win32::GUI::Menu->new(
    "SystrayMenu Function" => "SystrayMenu",
    #"trayIcon",
    "> Info"       => "SystrayInfo",
    "> Window"     => "DasWindow",
    ">> Show"      => "WindowShow",
    ">> Hide"      => "WindowHide",
    "> Console"    => "DieConsole",
    ">> Show"      => "ConsoleShow",
    ">> Hide"      => "ConsoleHide",
    "> Exit"       => "SystrayExit",
);



############################################################## MW CREATE
my $mw = MainWindow->new();
#$mw->optionAdd('*font', 'Arial 6'); # wuerde fontvergroesserung blocken
$mw->state('withdraw') if (defined $traylogingui);
$mw->maxsize(0,0);
############################################################## Mainwindow OPTS
$mw->protocol('WM_DELETE_WINDOW', \&ExitApplication);
#my $main_icon = $mw->Photo( -file => "images/icon.bmp" );
#$mw->Icon( -image => $main_icon );
$mw->setIcon(-file => 'images/Flip_client.ico');
$mw->title( 'VDM: Login');


#---- NOTEBOOK
#my $nb = $mw->NoteBook()->pack(-ipady => 50);
#our $nb = $mw->NoteBook()->pack();
#my $nb = $mw->NoteBook(-focuscolor => 'black')->pack(-expand => 1,-fill => 'y');
#my $nb = $mw->DynaTabFrame(-tabcolor => "#eeeeee",-raisecolor => "#bbbbbb",-initsize => [230,400],-tabclose => 1,-tabrotate => 0,-tiptime => 600,-tabside => 'wn',-textalign => 0)->pack(-expand => 1,-fill => 'y');
my $nb = $mw->DynaTabFrame(-tabcolor => "#eeeeee",-raisecolor => "#bbbbbb",-tabclose => 1,-tabrotate => 0,-tiptime => 600,-tabside => 'wn',-textalign => 0)->pack(-expand => 1,-fill => 'y');
my $page1 = $nb->add('Main',-label => 'Main',-tabclosekill => 1,-raisecmd => sub{$mw->title("VDM: Login");});#-bitmap => 'info');

#---- STATUSBAR
my $Label_Statusbar = "";
$sb = $mw->StatusBar();
$sb->addLabel(#-background => 'blue',
              -relief         => 'sunken',
              -textvariable   => \$Label_Statusbar,
             );

#---- Page-X Balloons
my $b = $mw->Balloon(-initwait => 0,-balloonposition => 'mouse');

#==== Global Messageboxes
sub infomessbox($$)
{
 Win32::GUI::MessageBox($_[0],$_[1],'VDM: Client',0x1040);
 return 1;
}
sub quesmessbox($$)
{
 my $answer = Win32::GUI::MessageBox($_[0],$_[1],'VDM: Client',0x1024);
 return ($answer == 6)? 1: 0;
}
#sub infomessbox($)
#{
# $mw->messageBox(-title   => 'Virtual Display Manager',
#                 -message => $_[0],
#                 -type    => 'Ok',
#                 -icon    => 'info',
#                 -default => 'Ok');
# return 1;
#}
#sub quesmessbox($)
#{
# my $answer = $mw->messageBox(-title   => 'Virtual Display Manager',
#                              -message => $_[0],
#                              -type    => 'YesNo',
#                              -icon    => 'question',
#                              -default => 'Yes');
# return ($answer eq 'No')? 0: 1;
#}
#sub retrymessbox($)
#{
# my $answer = $mw->messageBox(-title   => 'Virtual Display Manager',
#                              -message => $_[0],
#                              -type    => 'RetryCancel',
#                              -icon    => 'question',
#                              -default => 'Retry');
# return ($answer eq 'Cancel')? 0: 1;
#}

#================================================================== PAGE 1
#-------------------------------------- Connect
my $labframe = $page1->LabFrame(-label => "Connect",
                                #-background => 'white',
                                -labelside => "acrosstop")->pack(-fill => 'x');

$labframe->Label(-text => "IP:Port -> ")->grid(-column => 0,-row => 0,-sticky => 'w');
my $variable_ipport;
my $entry_ipport  = $labframe->Entry(-width => 23,
                                     -textvariable => \$variable_ipport)->grid(-column => 1,-row => 0,-sticky => 'e');
$labframe->Label(-text => "Name -> ")->grid(-column => 0,-row => 1,-sticky => 'w');
my $variable_name;
my $entry_name  = $labframe->Entry(-width => 23,
                                   -textvariable => \$variable_name)->grid(-column => 1,-row => 1,-sticky => 'w,e');
$labframe->Label(-text => "Password -> ")->grid(-column => 0,-row => 2,-sticky => 'w');
my $variable_password;
my $entry_password  = $labframe->Entry(-width => 23,
                                       -textvariable => \$variable_password)->grid(-column => 1,-row => 2,-sticky => 'w,e');
$labframe->Label(-text => "Win-URI -> ")->grid(-column => 0,-row => 3,-sticky => 'w');
my $variable_winuri;
my $entry_winuri  = $labframe->Entry(-width => 23,
                                     -textvariable => \$variable_winuri)->grid(-column => 1,-row => 3,-sticky => 'w,e');

$b->attach($entry_ipport,-balloonmsg => "Enter Ip or Host and Port (e.g.: vdm.myserver.net:5000)\nIf no Port is given, default Port 5000 is used.\nIp or Host are required.");
$b->attach($entry_name,-balloonmsg => "Username to Login. (required)");
$b->attach($entry_password,-balloonmsg => "Password to Login");
$b->attach($entry_winuri,-balloonmsg => "You can specify here what windows you want to load.\nIf empty all topwindows will opend.\nParameter:\n1) Pathname and/or filename of the Windows executable.\n2) Classname of the Windows \n3) Windowname (title-text)\n4) Maxdepth: -1 = Search all windows and childwindows.\n      0 (default) = Only topwindows\n      1 - X = A number to set max. Child-Depth to search\n\nYou can use perl-regex.\nAll parameter must be separated with a colon (:)\nFor example:\ncalc.exe = Calculator toplevel-windows only.\n:Classname = Toplevel-windows with this CN only.\n:Classname::-1 = All windows with this classname.\n(notepad.exe|explorer.exe) = Open windows of 2 programs.\nexplorer.exe:::-1 = Explorer windows and all subwindows.\nexplorer.exe:TrayClockWClass::-1 = Only tray clock subwindow.");

my $button = $labframe->Button(-text  => 'Connect to Server',
                               -bg => 'gray60',-fg => 'white',-activebackground => 'gray60',-activeforeground => 'black',
                               -width => 30,
                               -command => sub{&connect($variable_ipport,$variable_winuri,$variable_name,$variable_password)if(&testfields);})->grid(-columnspan => 2,-column => 0,-row => 4,-sticky => 'we');



#-------------------------------------- Config
my %config;
my $labframe_config = $page1->LabFrame(-label => "Config",
                                       -labelside => "acrosstop")->pack(-fill => 'x');
my $frame_config = $labframe_config->Frame()->pack();

my $frame_config_events = $frame_config->Frame()->pack(-expand => 1,-fill => 'x');
$frame_config_events->Label(-text => "Mouse, Keyboard   ")->pack(-side => 'left');
my $checkbutton_keyboard_key_event = $frame_config_events->Checkbutton(-command => \&config_save,-width => 0,-variable=>\$config{keyboard_key_event})->pack(-side => 'right');
my $checkbutton_mouse_move_event   = $frame_config_events->Checkbutton(-command => \&config_save,-width => 0,-variable=>\$config{mouse_move_event})->pack(-side => 'right');
my $checkbutton_mouse_wheel_event  = $frame_config_events->Checkbutton(-command => \&config_save,-width => 0,-variable=>\$config{mouse_wheel_event})->pack(-side => 'right');
my $checkbutton_mouse_button_event = $frame_config_events->Checkbutton(-command => \&config_save,-width => 0,-variable=>\$config{mouse_button_event})->pack(-side => 'right');
$b->attach($checkbutton_keyboard_key_event,-balloonmsg => "KEYBOARD_KEY_EVENT\nEnable or disable that these events will be sent.");
$b->attach($checkbutton_mouse_move_event,-balloonmsg   => "MOUSE_MOVE_EVENT\nEnable or disable that these events will be sent.");
$b->attach($checkbutton_mouse_wheel_event,-balloonmsg  => "MOUSE_WHEEL_EVENT\nEnable or disable that these events will be sent.");
$b->attach($checkbutton_mouse_button_event,-balloonmsg => "MOUSE_BUTTON_EVENT\nEnable or disable that these events will be sent.");

my $frame_config_delay = $frame_config->Frame()->pack(-expand => 1,-fill => 'x');
$frame_config_delay->Label(-text => "Reload Delay")->pack(-side => 'left');
$frame_config_delay->Frame(-width=>8)->pack(-side => 'right');
my $spinbox_reload_delay = $frame_config_delay->Spinbox(-width           => 14,
                                                        -format          => '%0.3f',
							-increment       => 0.01,
							-from            => 0,
							-to              => 1000,
                                                        -textvariable    => \$config{reload_delay},
                                                        -validate        => 'key',
                                                        -validatecommand => sub { my ($proposed, $changes, $current, $index, $type) = @_; return not $proposed =~ m/[^\d\.]/g; },
                                                        -takefocus       => 1)->pack(-side => 'right');
$mw->bind($spinbox_reload_delay, '<KeyPress>', [\&config_save]);
$mw->bind($spinbox_reload_delay, '<ButtonRelease>', [\&config_save]);
$b->attach($spinbox_reload_delay,-balloonmsg => "You can adjust the delay between\nloads from the server window.\nA bigger delay can save CPU power,\nbut has a slow framerate as effect.\nIf the window-data is unchanged\nthe delay is longer. (delay*2)\nThe value is in milli seconds.");

my @filter_list = (
"24bit  ?ms 636-kb 16M Colors (LAN)",
"16bit  ?ms 424-kb 32K Colors",
" 8bit  ?ms 213-kb 256 Colors",
" 8bit 67ms 213-kb Color Optimized",
" 8bit  ?ms   ?-kb Color Opt. & Packed",
" 8bit 19ms 213-kb Greyscale",
" 8bit  ?ms   ?-kb Greyscale Packed",
" 4bit 19ms 106-kb 16 Colors",
" 4bit 19ms 106-kb Greyscale",
" 1bit 20ms  27-kb Threshold 20%",
" 1bit 20ms  27-kb Threshold 40%",
" 1bit 20ms  27-kb Threshold 60%",
" 1bit 20ms  27-kb Threshold 80%",
" 1bit 39ms  27-kb Dither Fs",
" 1bit 30ms  27-kb Dither Bayer4x4",
" 1bit 30ms  27-kb Dither Bayer8x8",
" 1bit 34ms  27-kb Dither Cluster6x6",
" 1bit 34ms  27-kb Dither Cluster8x8",
" 1bit 33ms  27-kb Dither Cluster16x16",
"Jpeg 249ms  94-kb Color q100",
"Jpeg 233ms  81-kb Color q099",
"Jpeg 215ms  67-kb Color q098",
"Jpeg 207ms  60-kb Color q097",
"Jpeg 199ms  54-kb Color q096",
"Jpeg 188ms  44-kb Color q094",
"Jpeg 184ms  37-kb Color q092",
"Jpeg 179ms  34-kb Color q090",
"Jpeg 167ms  23-kb Color q080",
"Jpeg 160ms  16-kb Color q060",
"Jpeg 154ms  13-kb Color q040",
"Jpeg 151ms   9-kb Color q020",
"Jpeg 144ms   7-kb Color q010",
"Jpeg 141ms   5-kb Color q005",
"Jpeg 139ms   4-kb Color q001",
"Jpeg 249ms  94-kb Greyscale q100",
"Jpeg 233ms  81-kb Greyscale q099",
"Jpeg 215ms  67-kb Greyscale q098",
"Jpeg 207ms  60-kb Greyscale q097",
"Jpeg 199ms  54-kb Greyscale q096",
"Jpeg 188ms  44-kb Greyscale q094",
"Jpeg 184ms  37-kb Greyscale q092",
"Jpeg 179ms  34-kb Greyscale q090",
"Jpeg 167ms  23-kb Greyscale q080",
"Jpeg 160ms  16-kb Greyscale q060",
"Jpeg 154ms  13-kb Greyscale q040",
"Jpeg 151ms   9-kb Greyscale q020",
"Jpeg 144ms   7-kb Greyscale q010",
"Jpeg 141ms   5-kb Greyscale q005",
"Jpeg 139ms   4-kb Greyscale q001"
);
my $frame_config_jpgquality = $frame_config->Frame()->pack(-expand => 1,-fill => 'x');
$frame_config_jpgquality->Label(-text => "Stream Quality")->pack(-side => 'left');
$frame_config_jpgquality->Frame(-width=>8)->pack(-side => 'right');
#my @jpgquality_list = ('Standard (q:75)', 'q:010 (12 kb)', 'q:020 (17 kb)', 'q:030 (21 kb)', 'q:040 (24 kb)', 'q:050 (27 kb)', 'q:060 (29 kb)', 'q:070 (33 kb)', 'q:080 (39 kb)', 'q:090 (50 kb)', 'q:091 (52 kb)', 'q:092 (53 kb)', 'q:093 (56 kb)', 'q:094 (59 kb)', 'q:095 (63 kb)', 'q:096 (69 kb)', 'q:097 (74 kb)', 'q:098 (81 kb)', 'q:099 (94 kb)', 'q:100 (104 kb)');
my $browseentry_jpgquality = $frame_config_jpgquality->BrowseEntry(-width              => 13,
                                                             -disabledbackground => 'white',
                                                             -disabledforeground => 'black',
                                                             #-readonlybackground => 'white',
                                                             -background         => 'white',
                                                             -foreground         => 'black',
                                                             -choices            => \@filter_list, #jpgquality_list,
                                                             -textvariable       => \$config{jpg_quality},
                                                             -browsecmd          => sub{$config{jpg_quality}=~s/ *[\d?]*ms *[\d?]*-kb//; &config_save; },
                                                             #-browsecmd          => \&config_save,
                                                             -state              => 'readonly',
                                                             -listwidth          => 300,
                                                             -listheight         => 20,
                                                             #-highlightcolor     => 'black',
                                                             #-highlightthickness => 1,
                                                             -takefocus          => 1,
                                                             -buttontakefocus    => 1)->pack(-side => 'right');
$browseentry_jpgquality->Subwidget('arrow')->configure(-bg => 'lightgrey',-fg => 'black');
$browseentry_jpgquality->Subwidget('slistbox')->configure(-font => 'Courier 8');
$b->attach($browseentry_jpgquality,-balloonmsg => "Quality of the images taken from the server. (Lower is faster)\nThe kilobytes are examples of the size from an image.\n(Transfered images are JPG encoded. Only the smallest\nrectangular part of a changing window will be sent to client)");

my $frame_config_openwin = $frame_config->Frame()->pack(-expand => 1,-fill => 'x');
$frame_config_openwin->Label(-text => "New Windows")->pack(-side => 'left');
$frame_config_openwin->Frame(-width=>8)->pack(-side => 'right');
my $openwin_del_button = $frame_config_openwin->Label(-text => "del",-relief => "raised",-width=>4)->pack(-side => "right");
my @ow_saved = split("\n",std::readfile("config/openwindow_rules.dat"));
$openwin_del_button->bind('<ButtonPress>' => sub{ $_[0]->configure(-relief => "sunken"); });
$openwin_del_button->bind('<ButtonRelease>' => sub{ @ow_saved = (); std::writefile("config/openwindow_rules.dat",""); $_[0]->configure(-relief => "raised"); });
$b->attach($openwin_del_button,-balloonmsg => "Delete the list of saved answers from\nthe 'remember answer' option of the popup.\nYour answers was saved in a file.\nAfter deleting this list of your choices you will\nbe asked again for every new window to open.");
#my @openwin_list = ('Open','Ask','Ignore');
my @openwin_list = ('Open All','Same App','Same PID','Same TID','Ask (Rule)','Ignore All');
my $browseentry_openwin = $frame_config_openwin->BrowseEntry(-width              => 8,
                                                             -disabledbackground => 'white',
                                                             -disabledforeground => 'black',
                                                             #-readonlybackground => 'white',
                                                             -background         => 'white',
                                                             -foreground         => 'black',
                                                             -choices            => \@openwin_list,
                                                             -textvariable       => \$config{openwin},
                                                             #-browsecmd          => sub{&confirm_mark(1)},
                                                             -browsecmd          => \&config_save,
                                                             -state              => 'readonly',
                                                             -listwidth          => 35,
                                                             -listheight         => 6,
                                                             #-highlightcolor     => 'black',
                                                             #-highlightthickness => 1,
                                                             -takefocus          => 1,
                                                             -buttontakefocus    => 1)->pack(-side => 'right');
$browseentry_openwin->Subwidget('arrow')->configure(-bg => 'lightgrey',-fg => 'black');
#$b->attach($browseentry_openwin,-balloonmsg => "What to do if a window opens on serverside ?");
$b->attach($browseentry_openwin,-balloonmsg => "If a new window is open on the server VDM can automatically establish a connection.\n\n- Open All\nEvery new window on the server will auto-open a new window on the client if there is\nminimum one client already open on clientside.\n(If you have no single client open to this server the check function is not running)\n\n- Same App (exename)\nExamples: If one calc.exe client is open and you open a second one a new client will open.\nIf notepad.exe is open and you open the save-as dialog then a client will auto-connect\nto this dialog because it has the same executable name.\n\n- Same PID / TID (ProcessID,ThreadID)\nYou can see in the yellow thumbnail-info-popup the PID and TID of a window.\nRunning processes can have the same executable name (Same APP), but they have\ndifferent Process ID'S (PID). One process can have multiple thread ID's and\nthis is often used when a process creates some toplevel-windows and you\ncan use this ID's to identify them. Example: Depending on your configuration one\nexplorer.exe process can have open some explorer-windows. They have all the same\nexename and processID but a different threadID. The drop down menues and popups\nwill have the same threadID as their toplevel explorer window. Means threadID can\nidentify different instances of explorer in one process. If you are not sure your\napplication will use the same threadID for all its drop-down-boxes, popups, windows\nthen its sometimes better to work with the processID.\n\n- Ask\nThis option is used to define rules.\nEvery window with no rule will open a popup where you can define a rule.");

# Config load and save
foreach my $line (split("\n",std::readfile('config/config_client.dat')))
{
 my ($name,$data) = split("\t",$line);
 $config{$name} = $data if ($name ne '');
}
sub config_save()
{
 std::writefile('config/config_client.dat',join("\n",map($_."\t".$config{$_},keys(%config))));
}

#-------------------------------------- Load & Save
my $labframe_loadsave = $page1->LabFrame(-label => "Load & Save",
                                         -labelside => "acrosstop")->pack(-expand => 1,-fill => 'both');
my $loadsave_frame_bottom = $labframe_loadsave->Frame()->pack(-side => 'bottom',-expand => 0,-fill => 'x');

#$labframe_loadsave->Label(-text => "Savename -> ")->pack(-side => 'left',-anchor => 'w');
my $variable_savename;
my $loadsave_entry_savename = $labframe_loadsave->Entry(-width => 10,
                                                        -textvariable => \$variable_savename)->pack(-fill => 'x');
$b->attach($loadsave_entry_savename,-balloonmsg => "Write here the Savename if needed.\nIf blank a Name will be generated. (Name\@ip:port[:uri])\n\nAll saved sessions are available as a lnk- or bat-files\nin your VDM subdirectories saved.bat and saved.lnk !\nYou can use this files to open thumbs faster. (-openthumbs)\nIt is also possible to connect to one or more server windows\nwithout using the client-interface. (-openwindow)\nIf you do this it is very important you use a good window-uri\nto ensure only the window(s) you need will open and not all.");
my $list = $labframe_loadsave->Scrolled('Listbox',
                                        -width => 25,
                                        -height => 5,
                                        -setgrid => 0,
                                        -scrollbars => 'se')->pack(-side => 'top',-expand => 1,-fill => 'both');
$list->bind('<Double-1>' => sub{ &loaddata; &connect($variable_ipport,$variable_winuri,$variable_name,$variable_password)if(&testfields); });
$list->bind('<ButtonPress-1>' => focus);
$list->focus;
$b->attach($list,-balloonmsg => "Doubleclick to load and connect to a Saved connecton.");

$loadsave_frame_bottom->Button(-text  => 'Save',
                               -width => 10,-height => 1,
                               -command => [\&savedata])->pack(-expand => 1,-side => 'left',-fill => 'x');
$loadsave_frame_bottom->Button(-text  => 'Delete',
                               -width => 10,-height => 1,
                               -command => [\&deletedata])->pack(-expand => 1,-side => 'left',-fill => 'x');
$loadsave_frame_bottom->Button(-text  => 'Load',
                               -width => 10,-height => 1,
                               -command => [\&loaddata])->pack(-expand => 1,-side => 'right',-fill => 'x');


#---- load settings.dat from disk
my %settings;
foreach my $line (split("\n",std::readfile('config/config_client_users.dat')))
{
 my ($name,$data) = split("\t",$line,2);
 $settings{$name} = $data;
}
#---- show settingnames in list subroutine
sub hash_showinlist()
{
 $list->delete(0,'end');
 $list->insert(0,sort(keys(%settings)));
}
hash_showinlist(); #show loaded keys at runtime
#---- save settings to disk subroutine
sub hash_savetodisk()
{
 std::writefile('config/config_client_users.dat',join("\n",map($_."\t".$settings{$_},keys %settings))); 
}
#---- Test Fields (add STD-Port)
sub testfields
{
 my $sammelalert = '';
 my ($ip,$port) = split(':',$variable_ipport);
 $sammelalert .= "Pleace enter 'IP:Port'.\n" if ($ip eq "");
 $variable_ipport = $ip.':5000' if ($ip ne "" && $port eq "");
 $sammelalert .= "Pleace enter 'Name'.\n" if ($variable_name eq "");
 #$sammelalert .= "Pleace enter 'Password'.\n" if ($variable_password eq "");
 if ($sammelalert ne '')
 {
  #my $dialog = $mw->Dialog(-text => $sammelalert,
  #                         -bitmap => 'info',
  #                         -font => '{courier} 8',
  #                         -title => 'Info',
  #                         -default_button => 'Ok',
  #                         -buttons => [qw/Ok/]);
  #$dialog->Icon( -image => $main_icon );
  #$dialog->Show(); # and display dialog
  my $answer = $mw->messageBox(-title   => 'Virtual Display Manager',
                               -message => $sammelalert,
                               -type    => 'Ok',
                               -icon    => 'info',
                               -default => 'Ok');
  return 0;
 }
 if ($variable_password !~ m/^KEY-/)
 {
  my $sha1 = $variable_password;
  for(1..20)
  {
   $sha1 = uc(Digest::SHA::sha1_hex($sha1));
   $variable_password = 'KEY-'.$sha1;
   $mw->update;
   Time::HiRes::sleep(0.02);
  }
 }

 return 1;
}
#---- zum erzeugen eines windows-lnk-files
sub make_lnk($$$)
{
 my ($filename,$exename,$arguments) = @_;
 my $LINK = Win32::Shortcut->new();
 $LINK->{'Path'} = $exename;
 $LINK->{'Arguments'} = $arguments;
 $LINK->Save($filename);
 $LINK->Close();
}
#---- save and delete and load subroutines
sub savedata
{
 #---- test-fields
 return if (!testfields);
 #---- make-savename
 my $savename = $variable_savename;
 $variable_savename = "";
 my ($ip,$port) = split(':',$variable_ipport);
 #$ip = '127.0.0.1' if (not defined $ip);
 #$port = '5000' if (not defined $port);
 if ($savename eq '')
 {
  $savename = $variable_name.'@'.$ip.':'.$port;
  $savename .= ":".$variable_winuri if ($variable_winuri ne "");
 }
 #---- check-savename-exists
 if (defined $settings{$savename})
 {
  #my $dialog = $mw->Dialog(-text => "Savename '$savename' already exists !\nDo you want to overwrite it ?",
  #                         -bitmap => 'question',
  #                         -font => '{courier} 8',
  #                         -title => 'Question',
  #                         -default_button => 'Yes',
  #                         -buttons => [qw/Yes No/]);
  #$dialog->Icon( -image => $main_icon );
  #my $answer = $dialog->Show(); # and display dialog
  my $answer = $mw->messageBox(-title   => 'Virtual Display Manager',
                               -message => "Savename '$savename' already exists !\nDo you want to overwrite it ?",
                               -type    => 'YesNo',
                               -icon    => 'question',
                               -default => 'Yes');
  return if ($answer eq 'No');
 }
 #write-new-entry-to-hash
 $settings{$savename} = $ip.':'.$port."\t".$variable_name."\t".$variable_password."\t".$variable_winuri."\t";
 hash_showinlist();
 hash_savetodisk();

 #---- write bat/lnk files
 my $winuri = $variable_winuri;
 $winuri =~ s/\\/\\\\/g;
 $winuri =~ s/"/\\"\\"/g;
 mkdir "../saved.bat" if (! -d "../saved.bat");
 mkdir "../saved.lnk" if (! -d "../saved.lnk");
 std::writefile("../saved.bat/-openwindow_".std::fileable_underlineall($savename).".bat","%~dp0..\\vdm_client.exe -tray_login_gui -openwindow \"$ip:$port:$variable_name:$variable_password:$winuri\"");
 std::writefile("../saved.bat/-openthumbs_".std::fileable_underlineall($savename).".bat","%~dp0..\\vdm_client.exe -openthumbs \"$ip:$port:$variable_name:$variable_password:$winuri\"");
 my $abs_file = std::rx_g(Cwd::abs_path(__FILE__),"/","\\");
 my $abs_path = substr($abs_file,0,rindex($abs_file,"\\")+1);
 make_lnk("..\\saved.lnk\\-openwindow_".std::fileable_underlineall($savename).".lnk",$abs_path."..\\vdm_client.exe","-tray_login_gui -openwindow \"$ip:$port:$variable_name:$variable_password:$winuri\"");
 make_lnk("..\\saved.lnk\\-openthumbs_".std::fileable_underlineall($savename).".lnk",$abs_path."..\\vdm_client.exe","-openthumbs \"$ip:$port:$variable_name:$variable_password:$winuri\"");

 $Label_Statusbar = "'$savename' saved !";
}
sub loaddata
{
 my $active = $list->get('active');
 return if ($active eq '');
 #$variable_savename = $active;
 ($variable_ipport,$variable_name,$variable_password,$variable_winuri) = split("\t",$settings{$active});
 $Label_Statusbar = "'$active' loaded !";
}
sub deletedata
{
 my $active = $list->get('active');
 return if ($active eq '');
 my $answer = $mw->messageBox(-title   => 'Virtual Display Manager',
                              -message => 'Really delete '.$active.' ?',
                              -type    => 'YesNo',
                              -icon    => 'question',
                              -default => 'Yes');
 return if ($answer eq 'No');
 delete $settings{$active};
 hash_showinlist();
 hash_savetodisk();
 unlink "../saved.bat/-openwindow_".std::fileable_underlineall($active).".bat";
 unlink "../saved.bat/-openthumbs_".std::fileable_underlineall($active).".bat";
 unlink "../saved.lnk/-openwindow_".std::fileable_underlineall($active).".lnk";
 unlink "../saved.lnk/-openthumbs_".std::fileable_underlineall($active).".lnk";
 $Label_Statusbar = "'$active' deleted !";
}


####################################
###################### Tray SUBS ###
sub systray_RightClick
{
    my($x, $y) = Win32::GUI::GetCursorPos();
    $main->TrackPopupMenu($systray_menu->{SystrayMenu}, $x, $y);
}
sub systray_Click
{
    $mw->state('normal');
    $mw->deiconify();#this is the real - bring on top
    #$mw->attributes(-topmost => 1);
    #$mw->attributes(-topmost => 0);
    $mw->bell();
}
sub SystrayExit_Click
{
    $mw->state('normal');

    # Prepare dialog yes|no
    #my $dialog = $mw->Dialog(-text => 'Do you really want to quit?',
    #                         -bitmap => 'question',
    #                         -font => '{arial} 8',
    #                         -title => 'Virtual Display Manager',
    #                         -default_button => 'Yes',
    #                         -buttons => [qw/Yes No/],
    #                        );
    #$main_icon = $mw->Photo( -file => "icon4.ico" );
    #$dialog->Icon( -image => $main_icon );
    #my $answer = $dialog->Show(); # and display dialog
    my $answer = $mw->messageBox(-title   => 'Virtual Display Manager',
                                 -message => 'Do you really want to quit?',
                                 -type    => 'YesNo',
                                 -icon    => 'question',
                                 -default => 'yes');
    if ($answer =~ /y/i){
        # maybe do some cleaning up and
        #Win32::GUI::NotifyIcon::Delete( $ni, -id =>  $id );
        $ni->Remove;
        $mw->destroy();
        #return -1;
    }
    else {
        # continue
    }
}

#---- Perl Console
sub ConsoleShow_Click
{
 my $hwnd = Win32::GUI::GetPerlWindow();
 if ($hwnd)
 {
  Win32::GUI::Show($hwnd);
  Win32::GUI::SetForegroundWindow($hwnd);
 }
 else
 {
  if ($AllocConsole->Call())
  {
   $SetConsoleTitle->Call("VDM: Client Console");
   open(STDOUT,">CONOUT\$");
   open(STDERR,">CONOUT\$");
   open(STDIN,"<CONIN\$");
  }
 }
}
sub ConsoleHide_Click
{
 my $hwnd = Win32::GUI::GetPerlWindow();
 Win32::GUI::Hide($hwnd) if ($hwnd);
}

#---- TK:: Window
sub WindowShow_Click
{
 $mw->state('normal');
 $mw->deiconify();#this is the real - bring on top
 #$mw->attributes(-topmost => 1);
 #$mw->attributes(-topmost => 0);
}
sub WindowHide_Click
{
 #$mw->destroy();
 $mw->state('withdraw');
}

#---- X-Button SUB
sub ExitApplication
{
 $mw->state('withdraw');
 return;

 # Prepare dialog yes|no
 my $dialog = $mw->Dialog(-text => "Das Programm komplett schliessen ?\n'Nein' drcken um es zu verkleinern.",
                          -bitmap => 'question',
                          -title => 'Quit?',
                          -font => '{courier} 8',
                          -default_button => 'Yes',
                          -buttons => [qw/Yes No/],
                         );

 my $answer = $dialog->Show(); # and display dialog
 if ($answer =~ /y/i){
     # maybe do some cleaning up and
     #exit;
     $mw->destroy();
 }
 else {
     # continue
     #$mw->state('withdraw');
     $mw->state('icon');
     #$mw->state('zoomed');
 }
}

#---- PAGE INFO
sub SystrayInfo_Click
{
 $mw->state('normal');
 $mw->deiconify();#this is the real - bring on top
 return if($nb->raise('Info'));
 my $page = $nb->add('Info',-label => 'Info');#-bitmap => 'info');
 $page_info = $page->Frame(-padx => 20,-pady => 100)->pack();
 $nb->raise('Info');
 $page_info->Button(-bg => 'gray60',-fg => 'white',-activebackground => 'gray60',-activeforeground => 'black',-relief => 'raised',-text  => 'Close',-width => 10,-command => sub{$nb->delete('Info');$nb->raise('Main');})->pack(-anchor => 'n',-side => 'top',-expand => 0,-fill => 'x');
 my $page_info_frame = $page_info->Frame(-bg => 'white',-borderwidth => 0,-padx => 20,-pady => 10)->pack(-expand => 1,-anchor => 'center');
 my $logo = $mw->Photo(-file => "./images/logo_weich.bmp");
 $page_info_frame->Label(-bg => 'white',-border => 0,-padx => 20,-pady => 0,-image => $logo)->pack();
 $page_info_frame->Label(-bg => 'white',-border => 0,-padx => 0,-pady => 0,-text => "Virtual Display Manager\nClient v".$version_info."\nDeveloped by Robert Xell.")->pack();
 my $page_info_mailframe = $page_info_frame->Frame(-bg => 'white',-border => 0,-padx => 0,-pady => 0)->pack(-anchor => 'center');
 $page_info_mailframe->Label(-bg => 'white',-border => 0,-padx => 0,-pady => 0,-text => "Email: ")->pack(-side => 'left');
 my $label_mail = $page_info_mailframe->Label(-cursor => 'trek',-bg => 'white',-border => 0,-padx => 0,-pady => 0,-font => [-underline => 1,-size => 8],-text => "xenolux\@gmail.com")->pack(-side => 'right');
 my $page_info_urlframe = $page_info_frame->Frame(-bg => 'white',-border => 0,-padx => 0,-pady => 0)->pack(-anchor => 'center');
 $page_info_urlframe->Label(-bg => 'white',-border => 0,-padx => 0,-pady => 0,-font => [-underline => 0,-size => 8],-text => "Surf to: ")->pack(-side => 'left');
 my $label_url = $page_info_urlframe->Label(-cursor => 'hand2',-bg => 'white',-border => 0,-padx => 0,-pady => 0,-font => [-underline => 1,-size => 8],-text => "http://ynea.futureware.at")->pack(-side => 'right');
 $page_info_frame->Label(-bg => 'white',-border => 0,-padx => 0,-pady => 0,-text => "Thanks to Thierry Kleine.")->pack();
 
 $mw->bind($label_mail, '<Button-1>', sub{system('start mailto:xenolux@gmail.com')});
 $mw->bind($label_url , '<Button-1>', sub{system('start http://ynea.futureware.at')});
}

#---- zum erstellen der menus im client window
my $InsertMenuItem = Win32::API->new('User32.dll','InsertMenuItem','IIIP','I');
sub menu_setdata($$)
{
 return if $_[1] eq "";
 #---- menu daten arrays de-stringifizieren
 my @datasplit   = split("#CC#",$_[1]);
 my @menu_string = map([split("#AA#",$_)],split("#BB#",$datasplit[0]));
 my @menu_data   = map([split("#AA#",$_)],split("#BB#",$datasplit[1]));

 #---- menu erstellen
 my @submenu = ($CreateMenu->Call());
 for(my $menuid=0; $menuid<=$#menu_data; $menuid++)
 {
  my $menuhandle = $submenu[$menuid];
  for(my $itempos=0; $itempos<=$#{$menu_data[$menuid]}; $itempos++)
  {
   #print "menuid: $menuid, itempos: $itempos\n";
   my $MENUITEMINFO = $menu_data[$menuid][$itempos];
   my $hSubMenu = unpack("I",substr($MENUITEMINFO,20,4));
   if ($hSubMenu)
   {
    my $submenu = $CreateMenu->Call();
    push(@submenu,$submenu);
    substr($MENUITEMINFO,20,4,pack("I",$submenu));
   }
   substr($MENUITEMINFO,36,4,pack("P",$menu_string[$menuid][$itempos]));
   $InsertMenuItem->Call($menuhandle,$itempos,1,$MENUITEMINFO);
  }
 }
 Win32::GUI::SetMenu($_[0],$submenu[0]);
}

##########################################################################
############################### Clientwindow Menu Hook Functions #########
my %sysmenu_functions = ('0001' => 'Win32::GUI::SendMessage($hwnd,'.WM_SYSCOMMAND.',0xF120,0); Time::HiRes::sleep(0.1);',
                         '0002' => 'Win32::GUI::SendMessage($hwnd,'.WM_SYSCOMMAND.',0xF020,0); Time::HiRes::sleep(0.1);',
                         '0003' => 'Win32::GUI::SendMessage($hwnd,'.WM_SYSCOMMAND.',0xF030,0); Time::HiRes::sleep(0.1);',
                         '0004' => 'Win32::GUI::Redraw($hwnd,Win32::GUI::GetClientRect($hwnd),0x0485); Time::HiRes::sleep(0.1);',
                         '0005' => 'Win32::GUI::SetWindowPos($hwnd,-1,0,0,0,0,0x0001|0x0002|0x4000); Win32::GUI::SetWindowPos($hwnd,-2,0,0,0,0,0x0001|0x0002|0x4000); Time::HiRes::sleep(0.1);',
                         '0006' => 'Win32::GUI::SendMessage($hwnd,'.WM_SYSCOMMAND.',0xF060,0); Time::HiRes::sleep(0.1);');
sub wm_syscommand_hook
{
 my $lparam = $_[0];
 #my $winid  = $_[1];
 my ($ip,$port,$hwnd) = split(':',$_[1]);
 my $login_name = $_[2];
 my $login_pass = $_[3];
 my $menuidentifier = substr(sprintf("%08x",$lparam),-4);
 if (defined $sysmenu_functions{$menuidentifier})
 {
  print "Command Sended to RemoteHWND:$hwnd.\n";
  login_slurp($ip,$port,$login_name,$login_pass,hex($mw->id),'EVAL~'.String::Interpolate::interpolate($sysmenu_functions{$menuidentifier}));
 }
}
my %sysmenu_description = ('0001' => 'Restore the Remote Window.',
                           '0002' => 'Minimize the Remote Window.',
                           '0003' => 'Maximize the Remote Window.',
                           '0004' => 'Redraw the Remote Window.',
                           '0005' => 'Brings the Remote Window to the foreground.',
                           '0006' => 'Send SC_CLOSE to the Remote Window.');
sub wm_menuselect_hook
{
 my $menuidentifier = substr(sprintf("%08x",$_[0]),-4);
 my $flags          = hex(substr(sprintf("%08x",$_[0]),0,4));
 #printf("wparam: %08x\n",$_[0]);
 my $name           = $_[1];
 my $win            = $_[2];
 if ($flags & 0x2000)
 {
  if ($menuidentifier eq '0000')
  {
   $win->Change(-title => $name);
  }
  elsif (defined $sysmenu_description{$menuidentifier})
  {
   $win->Change(-title => $sysmenu_description{$menuidentifier});
  }
 }
}

#################################################################
################################################# createwindow ##
#my %sock;
my %Win;
#my %DC;
my %icon;
#my %Thread;
my %focus_hwnd;
my %openwindow_count;
my %openwindow_list;
my %openwindow_noerror;
my %openwindow_sameexe;
my %openwindow_samepid;
my %openwindow_sametid;
sub createwindow(@)
{
 my $hwnd       = $_[1];
 my $name       = $_[2];
 my $ip         = $_[3];
 my $port       = $_[4];
 my $login_name = $_[5];
 my $login_pass = $_[6];
 my $test_exist = $_[7];
 my $winid = $ip.':'.$port.':'.$hwnd;

 #---- testen ob serverwin noch existiert
 my $ancestor;
 if (($ancestor) = login_slurp($ip,$port,$login_name,$login_pass,hex($mw->id),"GetAncestor~$hwnd~2"))
 {return &infomessbox(hex($mw->id),"Cannot open window. (probably closed)\n\nhWnd: $hwnd\nName: $name\nIp: $ip\nPort: $port") if ($test_exist && !$ancestor);} else {return;}

 #---- checken ob window schon offen
 if (defined $Win{$winid})
 {
  $Win{$winid}->OpenIcon(); # restores a minimized window
  $Win{$winid}->SetForegroundWindow();
  return;
 }

 #---- load needed data from server
 #if ((my ($multidata) = login_slurp($ip,$port,$login_name,$login_pass,hex($mw->id),"MultiCommand|Win32::GUI::GetClientRect~$hwnd|Win32::GUI::GetWindowLong~$hwnd~-16|Win32::GUI::GetWindowLong~$hwnd~-20")) &&
 if ((my ($multidata) = login_slurp($ip,$port,$login_name,$login_pass,hex($mw->id),"MultiCommand|Win32::GUI::GetClientRect~$hwnd|Win32::GUI::GetWindowLong~$hwnd~-16|Win32::GUI::GetWindowLong~$hwnd~-20|CalcRelWinPos~$hwnd~".join(",",map {my $classname = Win32::GUI::GetClassName($_); $_."/".substr($classname,rindex($classname,":")+1);} grep(Win32::GuiTest::IsWindowVisible($_) && (index(Win32::GUI::GetClassName($_),"VDM_Client_".$ip.":".$port.":") == 0),Win32::GuiTest::GetChildWindows(0)))."|Win32::GUI::GetWindowThreadProcessId~$hwnd|GetWindowFileName~$hwnd|Win32::GUI::GetClassName~$hwnd")) &&
     (my ($menu_data) = login_slurp($ip,$port,$login_name,$login_pass,hex($mw->id),"menu_getdata~$hwnd")))# this tests onlinestate too
 {
  my ($win00XY,$style,$exstyle,$relwinpos,$threadprocessID,$exename,$classname) = split(/\|/,$multidata);
  my ($winX,$winY) = (split("~",$win00XY))[2,3];
  my ($threadID,$processID) = split("~",$threadprocessID);

  #---- Window-Style ermitteln
  my $client_style = 0x00000000; #info: -x1:visible_off_for_later_animate
  my $client_exstyle = 0x00000000;
  if ($exename =~ m/\\explorer\.exe$/ && ($classname eq "Shell_TrayWnd" || $classname eq "Progman"))
  {
   $client_style   = 0x00C80000; # C:thin-border,titlebar 8:sysmenu(showX)
   $client_exstyle = 0x00000080; # toolwindow(small-titlebar)
   $client_exstyle &= 0x00040000; # ex_appwindow: force toolwin and owned-wins on taskbar
  }
  else
  {
   $client_style |= ($style & 0x00C00000); # thin-border & titlebar
   $client_style |= ($style & 0x00300000); # scrollbar h&v
   $client_style |= ($style & 0x00040000); # sizing-border
   $client_style |= ($style & 0x00030000); # minimize-maximize box
   $client_style |= ($style & 0x00080000); # ws_sysmenu: window-control-buttons on titlebar y/n
   $client_style |= ($style & 0x80000000); # ws_popup: needed to supress titlebar for ?
   $client_style |= 0x80000000 if ($style & 0x40000000); # ws_child to ws_popup: because child raises error .. used to remove titlebar / tested in explorer adressbar-dropdown
   #$client_exstyle |= ($exstyle & 0x00000001); # ws_ex_dlgmodalframe: i use it to remove black border on rightclickmenues / damn does not work if i force logo to taskbar
   $client_exstyle |= ($exstyle & 0x00000080); # ex_toolwindow: TaskListThumbnailWnd will close after autoopen if not defined because a new taskbarentry is added / dont work because i force it on taskbar later, but i leave it for the small titlebar
   #$client_exstyle |= ($exstyle & 0x00000020); # ex_transparent: needed when a window has a other window as overlay for input but not visible (not seen yet) .. this is because i cannot supress such windows global .. ex: taskbaroverlaywnd / does not work because of the window updater .. flickers .. outcommented and blocked in server 4openwindow function.
   $client_exstyle &= 0x00040000; # ex_appwindow: force toolwin and owned-wins on taskbar
  }
  #return if ($classname eq "TaskListOverlayWnd");
  #return if ($classname eq "TaskListThumbnailWnd");
  print "Create Client: $hwnd, $classname\n";

  #---- Create Window
  #my $myclass = new Win32::GUI::Class(-name=>'VDM_Client_'.$hwnd);  
  my $myclass = new Win32::GUI::Class(-name=>'VDM_Client_'.$winid);  
  $Win{$winid} = new Win32::GUI::Window (-pos         => [100, 100],
                                         -size        => [330, 235],
                                         -name        => "Window_$hwnd",
                                         -text        => $name,
                                         -class       => $myclass,
                                         ($ancestor == $hwnd)?(
                                         -popstyle       => ~0,
                                         -popexstyle     => ~0,
                                         -pushstyle       => $client_style,
                                         -pushexstyle     => $client_exstyle):(),
                                         #-pushstyle       => $style & ~0x10000000 | 0x00000000, #-x1:vis_off_for_later_animate
                                         #-pushexstyle     => $exstyle & ~0x00000000 | 0x00040000):(),
                                         #-popstyle    => 0x00840000,
                                         #-pushstyle   => 0x80000000,
                                         #-noflicker   => 1,
                                         #NEM Events for this window
                                         #-onTimer     => \&windowupdater,
                                         #-onTerminate => sub {&WindowTerminate($winid,$login_name,$login_pass);},
                                         #-onMouseDown => sub {&Generic_MouseDown($winid,$_[1],$_[2],$_[3],$login_name,$login_pass);},
                                         #-onMouseUp   => sub {&Generic_MouseUp($winid,$_[1],$_[2],$_[3],$login_name,$login_pass);},
                                         #-onKeyDown   => sub {&Generic_KeyDown($winid,$_[1],$_[2],$login_name,$login_pass) if ($config{keyboard_key_event});},
                                         #-onKeyUp     => sub {&Generic_KeyUp($winid,$_[1],$_[2],$login_name,$login_pass) if ($config{keyboard_key_event});},
                                         #-onMouseMove => sub {&Generic_MouseMove($winid,$_[1],$_[2],$_[3],$login_name,$login_pass);},
                                        );
  unless (defined $Win{$winid}) {&infomessbox(hex($mw->id),"Cannot create window ... internal problem !"); return;}
  $Win{$winid}->Hook(0x0010, sub{&WindowTerminate($winid,$login_name,$login_pass,$exename,$threadID,$processID);}); #WM_CLOSE
  my $KeyEvent_AnonSub   = sub{&Window_KeyEvent($winid,$_[4],$_[1],$_[2],$login_name,$login_pass);};
  $Win{$winid}->Hook(0x0100, $KeyEvent_AnonSub) if ($config{keyboard_key_event}); #WM_KEYDOWN
  $Win{$winid}->Hook(0x0101, $KeyEvent_AnonSub) if ($config{keyboard_key_event}); #WM_KEYUP
  $Win{$winid}->Hook(0x0104, $KeyEvent_AnonSub) if ($config{keyboard_key_event}); #WM_SYSKEYDOWN (alt-?)
  $Win{$winid}->Hook(0x0105, $KeyEvent_AnonSub) if ($config{keyboard_key_event}); #WM_SYSKEYUP (alt-?)
  #$Win{$winid}->Hook(0x0102, $KeyEvent_AnonSub) if ($config{keyboard_key_event}); #WM_CHAR
  my $MouseEvent_AnonSub = sub{&Window_MouseEvent($winid,$_[4],$_[1],$_[2],$login_name,$login_pass);};
  $Win{$winid}->Hook(0x0200, $MouseEvent_AnonSub) if ($config{mouse_move_event});  #WM_MOUSEMOVE
  $Win{$winid}->Hook(0x0201, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_LBUTTONDOWN
  $Win{$winid}->Hook(0x0202, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_LBUTTONUP
  $Win{$winid}->Hook(0x0203, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_LBUTTONDBLCLK
  $Win{$winid}->Hook(0x0204, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_RBUTTONDOWN
  $Win{$winid}->Hook(0x0205, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_RBUTTONUP
  $Win{$winid}->Hook(0x0206, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_RBUTTONDBLCLK
  $Win{$winid}->Hook(0x0207, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_MBUTTONDOWN
  $Win{$winid}->Hook(0x0208, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_MBUTTONUP
  $Win{$winid}->Hook(0x0209, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_MBUTTONDBLCLK
  $Win{$winid}->Hook(0x020B, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_XBUTTONDOWN
  $Win{$winid}->Hook(0x020C, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_XBUTTONUP
  $Win{$winid}->Hook(0x020D, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_XBUTTONDBLCLK
  $Win{$winid}->Hook(0x020A, $MouseEvent_AnonSub) if ($config{mouse_wheel_event}); #WM_MOUSEWHEEL
  $Win{$winid}->Hook(0x111, sub{printf("1:%04x, 2:%04x\n",$_[1],$_[2]); login_slurp($ip,$port,$login_name,$login_pass,$Win{$winid}->{'-handle'},'Win32::GUI::PostMessage~'.$hwnd.'~'.0x111.'~'.$_[1].'~'.$_[2])}); #WM_COMMAND (for menubar)
  #$Win{$winid}->Hook(0x112, sub{printf("syscommand/  1:%04x, 2:%04x\n",$_[1],$_[2]); login_slurp($ip,$port,$login_name,$login_pass,$Win{$winid}->{'-handle'},'PostMessage~'.$hwnd.'~'.0x112.'~'.$_[1].'~'.$_[2])}); #WM_SYSCOMMAND

  #---- zum ermoeglichen das das fenster grsser als der schirm werden kann
  $Win{$winid}->Hook(0x0024, sub{if ($movsd) {$movsd->Call($_[2]+32,10000); $movsd->Call($_[2]+36,10000);}});#WM_GETMINMAXINFO

  #---- SystemMenu Extension
  my %SysMenu_hash = ('1' => 'Restore (Serverside)~images/restore.bmp',
                      '2' => 'Minimize~images/minimize.bmp',
                      '3' => 'Maximize~images/maximize.bmp',
                      '4' => 'Redraw~images/redraw.bmp',
                      '5' => 'SetForeground',
                      '6' => 'Close~images/close.bmp');
  my $SysMenu = Win32::GuiTest::GetSystemMenu($Win{$winid}->{'-handle'},FALSE);
  my $SM_CXMENUCHECK = $GetSystemMetrics->Call(71);
  my $SM_CYMENUCHECK = $GetSystemMetrics->Call(72);
  my $menucount = 0;
  foreach my $clickid (sort(keys(%SysMenu_hash)))
  {
   my ($name,$file) = split('~',$SysMenu_hash{$clickid});
   $InsertMenu->Call($SysMenu,
                     $menucount,
                     0x0400,
                     $clickid,
                     $name);
   if (defined $file)
   {
    my $img_hwnd = $LoadImage->Call(0,$file,0,$SM_CXMENUCHECK,$SM_CYMENUCHECK,0x010);
    $SetMenuItemBitmaps->Call($SysMenu,$menucount,0x0400,$img_hwnd,0);
   }
   $menucount++;
  }
  $InsertMenu->Call($SysMenu,$menucount,0x0400|0x0800,0,0);
  $Win{$winid}->Hook(0x011F, sub{&wm_menuselect_hook($_[1],$name,$_[0]); return @_;});#=WM_MENUSELECT
  $Win{$winid}->Hook(WM_SYSCOMMAND, sub{&wm_syscommand_hook($_[1],$winid,$login_name,$login_pass); return 1;});
  #$Win{$winid}->Hook(0x011F, \&menuselect);

  #---- load menubardata from the server and hang it on the client
  menu_setdata($Win{$winid}->{'-handle'},$menu_data);

  #---- nonClient_size_wh
  my $nonclient_w = $Win{$winid}->Width - $Win{$winid}->ScaleWidth;
  my $nonclient_h = $Win{$winid}->Height - $Win{$winid}->ScaleHeight;

  #---- nonClient_size_tl
  my ($win_X,$win_Y) = (Win32::GUI::GetWindowRect($Win{$winid}->{'-handle'}))[0,1];
  my ($client_X,$client_Y) = Win32::GUI::ClientToScreen($Win{$winid}->{'-handle'},0,0);
  my $nonclient_l = $client_X - $win_X;
  my $nonclient_t = $client_Y - $win_Y;

  #---- relwinpos: ermitteln von XY pos fuer parent-window-display
  my ($parent_client_hwnd,$diff_X,$diff_Y) = split("~",$relwinpos);
  if ($parent_client_hwnd != 0)# && $ancestor != $hwnd)
  {
   #---- center-size non-root windows if parent-client != 0 
   my ($parent_client_X,$parent_client_Y) = Win32::GUI::ClientToScreen($parent_client_hwnd,0,0);
   my ($posX,$posY) = ($parent_client_X+$diff_X-$nonclient_l,$parent_client_Y+$diff_Y-$nonclient_t);
   my ($dl,$dt,$dr,$db) = getdisplayfromwindow($parent_client_hwnd);
   $posX = $dr-$winX-$nonclient_w if ($dr < $posX+$winX+$nonclient_w);
   $posY = $db-$winY-$nonclient_h if ($db < $posY+$winY+$nonclient_h);
   $posX = $dl if ($dl > $posX);
   $posY = $dt if ($dt > $posY);
   $Win{$winid}->SetWindowPos(0,$posX,$posY,$winX+$nonclient_w,$winY+$nonclient_h,0x614) if ($winX != 0 && $winY != 0);
  }
  else
  {
   #---- center-size all new windows
   #$Win{$winid}->Resize($winX+$nonclient_w,$winY+$nonclient_h);
   $Win{$winid}->SetWindowPos(0,getdisplaycenterpos($winX+$nonclient_w,$winY+$nonclient_h),$winX+$nonclient_w,$winY+$nonclient_h,0x614) if ($winX != 0 && $winY != 0);
  }

  #---- Show Window
  #$Win{$winid}->Show();
  $Win{$winid}->Animate(
                        -show => 1,
                        -activate => 1,
                        -animation => 'blend',
                        #-animation => 'center',
                        #-direction => '',
                        -time => 200,
                       );

  #---- Create Windowupdater Thread
  my $jpgquality = ($config{jpg_quality} =~ m/q:(\d+)/)? $1: 75;
  #$Thread{$winid} = threads->create('windowupdater_threaded',$winid,$Win{$winid}->{'-handle'},$nonclient_w,$nonclient_h,$winX,$winY,$login_name,$login_pass);
  #system('perl\bin\vdm.exe client_loader.pl "'.$winid.'" "'.$Win{$winid}->{'-handle'}.'" "'.$nonclient_w.'" "'.$nonclient_h.'" "'.$winX.'" "'.$winY.'" "'.$login_name.'" "'.$login_pass.'" "'.$config{reload_delay}.'"');
  Win32::Process::Create($ProcessObj,
                         'perl\bin\vdm_client.exe',
                         'vdm_client.exe client_loader.pl "'.$winid.'" "'.$Win{$winid}->{'-handle'}.'" "'.$nonclient_w.'" "'.$nonclient_h.'" "'.$winX.'" "'.$winY.'" "'.$login_name.'" "'.$login_pass.'" "'.$config{reload_delay}.'" "'.$jpgquality.'"',
                         0,
                         (Win32::GUI::GetPerlWindow())?NORMAL_PRIORITY_CLASS:DETACHED_PROCESS|NORMAL_PRIORITY_CLASS,
                         '.') || &infomessbox(hex($mw->id),"Can't start client_loader process.\nError: ".Win32::FormatMessage(Win32::GetLastError()));

  #---- Icon Loading
  if (my $icon_data = login_slurp($ip,$port,$login_name,$login_pass,hex($mw->id),"myDrawIcon~$hwnd"))
  {
   std::writefile_binmode("images/remoteicon.ico",$icon_data);
   $icon{$winid} = new Win32::GUI::Icon("images/remoteicon.ico");
   $Win{$winid}->ChangeIcon($icon{$winid});
  }

  #---- openwindow count add to start ow system and first load of winlist
  $openwindow_list{join("\t",$ip,$port,$login_name,$login_pass)} = join("\t",sort map {substr($_,0,index($_,':'))} split("\t",login_slurp($ip,$port,$login_name,$login_pass,hex($mw->id),'GETCHILDWINDOWS_4OPENWINDOW~0'))) if (++$openwindow_count{join("\t",$ip,$port,$login_name,$login_pass)} == 1);
  $openwindow_noerror{join("\t",$ip,$port,$login_name,$login_pass)} = 1;
  $openwindow_sameexe{join("\t",$ip,$port,$exename)}++;
  $openwindow_samepid{join("\t",$ip,$port,$processID)}++;
  $openwindow_sametid{join("\t",$ip,$port,$threadID)}++;
 }
 #else { delete $Win{$winid}; } # um zu erkennen ob fenster noch offen! (info: das schliessen des handels schliesst auch das fenster)
}
sub createdesktop($$$$$$$$$)
{
 my ($displayname,$l,$t,$r,$b,$ip,$port,$login_name,$login_pass) = @_;
 my $winid = $ip.':'.$port.':'.$displayname;

 #---- checken ob window schon offen
 if (defined $Win{$winid})
 {
  $Win{$winid}->OpenIcon(); # restores a minimized window
  $Win{$winid}->SetForegroundWindow();
  return;
 }

 #---- Create Window
 my $myclass = new Win32::GUI::Class(-name=>'VDM_Client_'.$winid);  
 $Win{$winid} = new Win32::GUI::Window (-pos         => [100, 100],
                                        #-size        => [$r-$l,$b-$t],
                                        -name        => "Window_$winid",
                                        -text        => $displayname,
                                        -class       => $myclass,
                                        #-noflicker   => 1,
                                        -onTerminate => sub {return 1;}, # needed in Tk loop
                                       );
 unless (defined $Win{$winid}) {&infomessbox(hex($mw->id),"Cannot create window ... internal problem !"); return;}

 #---- resize client area (-size only uses windowsize)
 #$Win{$winid}->Resize($Win{$winid}->Width-$Win{$winid}->ScaleWidth+$r-$l,$Win{$winid}->Height-$Win{$winid}->ScaleHeight+$b-$t);
 my ($x,$y) = ($Win{$winid}->Width-$Win{$winid}->ScaleWidth+$r-$l,$Win{$winid}->Height-$Win{$winid}->ScaleHeight+$b-$t);
 $Win{$winid}->SetWindowPos(0,getdisplaycenterpos($x/2,$y/2),$x/2,$y/2,0x604);

 #---- Hooks
 $Win{$winid}->Hook(0x0010, sub{delete $Win{$winid}; return 1;}); #WM_CLOSE
 my $KeyEvent_AnonSub   = sub{&Desktop_KeyEvent($winid,$_[4],$_[1],$_[2],$login_name,$login_pass);};
 $Win{$winid}->Hook(0x0100, $KeyEvent_AnonSub) if ($config{keyboard_key_event}); #WM_KEYDOWN
 $Win{$winid}->Hook(0x0101, $KeyEvent_AnonSub) if ($config{keyboard_key_event}); #WM_KEYUP
 $Win{$winid}->Hook(0x0104, $KeyEvent_AnonSub) if ($config{keyboard_key_event}); #WM_SYSKEYDOWN (alt-?)
 $Win{$winid}->Hook(0x0105, $KeyEvent_AnonSub) if ($config{keyboard_key_event}); #WM_SYSKEYUP (alt-?)
 my $MouseEvent_AnonSub = sub{&Desktop_MouseEvent($winid,$_[4],$_[1],$_[2],$l,$t,$r,$b,$login_name,$login_pass);};
 $Win{$winid}->Hook(0x0200, $MouseEvent_AnonSub) if ($config{mouse_move_event});  #WM_MOUSEMOVE
 $Win{$winid}->Hook(0x0201, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_LBUTTONDOWN
 $Win{$winid}->Hook(0x0202, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_LBUTTONUP
 #$Win{$winid}->Hook(0x0203, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_LBUTTONDBLCLK
 $Win{$winid}->Hook(0x0204, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_RBUTTONDOWN
 $Win{$winid}->Hook(0x0205, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_RBUTTONUP
 #$Win{$winid}->Hook(0x0206, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_RBUTTONDBLCLK
 $Win{$winid}->Hook(0x0207, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_MBUTTONDOWN
 $Win{$winid}->Hook(0x0208, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_MBUTTONUP
 #$Win{$winid}->Hook(0x0209, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_MBUTTONDBLCLK
 #$Win{$winid}->Hook(0x020B, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_XBUTTONDOWN
 #$Win{$winid}->Hook(0x020C, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_XBUTTONUP
 #$Win{$winid}->Hook(0x020D, $MouseEvent_AnonSub) if ($config{mouse_button_event});#WM_XBUTTONDBLCLK
 $Win{$winid}->Hook(0x020A, $MouseEvent_AnonSub) if ($config{mouse_wheel_event}); #WM_MOUSEWHEEL

 #---- Show Window
 #$Win{$winid}->Show();
 $Win{$winid}->Animate(
                       -show => 1,
                       -activate => 1,
                       #-animation => 'blend',
                       -animation => 'center',
                       #-direction => '',
                       -time => 300,
                      );

 #---- Create Windowupdater Thread
 #my $jpgquality = ($config{jpg_quality} =~ m/q:(\d+)/)? $1: 75;
 Win32::Process::Create($ProcessObj,
                        'perl\bin\perl.exe',
                        'vdm_client.exe display_loader.pl "'.$Win{$winid}->{'-handle'}.'" "'.$ip.'" "'.$port.'" "'.$login_name.'" "'.$login_pass.'" "'.$l.'" "'.$t.'" "'.$r.'" "'.$b.'" "'.$config{reload_delay}.'" "'.$config{jpg_quality}.'"',
                        0,
                        (Win32::GUI::GetPerlWindow())?NORMAL_PRIORITY_CLASS:DETACHED_PROCESS|NORMAL_PRIORITY_CLASS,
                        '.') || &infomessbox(hex($mw->id),"Can't start client_loader process.\nError: ".Win32::FormatMessage(Win32::GetLastError()));

 #---- Icon Loading
 $Win{$winid}->ChangeIcon(new Win32::GUI::Icon("images/Flip_client.ico"));
}
#sub windowupdater_threaded($)
#{
# my $winid            = $_[0];
# my $client_hwnd      = $_[1];
# my $nonclient_w      = $_[2];
# my $nonclient_h      = $_[3];
# my $olddib_w         = $_[4];
# my $olddib_h         = $_[5];
# my $login_name       = $_[6];
# my $login_pass       = $_[7];
# my ($ip,$port,$hwnd) = split(':',$winid);
# my ($oldwin_w,$oldwin_h) = ($olddib_w,$olddib_h);
#
# delete $sockhash{$ip.':'.$port};
# my $bmpcache;
# while(my $DC = Win32::GUI::DC::GetDC($client_hwnd))
# {print "okx-$DC\n";
#  if(substr(sprintf("%08x",Win32::GUI::GetWindowLong($client_hwnd,-16)),0,1) == 1)#is_visible
#  {
#   if (login_slurp($ip,$port,$login_name,$login_pass,"SHOOTWINDOW~$hwnd") =~ m/^([0123])~(\d+)~(\d+)~(.+)/s)
#   {
#print "SHOOTED:$1~$2~$3~length(".length($4).")\n";
#    #---- Make Jpeg
#    my $bmpdata = Win32::GUI::DIBitmap->newFromData($4)->SaveToData(FIF_BMP) if ($1 != 1);
#    #my $bmpdata;
#    #if ($1 != 1)#when not 'not changed'
#    #{
#    # my %opts = (binmode_stdin=>1,binmode_stdout=>1);
#    # my $h = run3 './bin/libjpeg/djpeg.exe -bmp', \$4, \$bmpdata, \%opts;
#    # #$bmpdata = Compress::Zlib::compress($bmpdata);
#    #}
#
##std::writefile_binmode('test1.bmp',$4);
##std::writefile_binmode('test2.bmp',$bmpdata);
##exit if ($1 == 2);
#
#    if ($1 == 2)#partially changed
#    {
#     #---------------------------- bmpfusion
#     my ($bmpcache_x,$bmpcache_y) = unpack('I2',substr($bmpcache,18,8));
#     my ($bmpdata_x,$bmpdata_y) = unpack('I2',substr($bmpdata,18,8));
#     my $bmpdata_x_mal3 = $bmpdata_x*3;
#     my $bmpcache_datenbreitex_plusbugbit = $bmpcache_x*3+$bmpcache_x-int($bmpcache_x/4)*4;
#     my $bmpdata_datenbreitex_plusbugbit = $bmpdata_x*3+$bmpdata_x-int($bmpdata_x/4)*4;
#
#     my $bmpcache_ptr = unpack('I',pack('P',$bmpcache));
#     my $bmpdata_ptr = unpack('I',pack('P',$bmpdata));
#     my $bmpcache_startptr= $bmpcache_ptr+54+$bmpcache_datenbreitex_plusbugbit*($bmpcache_y-$bmpdata_y-$3)+$2*3;
##print "$bmpcache_ptr+54+$bmpcache_datenbreitex_plusbugbit*($bmpcache_y-$bmpdata_y-$3)+$2*3;\n";
#print "bmpdata_len:".length($bmpdata).", bmpcache_len:".length($bmpcache)."\n";
#
##exit;
#     my $bmpdata_startptr = $bmpdata_ptr+54;
#     $rep_movsb_repeated->Call($bmpdata_startptr,$bmpcache_startptr,$bmpdata_x_mal3,$bmpdata_datenbreitex_plusbugbit,$bmpcache_datenbreitex_plusbugbit,$bmpdata_y);
#    }
#    else
#    {
#     $bmpcache = $bmpdata if ($1 != 1);#when not 'not changed'
#    }
#
#    #---- make dib
#    my $dib = Win32::GUI::DIBitmap->newFromData($bmpcache);
#    my ($dib_w,$dib_h) = ($dib->GetWidth(),$dib->GetHeight());
#    #print "dib:$dib\n";
#    my $copyed = $dib->CopyToDC($DC) if ($dib);
#    #print "copyed:$copyed\n";
#    if ($dib_w != $olddib_w || $dib_h != $olddib_h)
#    {
#     print "Resize to: ".$dib_w.",".$dib_h."\n";
#     Win32::GUI::Resize($client_hwnd,$dib_w+$nonclient_w,$dib_h+$nonclient_h);
#     ($olddib_w,$olddib_h) = ($dib_w,$dib_h);
#     ($oldwin_w,$oldwin_h) = ($dib_w,$dib_h);
#    }
#    last if (Win32::GUI::GetWindowLong($client_hwnd,-16) == 0);
#    my ($win_w,$win_h) = ($Win{$winid}->ScaleWidth,$Win{$winid}->ScaleHeight);
#    if ($win_w != $oldwin_w || $win_h != $oldwin_h)
#    {
#     print "Resize_Remote to: ".$win_w.",".$win_h."\n";
#     login_slurp($ip,$port,$login_name,$login_pass,'EVAL~Win32::GUI::Resize('.$hwnd.','.$win_w.','.$win_h.');');
#     ($olddib_w,$olddib_h) = ($win_w,$win_h);
#     ($oldwin_w,$oldwin_h) = ($win_w,$win_h);
#    }
#    undef $dib;
#   }
#  }
#  my $released = Win32::GUI::DC::ReleaseDC($client_hwnd,$DC);
#  Time::HiRes::sleep(0.01);
# }
# undef $bmpcache;
# $sockhash{$ip.':'.$port}->close;
# #undef $rawcache;
# #threads->exit();
# #threads->detach();
# print "window_killed\n";
#}
#sub windowupdater($$)
#{
# my $winid = $_[1];
# my ($ip,$port,$hwnd) = split(':',$winid);
#
# print "okx_nowslurp_$hwnd\n";
# #$sock{$winid} = getsock($ip,$port);
# if (my $img_data = tcp_slurp($ip,$port,"SHOOTWINDOW~$hwnd"))
# {
#  print "okx_nowslurped_$hwnd\n";
#  $Win{$winid}->Update;
#  #my $DC = $Win{$winid}->GetDC;
#  my $dib = Win32::GUI::DIBitmap->newFromData($img_data);
#  $dib->CopyToDC($DC{$winid}) if ($dib);
#  undef $dib;
# }
# #close $sock{$winid};
#}

#==== WindowTerminate
sub WindowTerminate()
{
 my $winid      = $_[0];
 my $login_name = $_[1];
 my $login_pass = $_[2];
 my $exename    = $_[3];
 my $threadID   = $_[4];
 my $processID  = $_[5];
 my ($ip,$port,$hwnd) = split(':',$winid);
 #my $return = $DeleteDC->Call($DC{$winid});
 #close $sock{$winid};
 #$thr{$winid}->kill('SIGUSR1');
 delete $focus_hwnd{$winid};
 #$Win{$winid}->Animate(
 #                      -show => 0,
 #                      -activate => 1,
 #                      #-animation => 'blend',
 #                      -animation => 'center',
 #                      #-direction => '',
 #                      -time => 300,
 #                     );
 delete $Win{$winid}; # um zu erkennen ob fenster noch offen
 if (--$openwindow_count{join("\t",$ip,$port,$login_name,$login_pass)} == 0) #ow loop stoppen
 {
  delete $openwindow_count{join("\t",$ip,$port,$login_name,$login_pass)}; 
  delete $openwindow_list{join("\t",$ip,$port,$login_name,$login_pass)};
  delete $openwindow_noerror{join("\t",$ip,$port,$login_name,$login_pass)};
 }
 delete $openwindow_sameexe{join("\t",$ip,$port,$exename)} if (--$openwindow_sameexe{join("\t",$ip,$port,$exename)} == 0);
 delete $openwindow_samepid{join("\t",$ip,$port,$processID)} if (--$openwindow_samepid{join("\t",$ip,$port,$processID)} == 0);
 delete $openwindow_sametid{join("\t",$ip,$port,$threadID)} if (--$openwindow_sametid{join("\t",$ip,$port,$threadID)} == 0);
 #tcp_slurp($ip,$port,"EVAL~Win32::GUI::Redraw($hwnd,Win32::GUI::GetClientRect($hwnd),0x0085);");
 #login_slurp($ip,$port,$login_name,$login_pass,'EVAL~my $ancestor = $GetAncestor->Call('.$hwnd.',2); Win32::GUI::SetWindowLong($ancestor,-20,$ancestors_layered{$ancestor}); delete $ancestors_layered{$ancestor};');
 return 1;
}

#==== Generic Mouse and Key Senders
#my %oem_hash; $oem_hash{$_} = 1 for (0x8,0x9,0xd,0x1b,0x20,0x30 .. 0x39,0x41 .. 0x5a,0x60 .. 0x6f,0xba .. 0xc0,0xdb .. 0xdf,0xe2);
sub Window_KeyEvent()
{
 my ($winid,$event,$keycode,$flags,$login_name,$login_pass)=@_;
 my ($ip,$port,$hwnd) = split(':',$winid);
 #return if (($event == 0x100 && defined $oem_hash{$keycode}) || not(defined $focus_hwnd{$winid}) || $focus_hwnd{$winid} eq '');
 #return if (not(defined $focus_hwnd{$winid}) || $focus_hwnd{$winid} eq '');
 printf("KeyEvent( msgcode:0x%04x, key:0x%02x, flags:0x%08x)-> focus_hwnd:".$focus_hwnd{$winid}."\n",$event,$keycode,$flags);
 my $kb_state; vec($kb_state,255,8)=0; $GetKeyboardState->Call($kb_state);
 login_slurp($ip,$port,$login_name,$login_pass,$Win{$winid}->{'-handle'},'INPUT_EVENT~1~'.join("~",$hwnd,$focus_hwnd{$winid},$event,$keycode,$flags,$kb_state));
 #login_slurp($ip,$port,$login_name,$login_pass,$Win{$winid}->{'-handle'},
 #'EVAL~
 #my $hwnd = '.$hwnd.';
 #my $hwnd_mousefocus = "'.$focus_hwnd{$winid}.'"; # die " entfernen
 #my $event = "'.$event.'";
 #my $keycode = "'.$keycode.'";
 #my $flags = '.$flags.';
 #my $kb_state = "'.$kb_state.'";
 #if (Win32::GUI::GetClassName($hwnd) eq "ConsoleWindowClass")
 #{
 # return if ($keycode == 0x10 || $keycode == 0x11 || $keycode == 0x12);
 # my @sammelkeys = grep(ord(substr($kb_state,$_,1)) & 128,0x10,0x11,0x12);
 # $keybd_event->Call($_,0,0,0) foreach (@sammelkeys);
 # Time::HiRes::sleep(0.05);
 # Win32::GUI::PostMessage($hwnd_mousefocus,$event,$keycode,$flags);
 # Time::HiRes::sleep(0.05);
 # $keybd_event->Call($_,0,2,0) foreach (@sammelkeys);
 #}
 #else
 #{
 # my $threadID = $GetCurrentThreadId->Call();
 # my $threadIDwin = (Win32::GUI::GetWindowThreadProcessId($hwnd_mousefocus || $hwnd))[0];
 # Win32::GUI::AttachThreadInput($threadID,$threadIDwin,1);
 # $SetKeyboardState->Call($kb_state);
 # my $kb_focus = Win32::GUI::GetFocus();
 # unless ($kb_focus) { Win32::GUI::SetFocus($hwnd_mousefocus); $kb_focus = $hwnd_mousefocus; } # fuer fenster die nicht bei mausklick selber den focus setzten
 # Win32::GUI::PostMessage($kb_focus,$event,$keycode,$flags);
 # Time::HiRes::sleep(0.05);
 # Win32::GUI::AttachThreadInput($threadID,$threadIDwin,0);
 #}
 #');
 undef $kb_state;
}
sub Window_MouseEvent()
{
 my ($winid,$event,$flags,$paramXY,$login_name,$login_pass)=@_;
 my ($ip,$port,$hwnd) = split(':',$winid);
 my $ycor = int($paramXY/0x10000);
 my $xcor = $paramXY-$ycor*0x10000;
 if ($event == 0x020A) {my ($cleft,$ctop) = $Win{$winid}->GetAbsClientRect; $xcor -= $cleft; $ycor -= $ctop;} #zum korregieren der abweichenden mausrad screen coordinaten auf clientcoords
 #print "MouseEvent(x:$xcor,y:$ycor,flags:$flags) hwnd:$hwnd event:$event\n";
 my $retval = login_slurp($ip,$port,$login_name,$login_pass,$Win{$winid}->{'-handle'},'SendMouseDown~'.$hwnd.'~'.$event.'~'.$xcor.'~'.$ycor.'~'.$flags.'~0');
 $focus_hwnd{$winid} = $retval if ($event == 0x0201);
}
sub Desktop_KeyEvent()
{
 my ($winid,$event,$keycode,$flags,$login_name,$login_pass)=@_;
 my ($ip,$port,$hwnd) = split(':',$winid);
 printf("KeyEvent( msgcode:0x%04x, key:0x%02x, flags:0x%08x)-> focus_hwnd:".$focus_hwnd{$winid}."\n",$event,$keycode,$flags);
 #login_slurp($ip,$port,$login_name,$login_pass,$Win{$winid}->{'-handle'},'EVAL~Win32::GUI::PostMessage('.$focus_hwnd{$winid}.','.$event.','.$keycode.','.$flags.');');
 login_slurp($ip,$port,$login_name,$login_pass,$Win{$winid}->{'-handle'},'INPUT_EVENT~2~'.join("~",$event,$keycode,$flags));
 #login_slurp($ip,$port,$login_name,$login_pass,$Win{$winid}->{'-handle'},
 #'EVAL~
 #my $event = "'.$event.'";
 #my $keycode = "'.$keycode.'";
 #$keybd_event->Call($keycode,0,($event == 0x100)?0:2,0);
 #');
}
sub Desktop_MouseEvent()
{
 my ($winid,$event,$flags,$paramXY,$l,$t,$r,$b,$login_name,$login_pass)=@_;
 my ($ip,$port,$hwnd) = split(':',$winid);
 my ($cleft,$ctop,$cright,$cbottom) = $Win{$winid}->GetAbsClientRect;
 my $ycor = int($paramXY/0x10000);
 my $xcor = $paramXY-$ycor*0x10000;
 if ($event == 0x020A) {$xcor -= $cleft; $ycor -= $ctop;} #zum korregieren der abweichenden mausrad screen coordinaten auf clientcoords
 my $zoomfactor = ($cbottom-$ctop)/($b-$t);
 $xcor/=$zoomfactor; $ycor/=$zoomfactor;
 $xcor+=$l; $ycor+=$t;
 #print "MouseEvent(x:$xcor,y:$ycor,flags:$flags) hwnd:$hwnd event:$event\n";
 login_slurp($ip,$port,$login_name,$login_pass,$Win{$winid}->{'-handle'},'INPUT_EVENT~3~'.join("~",$event,$xcor,$ycor,$flags));
 #login_slurp($ip,$port,$login_name,$login_pass,$Win{$winid}->{'-handle'},
 #'EVAL~
 #my $event = "'.$event.'";
 #my $xcor = "'.$xcor.'";
 #my $ycor = "'.$ycor.'";
 #my $flags = "'.$flags.'";
 #if ($event == 0x200) { Win32::GUI::SetCursorPos($xcor,$ycor); }
 #elsif ($event == 0x201) { Win32::GuiTest::SendLButtonDown(); }
 #elsif ($event == 0x202) { Win32::GuiTest::SendLButtonUp(); }
 #elsif ($event == 0x204) { Win32::GuiTest::SendRButtonDown(); }
 #elsif ($event == 0x205) { Win32::GuiTest::SendRButtonUp(); }
 #elsif ($event == 0x207) { Win32::GuiTest::SendMButtonDown(); }
 #elsif ($event == 0x208) { Win32::GuiTest::SendMButtonUp(); }
 #elsif ($event == 0x20A) { my $scroll_ID = int($flags / 0x10000); Win32::GuiTest::MouseMoveWheel($scroll_ID / 120); }
 #');
}

#==== zum ermitteln des obersten clients eines servers
#sub get_toppest_client($$)
#{
# my ($ip,$port) = @_;
# foreach (grep(Win32::GuiTest::IsWindowVisible($_) && Win32::GUI::IsIconic($_) == 0 && index(Win32::GUI::GetClassName($_),'VDM_Client_'.$ip.'-'.$port.'-') == 0,Win32::GuiTest::GetChildWindows(0)))
# {
#  #print Win32::GUI::GetWindowLong($_,-8).":".Win32::GUI::GetClassName($_).",".Win32::GuiTest::GetWindowText($_)."\n";
#  if (Win32::GUI::GetClassName($_) =~ m/(\d+)$/)
#  {
#   return($1,Win32::GUI::ClientToScreen($_,0,0));
#  }
# }
# return(-1,0,0);
#}
#get_toppest_client("127.0.0.1","5002");
#exit;

#---- um neue fenster zu zentrieren auf multimonitor system
my @displayinfo_array;
my $MONITORINFOEX = pack("I", 72).("\x00" x 72);
my $MonitorEnumProc = Win32::API::Callback->new(sub{ $GetMonitorInfo->Call($_[0],$MONITORINFOEX); push(@displayinfo_array,join("\t",unpack("i4",unpack("P16",pack("I",$_[2]))))); }, "NNNN", "I");
sub getdisplaycenterpos($$)
{
 @displayinfo_array = ();
 $EnumDisplayMonitors->Call(0,0,$MonitorEnumProc,0);
 my ($mx, $my) = Win32::GUI::GetCursorPos;
 foreach (@displayinfo_array)
 {
  my ($x1,$y1,$x2,$y2) = split("\t",$_);
  if ($mx >= $x1 && $mx < $x2 && $my >= $y1 && $my < $y2)
  {
   my ($x,$y) = (int($x1+(($x2-$x1)/2)-$_[0]/2),int($y1+(($y2-$y1)/2)-$_[1]/2));
   return($x < $x1 ? $x1 : $x,$y < $y1 ? $y1 : $y);
  }
 }
 return(int($mx),int($my));
}
sub getdisplayfromwindow()
{
 @displayinfo_array = ();
 $EnumDisplayMonitors->Call(0,0,$MonitorEnumProc,0);
 #---- flaeche des fensters auf display errechnen -> biggest pix = our display
 my ($wl,$wt,$wr,$wb) = Win32::GUI::GetWindowRect($_[0]);
 my $XY_found = 0;
 my $displayinfo_array_pos_found = 0;
 my $array_pos_count = 0;
 foreach (@displayinfo_array)
 {
  my ($dl,$dt,$dr,$db) = split("\t",$_);
  $wl = $dl if ($dl > $wl);
  $wr = $dr if ($dr < $wr);
  $wt = $dt if ($dt > $wt);
  $wb = $db if ($db < $wb);
  my $XY_actual = ($wr-$wl) * ($wb-$wt);
  if ($XY_actual > $XY_found)
  {
   $XY_found = $XY_actual;
   $displayinfo_array_pos_found = $array_pos_count;
  }
  $array_pos_count++;
 }
 return(split("\t",$displayinfo_array[$displayinfo_array_pos_found]));
}

#---- popup fuer openwindow ask
my $ow_dialogbox = $mw->DialogBox(-title => 'VDM: New window found.', -buttons => ['Yes', 'No'], -default_button => 'No');
$ow_dialogbox->add('Label',-pady => 20,-text => "A new window on the server is displayed.",-font => '{arial} 10 bold',-justify => "left")->pack;
my $ow_image = $mw->Photo(-format => 'JPEG');
my $ow_frame_bottom = $ow_dialogbox->add('Frame')->pack(-side => "bottom");
my $ow_frame_center = $ow_dialogbox->add('Frame')->pack(-side => "bottom");
$ow_dialogbox->add('Label',-image => $ow_image)->pack();
my %ow_cb_var = (ipport => 1,exename => 1,windowname => 1,classname => 1,hWnd => 0);
my $ow_cb_ipport =     $ow_frame_center->Checkbutton(-text => "Ip/Port:",-state => 'disabled',-variable=>\$ow_cb_var{ipport},-font => '{arial} 8 bold')   ->grid(-column => 0,-row => 0,-sticky => 'w');
my $ow_cb_exename =    $ow_frame_center->Checkbutton(-text => "Exename:",-state => 'disabled',-variable=>\$ow_cb_var{exename},-font => '{arial} 8 bold')   ->grid(-column => 0,-row => 1,-sticky => 'w');
my $ow_cb_windowname = $ow_frame_center->Checkbutton(-text => "Windowname:",-state => 'disabled',-variable=>\$ow_cb_var{windowname},-font => '{arial} 8 bold')->grid(-column => 0,-row => 2,-sticky => 'w');
my $ow_cb_classname =  $ow_frame_center->Checkbutton(-text => "Classname:",-state => 'disabled',-variable=>\$ow_cb_var{classname},-font => '{arial} 8 bold') ->grid(-column => 0,-row => 3,-sticky => 'w');
my $ow_cb_hWnd =       $ow_frame_center->Checkbutton(-text => "hWnd:",-state => 'disabled',-variable=>\$ow_cb_var{hWnd},-font => '{arial} 8 bold')      ->grid(-column => 0,-row => 4,-sticky => 'w');
my $ow_text_ipport;     $ow_frame_center->Label(-font => '{arial} 8',-wraplength => 300,-textvariable => \$ow_text_ipport)->    grid(-column => 1,-row => 0,-sticky => 'w');
my $ow_text_exename;    $ow_frame_center->Label(-font => '{arial} 8',-wraplength => 300,-textvariable => \$ow_text_exename)->   grid(-column => 1,-row => 1,-sticky => 'w');
my $ow_text_windowname; $ow_frame_center->Label(-font => '{arial} 8',-wraplength => 300,-textvariable => \$ow_text_windowname)->grid(-column => 1,-row => 2,-sticky => 'w');
my $ow_text_classname;  $ow_frame_center->Label(-font => '{arial} 8',-wraplength => 300,-textvariable => \$ow_text_classname)-> grid(-column => 1,-row => 3,-sticky => 'w');
my $ow_text_hWnd;       $ow_frame_center->Label(-font => '{arial} 8',-wraplength => 300,-textvariable => \$ow_text_hWnd)->      grid(-column => 1,-row => 4,-sticky => 'w');
$b->attach($ow_cb_windowname,-balloonmsg => "The windowname is the text in the window title bar.\nSome windows can change their window title.\nFor example Firefox changes it when switching tab-windows.\nTake this in mind if you use it.");
$b->attach($ow_cb_hWnd,-balloonmsg => "Window handles changes everytime a new window will created.\nMeans the same window of the same application\ncould have another handle-id after reopening.\nHowever sometimes its useful to use this id in cases\nwhere no new window will be recreated but it comes back visibly.\nFor example some rightclick-menues or dropdown-menues or\nwhen a window comes back by clicking on the trayicon.");
$ow_frame_bottom->Frame(-height => 10)->pack();
$ow_frame_bottom->Label(-text => "Do you want to open this window ?",-font => '{arial} 10 bold',-justify => "left")->pack;
my $ow_remember_var = 0;
my $ow_cb_remember = $ow_frame_bottom->Checkbutton(-text => "Remember Answer",-variable => \$ow_remember_var,-command => sub{ $_->configure(-state => ($ow_remember_var?'normal':'disabled')) for ($ow_cb_ipport,$ow_cb_exename,$ow_cb_windowname,$ow_cb_classname,$ow_cb_hWnd); },-font => '{arial} 8')->pack;
$b->attach($ow_cb_remember,-balloonmsg => "To remember your answer,\nplease select one or more of the window options.\nThey are used to reidentify the windows.\n\nFor example you want to block exactly this window\nthen the best combination could be a mix of\nIp/Port, Exename, Windowname and Classname.\n\nInfo: Some windows has not a fixed windowname\nin this case dont choose it to remember the win.\n\nExample: Ipp/port + exename + classname\nOn server ipport all windows with this exename\nand classname are affected.\n\nExample: exename (only)\nOn all servers, applications with this path are affected.\n\nExample: ip/port (only)\nAll windows from this server are affected.");
sub ow_dialogbox(@)
{
 my ($ip,$port,$login_name,$login_pass,$newhwnd,$exename,$windowname,$classname) = @_;
 my $ipport = $ip.":".$port;

 #---- pruefen ob schon erinnerungsdaten existieren
 foreach (@ow_saved)
 {
  my ($xanswer,$xipport,$xexename,$xwindowname,$xclassname,$xhWnd) = split("\t",$_);
  if (($xipport eq "---" || $xipport eq $ipport) && ($xexename eq "---" || $xexename eq $exename) && ($xwindowname eq "---" || $xwindowname eq $windowname) && ($xclassname eq "---" || $xclassname eq $classname) && ($xhWnd eq "---" || $xhWnd eq $newhwnd))
  {
   return ($xanswer eq "Yes")?1:0;
  }
 }

 #---- text und bild ins popup schreiben
 ($ow_text_ipport,$ow_text_exename,$ow_text_windowname,$ow_text_classname,$ow_text_hWnd) = ($ipport,$exename,$windowname,$classname,$newhwnd);
 my $img_binary = login_slurp($ip,$port,$login_name,$login_pass,hex($mw->id),"ShootWindow_ONCE~$newhwnd");
 $ow_image->configure(-data => encode_base64(($img_binary eq "")? std::readfile_binmode("images/no_image_data.jpg"): $img_binary));

 #---- popup oeffnen
 $ow_remember_var = 0;
 $ow_cb_var{$_} = 1 for ("ipport","exename","windowname","classname");
 $ow_cb_var{hWnd} = 0;
 $_->configure(-state => 'disabled') for ($ow_cb_ipport,$ow_cb_exename,$ow_cb_windowname,$ow_cb_classname,$ow_cb_hWnd);
 my $answer;
 my $wrong;
 do {
  $answer = $ow_dialogbox->Show(-popover => "getdisplaycenterpos");
  return 0 if ($answer eq "");
  $wrong = ($ow_remember_var && !$ow_cb_var{ipport} && !$ow_cb_var{exename} && !$ow_cb_var{windowname} && !$ow_cb_var{classname} && !$ow_cb_var{hWnd})?1:0;
  &infomessbox(hex($mw->id),"You have choosed remember answer.\nPlease select one or more of the window options.\nThey are used to reidentify the windows.\n\nFor example you want to block exactly this window\nthen the best combination could be Ip/Port, Exename, Windowname and Classname.\n\nInfo: Some windows has not a fixed windowname\nin this case dont choose it to remember the win.\n\nExample: Ipp/port + exename + classname\nOn server ipport all windows with this exename and classname are affected.\n\nExample: exename (only)\nOn all servers, applications with this path are affected.\n\nExample: ip/port (only)\nAll windows from this server are affected.") if ($wrong);
 } while ($wrong);

 #---- erinnerungsdaten erstellen
 if ($ow_remember_var)
 {
  push(@ow_saved,join("\t",$answer,($ow_cb_var{ipport} == 0)?"---":$ow_text_ipport,($ow_cb_var{exename} == 0)?"---":$ow_text_exename,($ow_cb_var{windowname} == 0)?"---":$ow_text_windowname,($ow_cb_var{classname} == 0)?"---":$ow_text_classname,($ow_cb_var{hWnd} == 0)?"---":$ow_text_hWnd));
  std::writefile("config/openwindow_rules.dat",join("\n",@ow_saved));
 }

 return ($answer eq "Yes")?1:0;
}

#==== openwindow_loop
sub openwindow_loop()
{
 if ($config{openwin} ne "Ignore All")
 {
  foreach (keys %openwindow_count)
  {
   next unless ($openwindow_noerror{$_});
   my ($ip,$port,$login_name,$login_pass) = split("\t",$_);
   if (my ($hwnd_data_string) = login_slurp($ip,$port,$login_name,$login_pass,hex($mw->id),'GETCHILDWINDOWS_4OPENWINDOW~0'))
   {
    my @newhwnds = map {substr($_,0,index($_,':'))} split("\t",$hwnd_data_string); # need this array for the correct z-order in foreach (dropdown above topwindow)
    my $newhwndstring = join("\t",sort @newhwnds);
    #my $newhwndstring = join("\t",sort keys %hwndhash); # deleted because: if nochange above is faster .. hash only if needed
    if ($newhwndstring ne $openwindow_list{$_})
    {
     my %hwndhash = map {my @data = split(':',$_); $data[0] => {'exename',std::unfileable($data[1]),'classname',std::unfileable($data[2]),'windowname',std::unfileable($data[3]),'threadID',$data[4],'processID',$data[5]}} split("\t",$hwnd_data_string);
     my %oldwins = map {$_ => 1} split("\t",$openwindow_list{$_});
     #foreach my $newhwnd (split("\t",$newhwndstring))
     foreach my $newhwnd (reverse @newhwnds)
     {
      if (not(defined $oldwins{$newhwnd}) && not(defined $Win{$ip."-".$port."-".$newhwnd}))
      {
       #if ($config{openwin} ne "Ask" || &quesmessbox(hex($mw->id),"New window on server: $ip:$port\n\nExename: ".$hwndhash{$newhwnd}{exename}."\nWindowname: ".$hwndhash{$newhwnd}{windowname}."\nClassname: ".$hwndhash{$newhwnd}{classname}."\nhWnd: $newhwnd\n\nDo you want to open this window ?"))
       #if ($config{openwin} eq "Open" || ow_dialogbox($ip,$port,$login_name,$login_pass,$newhwnd,$hwndhash{$newhwnd}{exename},$hwndhash{$newhwnd}{windowname},$hwndhash{$newhwnd}{classname}))
       if (($config{openwin} eq "Open All") ||
           ($config{openwin} eq "Ask (Rule)" && ow_dialogbox($ip,$port,$login_name,$login_pass,$newhwnd,$hwndhash{$newhwnd}{exename},$hwndhash{$newhwnd}{windowname},$hwndhash{$newhwnd}{classname})) ||
           ($config{openwin} eq "Same App" && $openwindow_sameexe{join("\t",$ip,$port,$hwndhash{$newhwnd}{exename})}) ||
           ($config{openwin} eq "Same PID" && $openwindow_samepid{join("\t",$ip,$port,$hwndhash{$newhwnd}{processID})}) ||
           ($config{openwin} eq "Same TID" && $openwindow_sametid{join("\t",$ip,$port,$hwndhash{$newhwnd}{threadID})}))
       {
        #print "new_remote_window: $newhwnd\n";
        #createwindow(0,$newhwnd,$ip.":".$port.":".$newhwnd,$ip,$port,$login_name,$login_pass);
        #createwindow(0,$newhwnd,(($hwndhash{$newhwnd}{windowname} ne "")?$hwndhash{$newhwnd}{windowname}:std::rx_g($hwndhash{$newhwnd}{exename},"^.+\\\\","").":".$hwndhash{$newhwnd}{classname})." - VDM",$ip,$port,$login_name,$login_pass);
        #createwindow(0,$newhwnd,"VDM: ".($hwndhash{$newhwnd}{windowname} || $hwndhash{$newhwnd}{classname})." - ".std::rx_g($hwndhash{$newhwnd}{exename},"^.+\\\\",""),$ip,$port,$login_name,$login_pass);
        createwindow(0,$newhwnd,($hwndhash{$newhwnd}{windowname} || $hwndhash{$newhwnd}{classname})." - ".std::rx_g($hwndhash{$newhwnd}{exename},"^.+\\\\","")." - VDM",$ip,$port,$login_name,$login_pass);
       }
      }
     }
     $openwindow_list{$_} = $newhwndstring;
    }
   } else { $openwindow_noerror{$_} = 0; }
  }
 }
 $mw->after(1500,\&openwindow_loop);
}
$mw->after(2000,\&openwindow_loop);

#==== Rechtsklick Menue
my $application_menu = Win32::GUI::Menu->new(
    "ApplicationMenu Function" => "ApplicationMenu",
    "> Restore"  => "SendRestore",
    "> Minimize" => "SendMinimize",
    "> Maximize" => "SendMaximize",
    "> Close"    => "SendClose",
    "> ShowWindow"          => "",
    ">> SW_FORCEMINIMIZE"   => "SW_FORCEMINIMIZE",
    ">> SW_HIDE"            => "SW_HIDE",
    ">> SW_MAXIMIZE"        => "SW_MAXIMIZE",
    ">> SW_MINIMIZE"        => "SW_MINIMIZE",
    ">> SW_RESTORE"         => "SW_RESTORE",
    ">> SW_SHOW"            => "SW_SHOW",
    ">> SW_SHOWDEFAULT"     => "SW_SHOWDEFAULT",
    ">> SW_SHOWMAXIMIZED"   => "SW_SHOWMAXIMIZED",
    ">> SW_SHOWMINIMIZED"   => "SW_SHOWMINIMIZED",
    ">> SW_SHOWMINNOACTIVE" => "SW_SHOWMINNOACTIVE",
    ">> SW_SHOWNA"          => "SW_SHOWNA",
    ">> SW_SHOWNOACTIVATE"  => "SW_SHOWNOACTIVATE",
    ">> SW_SHOWNORMAL"      => "SW_SHOWNORMAL",
    "> Redraw"              => "SendRedraw",
    "> Set Foreground"      => "SetForeground",
    "> Transparency"        => "",
    ">> LayeredOn_FadeOut"  => "LayeredOn_FadeOut",
    ">> LayeredOn_FadeIn"   => "LayeredOn_FadeIn",
    ">> LayeredOff"         => "LayeredOff",
    "> Window Styles"       => "WindowStyles",
    "> Get ChildWindows"    => "GetChildWindows");

my $CLICK_photolab;
my $CLICK_hwnd;
my $CLICK_ip;
my $CLICK_port;
my $CLICK_login_name;
my $CLICK_login_pass;
sub applicationmenu($$$$$$$)
{
 $CLICK_photolab = $_[0];
 $CLICK_hwnd     = $_[1];
 $CLICK_ip       = $_[2];
 $CLICK_port     = $_[3];
 $CLICK_login_name = $_[4];
 $CLICK_login_pass = $_[5];

 my($x, $y) = Win32::GUI::GetCursorPos();
 $main->TrackPopupMenu($application_menu->{ApplicationMenu}, $x, $y);
}
my %ApplicationMenu_functions = ('SendRestore'        => 'Win32::GUI::SendMessage($CLICK_hwnd,'.WM_SYSCOMMAND.',0xF120,0); Time::HiRes::sleep(0.1);',
                                 'SendMinimize'       => 'Win32::GUI::SendMessage($CLICK_hwnd,'.WM_SYSCOMMAND.',0xF020,0); Time::HiRes::sleep(0.1);',
                                 'SendMaximize'       => 'Win32::GUI::SendMessage($CLICK_hwnd,'.WM_SYSCOMMAND.',0xF030,0); Time::HiRes::sleep(0.1);',
                                 'SendClose'          => 'Win32::GUI::SendMessage($CLICK_hwnd,'.WM_SYSCOMMAND.',0xF060,0); Time::HiRes::sleep(0.1);',
                                 'SW_FORCEMINIMIZE'   => 'Win32::GuiTest::ShowWindow($CLICK_hwnd,11); Time::HiRes::sleep(0.1);',
                                 'SW_HIDE'            => 'Win32::GuiTest::ShowWindow($CLICK_hwnd,0); Time::HiRes::sleep(0.1);',
                                 'SW_MAXIMIZE'        => 'Win32::GuiTest::ShowWindow($CLICK_hwnd,3); Time::HiRes::sleep(0.1);',
                                 'SW_MINIMIZE'        => 'Win32::GuiTest::ShowWindow($CLICK_hwnd,6); Time::HiRes::sleep(0.1);',
                                 'SW_RESTORE'         => 'Win32::GuiTest::ShowWindow($CLICK_hwnd,9); Time::HiRes::sleep(0.1);',
                                 'SW_SHOW'            => 'Win32::GuiTest::ShowWindow($CLICK_hwnd,5); Time::HiRes::sleep(0.1);',
                                 'SW_SHOWDEFAULT'     => 'Win32::GuiTest::ShowWindow($CLICK_hwnd,10); Time::HiRes::sleep(0.1);',
                                 'SW_SHOWMAXIMIZED'   => 'Win32::GuiTest::ShowWindow($CLICK_hwnd,3); Time::HiRes::sleep(0.1);',
                                 'SW_SHOWMINIMIZED'   => 'Win32::GuiTest::ShowWindow($CLICK_hwnd,2); Time::HiRes::sleep(0.1);',
                                 'SW_SHOWMINNOACTIVE' => 'Win32::GuiTest::ShowWindow($CLICK_hwnd,7); Time::HiRes::sleep(0.1);',
                                 'SW_SHOWNA'          => 'Win32::GuiTest::ShowWindow($CLICK_hwnd,8); Time::HiRes::sleep(0.1);',
                                 'SW_SHOWNOACTIVATE'  => 'Win32::GuiTest::ShowWindow($CLICK_hwnd,4); Time::HiRes::sleep(0.1);',
                                 'SW_SHOWNORMAL'      => 'Win32::GuiTest::ShowWindow($CLICK_hwnd,1); Time::HiRes::sleep(0.1);',
                                 'SendRedraw'         => 'Win32::GUI::Redraw($CLICK_hwnd,Win32::GUI::GetClientRect($CLICK_hwnd),0x0485); Time::HiRes::sleep(0.1);',
                                 #'SetForeground'      => 'Win32::GUI::SetWindowPos($CLICK_hwnd,0,0,0,0,0,0x0001|0x0002|0x4000); Time::HiRes::sleep(0.1);');
                                 'SetForeground'      => 'Win32::GUI::SetWindowPos($CLICK_hwnd,-1,0,0,0,0,0x0001|0x0002|0x4000); Win32::GUI::SetWindowPos($CLICK_hwnd,-2,0,0,0,0,0x0001|0x0002|0x4000); Time::HiRes::sleep(0.1);',
                                 'LayeredOn_FadeOut'  => 'my \$ancestor = \$GetAncestor->Call($CLICK_hwnd,2); Win32::GUI::SetWindowLong(\$ancestor,-20,Win32::GUI::GetWindowLong(\$ancestor,-20)|0x00080000); for(reverse(0,12,25,38,51,63,76,89,102,114,127,140,153,165,178,191,204,216,229,242,255)){\$SetLayeredWindowAttributes->Call(\$ancestor,0,\$_,2);Time::HiRes::sleep(0.04);}',
                                 'LayeredOn_FadeIn'   => 'my \$ancestor = \$GetAncestor->Call($CLICK_hwnd,2); Win32::GUI::SetWindowLong(\$ancestor,-20,Win32::GUI::GetWindowLong(\$ancestor,-20)|0x00080000); for(0,12,25,38,51,63,76,89,102,114,127,140,153,165,178,191,204,216,229,242,255){\$SetLayeredWindowAttributes->Call(\$ancestor,0,\$_,2);Time::HiRes::sleep(0.04);}',
                                 'LayeredOff'         => 'my \$ancestor = \$GetAncestor->Call($CLICK_hwnd,2); Win32::GUI::SetWindowLong(\$ancestor,-20,Win32::GUI::GetWindowLong(\$ancestor,-20)&0xFFF7FFFF);');
foreach my $function (keys %ApplicationMenu_functions)
{
 eval('sub '.$function.'_Click
       {
        if (my ($tmp) = login_slurp($CLICK_ip,$CLICK_port,$CLICK_login_name,$CLICK_login_pass,hex($mw->id),"EVAL~'.$ApplicationMenu_functions{$function}.'"))
	{
         #tcp_slurp($CLICK_ip,$CLICK_port,"SendMessage~".$CLICK_hwnd."~".WM_PAINT."~0~0");
         if (my $img_binary = login_slurp($CLICK_ip,$CLICK_port,$CLICK_login_name,$CLICK_login_pass,hex($mw->id),\'ShootWindow_ONCE~\'.$CLICK_hwnd))
         {
          my $foto1 = $mw->Photo( -data => encode_base64($img_binary), -format => \'JPEG\');
          $CLICK_photolab->configure(-image => $foto1);
         }
        }
       }');
}
sub GetChildWindows_Click
{
 &connect($CLICK_ip.':'.$CLICK_port,$CLICK_hwnd,$CLICK_login_name,$CLICK_login_pass);
}
sub WindowStyles_Click
{
 Win32::Process::Create($ProcessObj,
                        'perl\bin\vdm_client.exe',
                        'vdm_client.exe window_styles.pl "'.$CLICK_ip.'" "'.$CLICK_port.'" "'.$CLICK_login_name.'" "'.$CLICK_login_pass.'" "'.$CLICK_hwnd.'"',
                        0,
                        (Win32::GUI::GetPerlWindow())?NORMAL_PRIORITY_CLASS:DETACHED_PROCESS|NORMAL_PRIORITY_CLASS,
                        '.') || &infomessbox(hex($mw->id),"Can't start window_styles process.\nError: ".Win32::FormatMessage(Win32::GetLastError()));
}
sub opendesktopbuttons($$$$$)
{
 my ($page,$ip,$port,$login_name,$login_pass) = @_;
 my $pagebottom = $page->Frame()->pack(-side => "bottom",-expand => 0,-fill => "x");
 if (my ($displaydata) = login_slurp($ip,$port,$login_name,$login_pass,hex($mw->id),'GETDISPLAYINFO'))
 {
  foreach (split("\n",$displaydata))
  {
   my ($displayDC,$display_l,$display_t,$display_r,$display_b,$displayname) = split("\t",$_);
   $pagebottom->Button(-command => sub{&createdesktop($displayname,$display_l,$display_t,$display_r,$display_b,$ip,$port,$login_name,$login_pass)},-text => $displayname." (".($display_r-$display_l)."x".($display_b-$display_t).")",-bg => 'gray60',-fg => 'white',-activebackground => 'gray60',-activeforeground => 'black')->pack(-side => "top",-expand => 1,-fill => "x");
  }
  return 1;
 }
 return 0;
}

####################################################################
################################################## new socksystem ##
#---- vars
#my %sockhash;
my $stream_terminator = "~#END#";
#---- getsock
sub getsock($$)
{
 my $ip   = $_[0];
 my $port = $_[1];
 my $dsock = IO::Socket::INET->new(#Listen    => SOMAXCONN,
                                   PeerAddr  => $ip,
                                   PeerPort  => $port,
                                   #LocalAddr => inet_ntoa(INADDR_ANY),
                                   #LocalPort => $portid,
                                   #Broadcast => 1,
                                   #Type => SOCK_STREAM,
                                   #Blocking => 1,
                                   Proto     => 'tcp');
 return $dsock;
}
#---- getsock + login
sub getsock_andlogin($$$$$)
{
 my $ip           = $_[0];
 my $port         = $_[1];
 my $login_name   = $_[2];
 my $login_pass   = $_[3];
 my $messbox_hwnd = $_[4];

 my $dsock;
 while(not($dsock = &getsock($ip,$port)))
 { return if (! &quesmessbox($messbox_hwnd,"Cant connect to Server.\nError message: $!\n\nTry to reconnect ?")); }

 my $publickey;
 if (not(($publickey) = &tcp_slurp($dsock,'LOGINGETPUBLIC')))
 { &infomessbox($messbox_hwnd,"Server tcp_slurp problem on login. (1)"); return; }

 my $complexpass = $login_pass.$publickey;
 $complexpass = uc(Digest::SHA::sha1_hex($complexpass)) for (1 .. 7);

 my $pass_answer;
 if (not(($pass_answer) = &tcp_slurp($dsock,'LOGIN~'.$login_name.'/'.$complexpass)))
 { &infomessbox($messbox_hwnd,"Server tcp_slurp problem on login. (2)"); return; }

 if ($pass_answer ne 'LOGIN_OK')
 {
  $dsock->close;
  &infomessbox($messbox_hwnd,"Authentication problem.\nServer response: ".$pass_answer);
  return;
 }
 return $dsock;
}
#---- tcp_slurp
sub tcp_slurp($$)
{
 my $sock    = $_[0];
 my $tosend  = $_[1];

 my $theselect = IO::Select->new($sock);
 if($theselect->can_write(7))
 {
  #print "can_write\n";
  syswrite($sock,$tosend.$stream_terminator);
  my $sammelrequest;
  while($theselect->can_read(7))
  {
   #print "can_read\n";
   my $data;
   return unless (sysread($sock,$data,1000000));
   $sammelrequest .= $data;
   if ($sammelrequest =~ s/$stream_terminator$//)
   {
    return $sammelrequest;
   }
   #print "must-reread\n";
  }
 }
 close $sock;
 #print "TIMEOUT: end_tcp_slurp\n";
 return;
}
#---- login_slurp
sub login_slurp($$$$$$)
{
 my $ip           = $_[0];
 my $port         = $_[1];
 my $login_name   = $_[2];
 my $login_pass   = $_[3];
 my $messbox_hwnd = $_[4];
 my $send_string  = $_[5];
 my $ip_port      = join(':',$ip,$port);

 if (not defined $sockhash{$ip_port})
 {
   my $server_answer;
   do
   {
    return unless (($sockhash{$ip_port}) = &getsock_andlogin($ip,$port,$login_name,$login_pass,$messbox_hwnd));
    if (not(($server_answer) = &tcp_slurp($sockhash{$ip_port},$send_string)))
    { return if (! &quesmessbox($messbox_hwnd,"Server tcp_slurp problem.\nTry to reconnect ?")); }
   }
   while (not defined $server_answer);
   return $server_answer;
 }
 else
 {
  if (my ($return_string) = &tcp_slurp($sockhash{$ip_port},$send_string))
  {
   return $return_string;
  }
  else
  {
   return unless (&quesmessbox($messbox_hwnd,"Connection to Server broken.\nError message: $!\n\nTry to reconnect ?"));
   my $server_answer;
   do
   {
    return unless (($sockhash{$ip_port}) = &getsock_andlogin($ip,$port,$login_name,$login_pass,$messbox_hwnd));
    if (not(($server_answer) = &tcp_slurp($sockhash{$ip_port},$send_string)))
    { return if (! &quesmessbox($messbox_hwnd,"Server tcp_slurp problem.\nTry to reconnect ?")); }
   }
   while (not defined $server_answer);
   return $server_answer;
  }
 }
}

#####################################################################
########################################################## Connect ##
my @photo_cache;
sub delete_tab_objects($$) { my $tabid = $_[1]; $_->delete foreach(@{$photo_cache[$tabid]}); }
sub scrollit {$_[2]->yview('scroll',($_[1]==120)?-5:5,'units');}
my $tabid_count = 1;
sub connect($$$$)
{
 my $ip_port       = $_[0];
 my $mainhwnd      = $_[1];# hwnd or uri
    $mainhwnd      = 0 if ($mainhwnd eq "");
 my $login_name    = $_[2];
 my $login_pass    = $_[3];
 my ($ip,$port)    = split(':',$ip_port);
 my $tabname       = ($mainhwnd == 0)? $ip_port: $ip_port.' hWnd:'.$mainhwnd;
    $tabname       = $ip_port." Uri: ".$mainhwnd if ($mainhwnd !~ m/^-?\d+$/);
    #$tabname       = $ip."\nPort: ".$port."\nhWnd: ".$mainhwnd;
 my $tabid         = $tabid_count++;
 my $titlename     = "VDM: ".$ip_port." hWnd: ".$mainhwnd;
    $titlename     = "VDM: ".$ip_port." Uri: ".$mainhwnd if ($mainhwnd !~ m/^-?\d+$/);

 if (my ($request) = login_slurp($ip,$port,$login_name,$login_pass,hex($mw->id),(($mainhwnd !~ m/^-?\d+$/)?'FINDWINDOWLIKE_URI_FULLINFO':'GETCHILDWINDOWS_FULLINFO').'~'.$mainhwnd))
 {
  my $pagetab = $nb->add($tabid,-label => $tabname,-tabclosekill => 0,-raisecmd => sub{$mw->title($titlename);});
  $pagetab->bind("<Destroy>",[\&delete_tab_objects,$tabid]);
  my $page = $pagetab->Frame()->pack(-expand => 1,-fill => 'both');
  my $pagetop = $page->Frame(-width => 20)->pack(-anchor => 's',-expand => 0,-fill => 'x');
  $pagetop->Button(-bg => 'gray60',-fg => 'white',-activebackground => 'gray60',-activeforeground => 'black',-relief => 'raised',-text  => 'Refresh',-width => 10,-command => sub{$nb->delete($tabid);&connect($ip.':'.$port,$mainhwnd,$login_name,$login_pass);})->pack(-anchor => 'n',-side => 'left',-expand => 1,-fill => 'x');
  $pagetop->Button(-bg => 'gray60',-fg => 'white',-activebackground => 'gray60',-activeforeground => 'black',-relief => 'raised',-text  => 'Close',-width => 10,-command => sub{$nb->delete($tabid);})->pack(-anchor => 'n',-side => 'right',-expand => 1,-fill => 'x');
  return unless opendesktopbuttons($page,$ip,$port,$login_name,$login_pass);
  my $page_scrollable = $page->Scrolled('Frame', -scrollbars => "e",-width => 210 , -height => 450)->pack(-expand => 1,-fill => 'both');
  $page->bind("<MouseWheel>",[\&scrollit,Ev('D'),$page_scrollable]);
  $page->bind("<Enter>",sub{$_[0]->focus;});
  $nb->raise($tabid);
  my @request_split = split("\t",$request);
  foreach my $window (@request_split)
  {
   my ($hwnd,$name,$classname,$left_w,$top_w,$right_w,$bottom_w,$left_c,$top_c,$right_c,$bottom_c,$class_style,$style,$exstyle,$hwnd_parent,$hwnddeep,$filename,$threadid,$processid) = split(':',$window);
   $name      = std::unfileable($name);
   $classname = std::unfileable($classname);
   $filename  = std::unfileable($filename);
   printf("Load-Thumb: %08x, $name\n",$hwnd);
   if (my ($img_binary) = login_slurp($ip,$port,$login_name,$login_pass,hex($mw->id),"ShootWindow_ONCE~$hwnd"))
   {
    next if ($img_binary eq "");
    $Label_Statusbar = 'Load hWnd: '.$hwnd;
    $mw->update;
    my $foto1 = $mw->Photo( -data => encode_base64($img_binary), -format => 'JPEG');
    my $photolab = $page_scrollable->Label(-takefocus => 1,-relief => 'raised',-image => $foto1)->pack();
    push(@{$photo_cache[$tabid]},$foto1);

#$photolab->bind($photolab,'<ButtonPress-1>' => [\&createwindow,$hwnd,$name,$ip,$port,$login_name,$login_pass,1]);
$photolab->bind($photolab,'<ButtonPress-1>' => [\&createwindow,$hwnd,($name || $classname)." - ".std::rx_g($filename,"^.+\\\\","")." - VDM",$ip,$port,$login_name,$login_pass,1]);
$photolab->bind($photolab,'<ButtonPress-3>' => [\&applicationmenu,$hwnd,$ip,$port,$login_name,$login_pass]);
$photolab->bind($photolab,'<Enter>' => [\&Tk::configure,-relief => 'sunken',-borderwidth => 4]);
$photolab->bind($photolab,'<Leave>' => [\&Tk::configure,-relief => 'raised',-borderwidth => 2]);
$photolab->bind($photolab,'<FocusIn>'  => [\&Tk::configure,-relief => 'sunken',-borderwidth => 4]);
$photolab->bind($photolab,'<FocusOut>' => [\&Tk::configure,-relief => 'raised',-borderwidth => 2]);

    $b->attach($photolab,-balloonmsg => "Child-Depth: $hwnddeep\nWindowname: ".join("\n\t         ",map {s/ *$//;$_;} ($name =~ m/(.{1,70}$|.{1,70} +|.{1,70})/g))."\nClassname: $classname\nFilename: $filename\nhWnd: $hwnd (0x".uc(sprintf("%08x",$hwnd)).")\nhWnd_Parent: $hwnd_parent (0x".uc(sprintf("%08x",$hwnd_parent)).")\nWindow_Rect: ($left_w,$top_w)-($right_w,$bottom_w), ".($right_w-$left_w)."x".($bottom_w-$top_w)."\nClient_Rect:     ($left_c,$top_c)-($right_c,$bottom_c), ".($right_c-$left_c)."x".($bottom_c-$top_c)."\nStyle: $style (0x".uc(sprintf("%08x",$style)).")\nExStyle: $exstyle (0x".uc(sprintf("%08x",$exstyle)).")\nClass_Style: $class_style (0x".uc(sprintf("%08x",$class_style)).")\nProcessID: $processid (0x".uc(sprintf("%04x",$processid)).")\nThreadID:    $threadid (0x".uc(sprintf("%04x",$threadid)).")\n(Right-click on Thumb for Options)");
   }
   else
   {
    last; #on slurp problem
   }
  }
  $Label_Statusbar = 'All Windows loaded.';
 }
 #close $dsock if($dsock);
}

#---- zum erstellen des passwort-sha1-hash
sub generate_password_hash($)
{
 my $key = $_[0];
 if ($key !~ m/^KEY-/)
 {
   $key = uc(Digest::SHA::sha1_hex($key)) for (1..20);
   return 'KEY-'.$key;
 }
 return $key;
}

#---- zum oeffnen von client-verbindungen mit openwindow commandline strings
sub openwindow(@)
{
 #my ($type,$ip,$port,$login_name,$login_pass,$exename,$classname,$windowname,$maxdeep) = split(":",$_[0]);
 my ($type,$ip,$port,$login_name,$login_pass,$uri) = @_;
 $login_pass = generate_password_hash($login_pass);
 if ($type eq "-openwindow")
 {
  if (my ($hwnd_list) = login_slurp($ip,$port,$login_name,$login_pass,hex($mw->id),"FINDWINDOWLIKE_URI~".$uri))
  {
   #print "hwnd_list: $hwnd_list\n";
   my @hwnd_list = split("\t",$hwnd_list);
   print "Found Windows Matching: ".($#hwnd_list+1)." hwnds:".join(",",@hwnd_list)."\n";
   return infomessbox(hex($mw->id),"Cannot find matching windows.\n".join(":",@_)) if ($#hwnd_list == -1);
   foreach my $hwnd (@hwnd_list)
   {
    #print $hwnd.": ".Win32::GuiTest::GetWindowText($hwnd)."\n";
    createwindow(0,$hwnd,$ip.":".$port.":".$uri,$ip,$port,$login_name,$login_pass);
   }
  }
 }
 else # -openthumbs
 {
  &connect($ip.':'.$port,$uri,$login_name,$login_pass);
 }
}

#---- zum pruefen ob neue -openwindow gesendet wurden im openwindow.dat file
sub check_owdat()
{
 print "Info: openwindow-signal received.\n";
 if (-f $ENV{TEMP}."\\openwindow.dat")
 {
  if (open DATEI, '+<', $ENV{TEMP}."\\openwindow.dat")
  {
   flock DATEI, Fcntl->LOCK_EX;
   my $old=$/; undef $/; my $content=<DATEI>; $/=$old;
   seek DATEI, 0, 0; truncate DATEI, 0;
   close DATEI;
   foreach (split("\n",$content))
   {
    print "openwindow_oncheck: $_\n";
    openwindow(split(":",$_,6));
   }
  } else {print "Cant open: ".$ENV{TEMP}."\\openwindow.dat";}
 } else {print "Cant find: ".$ENV{TEMP}."\\openwindow.dat";}
}
#$mw->repeat(5000,\&check_owdat);

#==== zum oeffnen von fenstern mit der commandline & stoppen von mehrfachinstanzierung
@openwindow = map('-openwindow:'.$_, @openwindow);
@openthumbs = map('-openthumbs:'.$_, @openthumbs);
my @openuri = @openwindow;
push(@openuri,@openthumbs);
#my @openwindow;
#GetOptions ();
#my $another_instance_running = (grep(Win32::GUI::IsVisible($_) && Win32::GUI::GetClassName($_) eq "TkTopLevel" && index(Win32::GuiTest::GetWindowText($_),"Virtual Display Manager") == 0,Win32::GuiTest::GetChildWindows(0)) != 0)? 1: 0;
#my $another_instance_running = (grep(Win32::GUI::GetClassName($_) eq "TkTopLevel" && index(Win32::GuiTest::GetWindowText($_),"VDM: ") == 0,Win32::GuiTest::GetChildWindows(0)) != 0)? 1: 0;
my $another_instance_running = (grep(Win32::GUI::GetClassName($_) eq "VDM_SignalWindow" && Win32::GuiTest::GetWindowText($_) eq "VDM_SignalWindow",Win32::GuiTest::GetChildWindows(0)) != 0)? 1: 0;
print "another_instance_running\n" if ($another_instance_running == 1);
my $open_this_instance = 1;
if ($#openuri != -1)
{
 #---- openwindow input ueber commandline
 if ($another_instance_running)
 {
  #---- windowinput wenn client schon laeuft -> eingabe senden an den client -> exit
  print "A running client was found in this session.\n";
  print "The '-openwindow' infos will be sent to this client instance.\n";
  #print "(If this client is in another directory as the server close it and retry).\n";
  #std::writefile_append('config/openwindow.dat',join("\n",@openwindows)."\n");
  if(open WOUT,">>".$ENV{TEMP}."\\openwindow.dat")
  {
   flock (WOUT,Fcntl->LOCK_EX);
   print WOUT join("\n",@openuri);
   close WOUT; 
  }
  #---- sendmessage an client um auslesen anzuregen.
  my @winid = grep(Win32::GUI::GetClassName($_) eq "VDM_SignalWindow" && index(Win32::GuiTest::GetWindowText($_),"VDM_SignalWindow") == 0,Win32::GuiTest::GetChildWindows(0));
  print "Client_hWnd: ".join(",",@winid)."\n";
  my $result = Win32::GUI::PostMessage($winid[0],0x5000,0,0);
  print "Error: Cant send message to hWnd ".$winid[0]."\n" unless $result;
  print "EXIT.\n";
  exit;
 }
 else
 {
  #---- windowinput wenn client nicht laeuft -> fenster oeffnen
  print "Connect to Remote Windows (".($#openuri+1)."):\n";
  foreach (@openuri)
  {
   print "OPEN_URI: ".$_."\n";
   openwindow(split(":",$_,6));
  }
 }
}
else
{
 #---- normaler client start / aber exit wenn client schon offen
 exit Win32::GUI::MessageBox(0,"Another instance of VDM Client is running.\nPlease close it first.\nIf you can't see it look for a Trayicon. (box in the taskbar)\nClose it with a right-click on the icon.","Problem",MB_OK|MB_ICONASTERISK) if ($another_instance_running);
}
#---- signalwindow erstellen
my $myclass = new Win32::GUI::Class(-name=>'VDM_SignalWindow');  
my $signalwindow = new Win32::GUI::Window(-text => "VDM_SignalWindow",
                                          -class => $myclass,
                                        );
#$signalwindow->Show;
$signalwindow->Hook(0x5000, \&check_owdat);



###################################################################################
######################################################################## Mainloop #
###################################################################################
MainLoop();
exit 7;
__END__






