#!/usr/bin/perl

#use Win32::GUI::Carp qw/warningsToDialog fatalsToDialog/; # macht fehler mit B::Bytecode
use Win32::GUI;
use Win32::GUI::DIBitmap;
use IO::Socket;
use IO::Select;
use Time::HiRes;
use Digest::SHA;

#---- API Use's
use Win32::API;
my $rep_movsb_repeated = Win32::API->new('./bin/move_dll/move.dll', 'rep_movsb_repeated', 'IIIIII','I');


#==== Global Messageboxes
sub infomessbox_w32($)
{
 Win32::GUI::MessageBox($ARGV[1],$_[0],'VDM: Client Loader',0x40);
 return 1;
}
sub quesmessbox_w32($)
{
 my $answer = Win32::GUI::MessageBox($ARGV[1],$_[0],'VDM: Client Loader',0x24);
 return ($answer == 6)? 1: 0;
}
#sub retrymessbox($)
#{
# my $answer = $mw->messageBox(-title   => 'Virtual Display Manager',
#                              -message => $_[0],
#                              -type    => 'RetryCancel',
#                              -icon    => 'question',
#                              -default => 'Retry');
# return ($answer eq 'Cancel')? 0: 1;
#}

####################################################################
################################################## new socksystem ##
#---- vars
my %sockhash;
my $stream_terminator = "~#END#";
#---- getsock
sub getsock($$)
{
 my $ip   = $_[0];
 my $port = $_[1];
 my $dsock = IO::Socket::INET->new(#Listen    => SOMAXCONN,
                                   PeerAddr  => $ip,
                                   PeerPort  => $port,
                                   #LocalAddr => inet_ntoa(INADDR_ANY),
                                   #LocalPort => $portid,
                                   #Broadcast => 1,
                                   #Type => SOCK_STREAM,
                                   #Blocking => 1,
                                   Proto     => 'tcp');
 return $dsock;
}
#---- getsock + login
sub getsock_andlogin($$$$)
{
 my $ip         = $_[0];
 my $port       = $_[1];
 my $login_name = $_[2];
 my $login_pass = $_[3];

 my $dsock;
 while(not($dsock = &getsock($ip,$port)))
 { return if (! &quesmessbox_w32("Cant connect to Server.\nError message: $!\n\nTry to reconnect ?")); }

 my $publickey;
 if (not(($publickey) = &tcp_slurp($dsock,'LOGINGETPUBLIC')))
 { &infomessbox_w32("Server tcp_slurp problem on login. (1)"); return; }

 my $complexpass = $login_pass.$publickey;
 $complexpass = uc(Digest::SHA::sha1_hex($complexpass)) for (1 .. 7);

 my $pass_answer;
 if (not(($pass_answer) = &tcp_slurp($dsock,'LOGIN~'.$login_name.'/'.$complexpass)))
 { &infomessbox_w32("Server tcp_slurp problem on login. (2)"); return; }

 if ($pass_answer ne 'LOGIN_OK')
 {
  $dsock->close;
  &infomessbox_w32("Authentication problem.\nServer response: ".$pass_answer);
  return;
 }
 return $dsock;
}
#---- tcp_slurp
sub tcp_slurp($$)
{
 my $sock    = $_[0];
 my $tosend  = $_[1];

 my $theselect = IO::Select->new($sock);
 if($theselect->can_write(7))
 {
  #print "can_write\n";
  syswrite($sock,$tosend.$stream_terminator);
  my $sammelrequest;
  while($theselect->can_read(7))
  {
   #print "can_read\n";
   my $data;
   return unless (sysread($sock,$data,1000000));
   $sammelrequest .= $data;
   if ($sammelrequest =~ s/$stream_terminator$//)
   {
    return $sammelrequest;
   }
   #print "must-reread\n";
  }
 }
 close $sock;
 #print "TIMEOUT: end_tcp_slurp\n";
 return;
}
#---- login_slurp
sub login_slurp($$$$$)
{
 my $ip          = $_[0];
 my $port        = $_[1];
 my $login_name  = $_[2];
 my $login_pass  = $_[3];
 my $send_string = $_[4];
 my $ip_port     = join(':',$ip,$port);

 if (not defined $sockhash{$ip_port})
 {
   my $server_answer;
   do
   {
    return unless (($sockhash{$ip_port}) = &getsock_andlogin($ip,$port,$login_name,$login_pass));
    if (not(($server_answer) = &tcp_slurp($sockhash{$ip_port},$send_string)))
    { return if (! &quesmessbox_w32("Server tcp_slurp problem.\nTry to reconnect ?")); }
   }
   while (not defined $server_answer);
   return $server_answer;
 }
 else
 {
  if (my ($return_string) = &tcp_slurp($sockhash{$ip_port},$send_string))
  {
   return $return_string;
  }
  else
  {
   return unless (&quesmessbox_w32("Connection to Server broken.\nError message: $!\n\nTry to reconnect ?"));
   my $server_answer;
   do
   {
    return unless (($sockhash{$ip_port}) = &getsock_andlogin($ip,$port,$login_name,$login_pass));
    if (not(($server_answer) = &tcp_slurp($sockhash{$ip_port},$send_string)))
    { return if (! &quesmessbox_w32("Server tcp_slurp problem.\nTry to reconnect ?")); }
   }
   while (not defined $server_answer);
   return $server_answer;
  }
 }
}

#####################################################################
########################################################## UPDATER ##
sub windowupdater(@)
{
 my $winid            = $_[0];
 my $client_hwnd      = $_[1];
 my $nonclient_w      = $_[2];
 my $nonclient_h      = $_[3];
 my $olddib_w         = $_[4];
 my $olddib_h         = $_[5];
 my $login_name       = $_[6];
 my $login_pass       = $_[7];
 my $reload_delay     = $_[8];
 my $jpg_quality      = $_[9];
 my ($ip,$port,$hwnd) = split(':',$winid);
 my ($oldwin_w,$oldwin_h) = ($olddib_w,$olddib_h);

 delete $sockhash{$ip.':'.$port};
 my $bmpcache;
 while(my $DC = Win32::GUI::DC::GetDC($client_hwnd))
 {
  my $delay_reload = 2;
  #if(substr(sprintf("%08x",Win32::GUI::GetWindowLong($client_hwnd,-16)),0,1) == 1)#is_visible
  unless(Win32::GUI::IsIconic($client_hwnd))#is_minimized
  {
   if (my ($dataslurp) = login_slurp($ip,$port,$login_name,$login_pass,"SHOOTWINDOW~".$hwnd."~".$jpg_quality))
   {
    if ($dataslurp =~ m/^([0123])~(\d+)~(\d+)~(.*)/s)
    {
     #print "SHOOTED:$1~$2~$3~length(".length($4).")\n";
     #---- Make BMP
     #my $bmpdata = Win32::GUI::DIBitmap->newFromData($4)->SaveToData(FIF_BMP) if ($1 != 1);
     #my $bmpdata;
     #if ($1 != 1)#when not 'not changed'
     #{
     # my %opts = (binmode_stdin=>1,binmode_stdout=>1);
     # my $h = run3 './bin/libjpeg/djpeg.exe -bmp', \$4, \$bmpdata, \%opts;
     # #$bmpdata = Compress::Zlib::compress($bmpdata);
     #}
     if ($1 != 1) # when not 'not changed'
     {
      $delay_reload = 1;
      if (my $dib = Win32::GUI::DIBitmap->_newFromData(FIF_JPEG,$4,0))
      {
       my $bmpdata = $dib->_saveToData(FIF_BMP,0);
       undef $dib;
       if ($1 == 2)#partially changed
       {
        #---------------------------- bmpfusion
        my ($bmpcache_x,$bmpcache_y) = unpack('I2',substr($bmpcache,18,8));
        my ($bmpdata_x,$bmpdata_y) = unpack('I2',substr($bmpdata,18,8));
        my $bmpdata_x_mal3 = $bmpdata_x*3;
        my $bmpcache_datenbreitex_plusbugbit = $bmpcache_x*3+$bmpcache_x-int($bmpcache_x/4)*4;
        my $bmpdata_datenbreitex_plusbugbit = $bmpdata_x*3+$bmpdata_x-int($bmpdata_x/4)*4;

        my $bmpcache_ptr = unpack('I',pack('P',$bmpcache));
        my $bmpdata_ptr = unpack('I',pack('P',$bmpdata));
        my $bmpcache_startptr= $bmpcache_ptr+54+$bmpcache_datenbreitex_plusbugbit*($bmpcache_y-$bmpdata_y-$3)+$2*3;
        my $bmpdata_startptr = $bmpdata_ptr+54;
        $rep_movsb_repeated->Call($bmpdata_startptr,$bmpcache_startptr,$bmpdata_x_mal3,$bmpdata_datenbreitex_plusbugbit,$bmpcache_datenbreitex_plusbugbit,$bmpdata_y);
       }
       else
       {
        $bmpcache = $bmpdata;# if ($1 != 1);#when not 'not changed'
       }
      }
      #else { unless (&quesmessbox_w32("Loader Process Failure.\n(Image data is corrupted)\n\nRetry to load ?")) { Win32::GUI::PostMessage($client_hwnd,0x10,0,0); last; } }
     }

     #---- display image
     if (my $dib = Win32::GUI::DIBitmap->_newFromData(FIF_BMP,$bmpcache,0))
     {
      $dib->CopyToDC($DC) if (Win32::GUI::IsWindow($client_hwnd));
      my ($dib_w,$dib_h) = ($dib->GetWidth(),$dib->GetHeight());
      undef $dib;
      #---- resize client-win
      if ($dib_w != $olddib_w || $dib_h != $olddib_h)
      {
       print "Resize to: ".$dib_w.",".$dib_h."\n";
       #---- get nonclient size
       #my ($main_l,$main_t,$main_r,$main_b) = Win32::GUI::GetWindowRect($client_hwnd);
       #my ($clientX,$clientY) = (Win32::GUI::GetClientRect($client_hwnd))[2,3];
       #$nonclient_w = $main_r-$main_l-$clientX;
       #$nonclient_h = $main_b-$main_t-$clientY;
       ($nonclient_w,$nonclient_h) = ((Win32::GUI::Width($client_hwnd)-Win32::GUI::ScaleWidth($client_hwnd)),(Win32::GUI::Height($client_hwnd)-Win32::GUI::ScaleHeight($client_hwnd)));
       #---- resize
       Win32::GUI::Resize($client_hwnd,$dib_w+$nonclient_w,$dib_h+$nonclient_h);
       #Win32::GUI::Resize($client_hwnd,$dib_w,$dib_h);
       ($olddib_w,$olddib_h) = ($dib_w,$dib_h);
       ($oldwin_w,$oldwin_h) = ($dib_w,$dib_h);
      }
      #---- resize server-win
      #last if (Win32::GUI::GetWindowLong($client_hwnd,-16) == 0); # war zum testen ob win noch offen
      my ($win_w,$win_h) = (Win32::GUI::ScaleWidth($client_hwnd),Win32::GUI::ScaleHeight($client_hwnd));
      if (($win_w != $oldwin_w || $win_h != $oldwin_h) && $win_w+$win_h != 0) # != 0 zum testen ob win noch offen
      {
       print "Resize_Remote to: ".$win_w.",".$win_h."\n";
       #login_slurp($ip,$port,$login_name,$login_pass,'EVAL~Win32::GUI::Resize('.$hwnd.','.$win_w.','.$win_h.');');
       #login_slurp($ip,$port,$login_name,$login_pass,'EVAL~Win32::GUI::Resize('.$hwnd.','.($win_w+$nonclient_w).','.($win_h+$nonclient_h).');');
       login_slurp($ip,$port,$login_name,$login_pass,'ClientResize~'.$hwnd.'~'.$win_w.'~'.$win_h);
       ($olddib_w,$olddib_h) = ($win_w,$win_h);
       ($oldwin_w,$oldwin_h) = ($win_w,$win_h);
      }
     }
    }
    #---- zum schliessen wenn server-handle geschlossen (ohne popupwarnung)
    elsif ($dataslurp eq "-1") { Win32::GUI::PostMessage($client_hwnd,0x10,0,0); last; }
    #---- zum schliessen bei datenfehler (mit retrypopup)
    else { unless (&quesmessbox_w32("Loader Process Failure.\n(Data Failure ?)\n(Remote Window Closed ?)\n\nRetry to load ?")) { Win32::GUI::PostMessage($client_hwnd,0x10,0,0); last; } }
   #---- zum schliessen bei verbindungsfehler (kein warn-popup / kam eh bei slurp)
   } else { Win32::GUI::PostMessage($client_hwnd,0x10,0,0); last; }
  }
  my $released = Win32::GUI::DC::ReleaseDC($client_hwnd,$DC);
  Time::HiRes::sleep($reload_delay*$delay_reload);
  #last;
 }
 undef $bmpcache;
 close $sockhash{$ip.':'.$port};
 #undef $rawcache;
 #threads->exit();
 #threads->detach();
 print "window_killed\n";
}

windowupdater(@ARGV);
#print join(',',@ARGV)."\n";



