#!/usr/bin/perl

use std;
use IO::Socket;
use IO::Select;
use Tk;
use Tk::StatusBar;
use Tk::NoteBook;
use Tk::Balloon;
use Tk::LabFrame;
use Tk::Icon;
use Win32::Process;
use Win32::Registry;
use Cwd;
#use Win32::Daemon; 
#use Win32::Service;
#use Cwd;
use URI::file;
use Digest::SHA;
use Time::HiRes;
use Win32::GUI;
use Win32::GuiTest;

#---- Glob's
my $version_info = '2.5';

#---- CHDIR to script-dir (no -x needed)
my $abs_file = std::rx_g(Cwd::abs_path($0),"\\\\","/");
chdir(substr($abs_file,0,rindex($abs_file,"/")+1));

#---- API Use's
use Win32::API;
my $AllocConsole = Win32::API->new('Kernel32.dll','AllocConsole','','N');
my $SetConsoleTitle = Win32::API->new('Kernel32.dll','SetConsoleTitle','P','N');

#---------------- stop multi-instances
exit Win32::GUI::MessageBox(0,"Another instance of VDM Server Interface is running.\nPlease close it first.\nIf you can't see it look for a Trayicon. (right box in the taskbar)\nClose it with a right-click on the icon.","Problem",MB_OK|MB_ICONASTERISK) if (grep(Win32::GUI::GetClassName($_) eq "TkTopLevel" && index(Win32::GuiTest::GetWindowText($_),"VDM Server Interface") == 0,Win32::GuiTest::GetChildWindows(0)) != 0);

############################################################## MW CREATE
my $mw = MainWindow->new();
#--------------------------- Mainwindow OPTS
$mw->maxsize(0,0);
$mw->protocol('WM_DELETE_WINDOW', sub{$mw->state('withdraw')});
#my $main_icon = $mw->Photo(-file => "images/Flip_interface.bmp");
#$mw->Icon(-image => $main_icon);
$mw->setIcon(-file => 'images/Flip_interface.ico');
$mw->title('VDM Server Interface');

#----------------------------------------------- NOTEBOOK
my $entry_name;
my $entry_addr;
my $nb = $mw->NoteBook(-focuscolor => 'black')->pack(-expand => 1,-fill => 'y');
my $page1 = $nb->add('PageID-1', -label => 'Main',-raisecmd => sub{$entry_addr->focus;});#-bitmap => 'info');
my $page2 = $nb->add('PageID-2', -label => 'User',-raisecmd => sub{$entry_name->focus; &user_loadhash;&user_showlist;});#-bitmap => 'info');
my $page_info = $nb->add('PageID-Info', -label => 'Info');

#----------------------------------------------- STATUSBAR
my $Label_Statusbar = "";
my $sb = $mw->StatusBar();
$sb->addLabel(#-background => 'blue',
              -relief         => 'sunken',
              -textvariable   => \$Label_Statusbar);

#------------------------------------- Page-X Balloons
my $b = $mw->Balloon(-initwait => 0);

#================================================================== PAGE INFO
my $page_info_frame = $page_info->Frame(-bg => 'white',-borderwidth => 0,-padx => 0,-pady => 10)->pack(-expand => 1,-anchor => 'center');
my $logo = $mw->Photo(-file => "./images/logo_weich.bmp");
$page_info_frame->Label(-bg => 'white',-border => 0,-padx => 20,-pady => 0,-image => $logo)->pack();
$page_info_frame->Label(-bg => 'white',-border => 0,-padx => 10,-pady => 0,-text => "Virtual Display Manager\nServer Process Interface v".$version_info."\nDeveloped by Robert Xell.")->pack();
my $page_info_mailframe = $page_info_frame->Frame(-bg => 'white',-border => 0,-padx => 0,-pady => 0)->pack(-anchor => 'center');
$page_info_mailframe->Label(-bg => 'white',-border => 0,-padx => 0,-pady => 0,-text => "Email: ")->pack(-side => 'left');
my $label_mail = $page_info_mailframe->Label(-cursor => 'trek',-bg => 'white',-border => 0,-padx => 0,-pady => 0,-font => [-underline => 1,-size => 8],-text => "xenolux\@gmail.com")->pack(-side => 'right');
my $page_info_urlframe = $page_info_frame->Frame(-bg => 'white',-border => 0,-padx => 0,-pady => 0)->pack(-anchor => 'center');
$page_info_urlframe->Label(-bg => 'white',-border => 0,-padx => 0,-pady => 0,-font => [-underline => 0,-size => 8],-text => "Surf to: ")->pack(-side => 'left');
my $label_url = $page_info_urlframe->Label(-cursor => 'hand2',-bg => 'white',-border => 0,-padx => 0,-pady => 0,-font => [-underline => 1,-size => 8],-text => "http://ynea.futureware.at")->pack(-side => 'right');
$page_info_frame->Label(-bg => 'white',-border => 0,-padx => 0,-pady => 0,-text => "Thanks to Thierry Kleine.")->pack();

$mw->bind($label_mail, '<Button-1>', sub{system('start mailto:xenolux@gmail.com')});
$mw->bind($label_url , '<Button-1>', sub{system('start http://ynea.futureware.at')});

########################################################
########################################### TRAYICON ###
#my $id = 1;
#my $hwnd = Win32::GUI::GetPerlWindow(); #Win32::GUI::Hide($hwnd);
my $icon = new Win32::GUI::Icon('images/Flip_interface.ico');
my $main = Win32::GUI::Window->new(
    -name   => 'Main',
    -text   => 'Perl',
    -width  => 200,
    -height => 200,
    -visible => 0,
);
my $ni = $main->AddNotifyIcon(
    -name => "systray",
    #-id   => $id,
    -icon => $icon,
    -tip  => "------------\nVirtual\nDisplay\nManager\n------------\nServer\nInterface\n------------",
);
my $systray_menu = Win32::GUI::Menu->new(
    "SystrayMenu Function" => "SystrayMenu",
    #"trayIcon",
    "> Info"             => "Systray_Info",
    "> Config"           => "",
    ">> Server Config"   => "Systray_ServerConfig",
    ">> User Config"     => "Systray_UserConfig",
    "> Server"           => "",
    ">> Start Process"   => "Systray_Start",
    ">> Stop Process"    => "Systray_Stop",
    ">> Kill Process"    => "Systray_Kill",
    ">> Test Server"     => "Systray_Test",
    ">> Open Server Log" => "Systray_Log",
    "> Console"          => "",
    ">> Show"            => "Systray_ConsoleShow",
    ">> Hide"            => "Systray_ConsoleHide",
    "> Exit"             => "Systray_Exit",
);

#------------------------------------ tray sub's
sub Systray_Start_Click()        {&start_server_process;}
sub Systray_Stop_Click()         {&stop_server_process;}
sub Systray_Kill_Click()         {&kill_server_process;}
sub Systray_Test_Click()         {&test_server;}
sub Systray_Log_Click()          {&open_server_log;}
sub Systray_ServerConfig_Click() {$mw->state('normal'); $mw->deiconify; $nb->raise('PageID-1');}
sub Systray_UserConfig_Click()   {$mw->state('normal'); $mw->deiconify; $nb->raise('PageID-2');}
sub Systray_Info_Click()         {$mw->state('normal'); $mw->deiconify; $nb->raise('PageID-Info');}
sub systray_RightClick
{
    my($x, $y) = Win32::GUI::GetCursorPos();
    $main->TrackPopupMenu($systray_menu->{SystrayMenu}, $x, $y);
}
sub systray_Click
{
    $mw->state('normal');
    $mw->deiconify();#this is the real - bring on top
    #$mw->attributes(-topmost => 1);
    #$mw->attributes(-topmost => 0);
    $mw->bell();
}
sub Systray_Exit_Click
{
    $mw->state('normal');
    if (&quesmessbox('Do you really want to quit ?')){
        # maybe do some cleaning up and
        #Win32::GUI::NofityIcon::Remove($ni);
        #Win32::GUI::NotifyIcon::Delete( $ni, -id =>  $id );
        $ni->Remove;
        $mw->destroy();
        #return -1;
    }
}
sub Systray_ConsoleShow_Click
{
 my $hwnd = Win32::GUI::GetPerlWindow();
 if ($hwnd)
 {
  Win32::GUI::Show($hwnd);
  Win32::GUI::SetForegroundWindow($hwnd);
 }
 else
 {
  if ($AllocConsole->Call())
  {
   $SetConsoleTitle->Call("VDM: Server Interface Console");
   open(STDOUT,">CONOUT\$");
   open(STDERR,">CONOUT\$");
   open(STDIN,"<CONIN\$");
  }
 }
}
sub Systray_ConsoleHide_Click
{
 my $hwnd = Win32::GUI::GetPerlWindow();
 Win32::GUI::Hide($hwnd) if ($hwnd);
}

######################################################################### load config
my %config = split(/[\t\n]/,std::readfile('config/config_server.dat'));
my %user_settings;

#======================================================== Service Log
sub datetime()
{
 my ($Sekunden, $Minuten, $Stunden, $Monatstag, $Monat,
     $Jahr, $Wochentag, $Jahrestag, $Sommerzeit) = localtime(time);
 $Monat+=1;
 $Monat = $Monat < 10 ? $Monat = "0".$Monat : $Monat;
 $Monatstag = $Monatstag < 10 ? $Monatstag = "0".$Monatstag : $Monatstag;
 $Stunden = $Stunden < 10 ? $Stunden = "0".$Stunden : $Stunden;
 $Minuten = $Minuten < 10 ? $Minuten = "0".$Minuten : $Minuten;
 $Sekunden = $Sekunden < 10 ? $Sekunden = "0".$Sekunden : $Sekunden;
 $Jahr+=1900;
 return("$Jahr-$Monat-$Monatstag","$Stunden:$Minuten:$Sekunden");
}
sub server_log($)
{
 my ($date,$time) = &datetime;
 print "Log: ".$_[0]."\n";
 std::writefile_append('server_log\\'.$date.'.txt',$time.' '.$_[0]."\n");
}

#================================================================== PAGE 1
#-------------------------------------- Server Config
my $server_labframe = $page1->LabFrame(-label => "Server Config",
                                       #-background => 'white',
                                       -labelside => "acrosstop")->pack(-fill => 'x');
my $frame_serverconfig = $server_labframe->Frame()->pack(-expand => 1,-fill => 'x');

$frame_serverconfig->Label(-text => "Addr -> ")->grid(-column => 0,-row => 0,-sticky => 'w');
my $variable_addr = $config{addr};
$entry_addr  = $frame_serverconfig->Entry(-width => 23,
                                          -textvariable => \$variable_addr)->grid(-column => 1,-row => 0,-sticky => 'e');
$mw->bind($entry_addr,'<KeyPress>' => sub{return if($variable_addr eq $config{addr}); $config{addr}=$variable_addr; &config_save;});
$b->attach($entry_addr,-balloonmsg => "Local host bind address.\n(restart server after change)\n\nInfo:\n0.0.0.0 = all ip\n127.0.0.1 = only localhost\nor enter your ip manually");

$frame_serverconfig->Label(-text => "Port -> ")->grid(-column => 0,-row => 1,-sticky => 'w');
my $variable_port = $config{port};
my $entry_port  = $frame_serverconfig->Entry(-width => 23,
                                             #-validate => 'key',
                                             #-vcmd => \&config_save,
                                             -textvariable => \$variable_port)->grid(-column => 1,-row => 1,-sticky => 'e');
$mw->bind($entry_port,'<KeyPress>' => sub{return if($variable_port eq $config{port}); $config{port}=$variable_port; &config_save;});
$b->attach($entry_port,-balloonmsg => "Server Port\n(restart server after change)");

#-------------------------------------- Server Process Control
my $service_labframe = $page1->LabFrame(-label => "Server Process Control",
                                        #-background => 'white',
                                        -labelside => "acrosstop")->pack(-fill => 'x');
my $button_start = $service_labframe->Button(-text  => 'Start Server Process',
                                             #-bg => 'gray60',-fg => 'white',-activebackground => 'gray60',-activeforeground => 'black',
                                             #-width => 30,
                                             -command => sub{&start_server_process;})->pack(-expand => 1,-fill => 'x');
my $button_stop = $service_labframe->Button(-text  => 'Stop Server Process',
                                            -command => sub{&stop_server_process;})->pack(-expand => 1,-fill => 'x');
my $button_kill = $service_labframe->Button(-text  => 'Kill Server Process',
                                            -command => sub{&kill_server_process;})->pack(-expand => 1,-fill => 'x');
#$b->attach($button_kill,-balloonmsg => "Not recommend.\n(Use it only when it stucks)");
my $button_test = $service_labframe->Button(-text  => 'Test Server',
                                            -command => sub{&test_server;})->pack(-expand => 1,-fill => 'x');
my $button_autostart = $service_labframe->Button(-text  => 'Register Server Autostart',
                                                 -command => sub{&server_autostart;})->pack(-expand => 1,-fill => 'x');
my $button_log = $service_labframe->Button(-text  => 'Open Server Log',
                                           -command => sub{&open_server_log;})->pack(-expand => 1,-fill => 'x');

sub infomessbox($)
{
 $mw->messageBox(-title   => 'Virtual Display Manager',
                 -message => $_[0],
                 -type    => 'Ok',
                 -icon    => 'info',
                 -default => 'Ok');
 return 1;
}
sub quesmessbox($)
{
 my $answer = $mw->messageBox(-title   => 'Virtual Display Manager',
                              -message => $_[0],
                              -type    => 'YesNo',
                              -icon    => 'question',
                              -default => 'Yes');
 return ($answer eq 'No')? 0: 1;
}
my $running_pid;
my $ProcessObj; 
sub external_runningcheck()
{
 $running_pid = std::readfile('config/running_pid.dat');
 Win32::Process::Open($ProcessObj,$running_pid,PROCESS_ALL_ACCESS) if ($running_pid != 0);
}
&external_runningcheck;
$mw->repeat(10000,\&external_runningcheck);
sub start_server_process()
{
 if (user_size() == -1)
 {
  $mw->state('normal');
  $mw->deiconify();#this is the real - bring on top
  $nb->raise('PageID-2');
  infomessbox("There is no single user defined in the list.\nIt makes no sense to start the server.\nPleace add a User to the list.");
  return;
 }
 return &infomessbox("Another server process is running.\nProcess id: ".$running_pid) if ($running_pid != 0);
 Win32::Process::Create($ProcessObj,
                        'perl\bin\vdm_server_process.exe',
                        'vdm_server_process.exe server_process.pl',
                        0,
                        DETACHED_PROCESS|NORMAL_PRIORITY_CLASS,
                        '.') || return &infomessbox("Can't start server process.\nError: ".Win32::FormatMessage(Win32::GetLastError()));
 $running_pid = $ProcessObj->GetProcessID;
 std::writefile('config/running_pid.dat',$running_pid);
 $mw->after(500,\&process_UIstate);
}
sub mini_slurp($$)
{
 my $dsock = $_[0];
 my $message = $_[1];
 my $theselect = IO::Select->new($dsock);
 if($theselect->can_write(3))
 {
  syswrite($dsock,$message.'~#END#');
  my $sammelrequest;
  while($theselect->can_read(3))
  {
   #print "can_read\n";
   my $data;
   last unless (sysread($dsock,$data,1000000));
   $sammelrequest .= $data;
   if ($sammelrequest =~ s/~#END#$//)
   {
    #&infomessbox("Shutdown message successfuly transmitted to server !\nServer response: ".$sammelrequest);
    return $sammelrequest;
   }
   #print "must-reread\n";
  }
  &infomessbox("Strange data from server ".$config{addr}.":".$config{port}." !\nData: ".$sammelrequest) if (length($sammelrequest) != 0);
  &infomessbox("Can connect to server,\ncan write to server, but\ncan't read from server ".$config{addr}.":".$config{port}." !\nTimeout.") if (length($sammelrequest) == 0);
 }
 else { &infomessbox("Can connect to server, but\ncan't write to server ".$config{addr}.":".$config{port}." !\nTimeout."); }
 return;
}
sub stop_server_process()
{
 my $dsock = IO::Socket::INET->new(PeerAddr => ($config{addr} ne '0.0.0.0')?$config{addr}:'127.0.0.1',PeerPort => $config{port},Proto => 'tcp');
 &infomessbox("Can't connect to server ".$config{addr}.":".$config{port}." !\nError: $!") && return if (!$dsock);
 my $publickey;
 if (my ($publickey) = mini_slurp($dsock,'LOGINGETPUBLIC'))
 {
  my ($first_user) = keys %user_settings;
  my $complexpass = $user_settings{$first_user}.$publickey;
  $complexpass = uc(Digest::SHA::sha1_hex($complexpass)) for (1 .. 7);
  if (my ($login_response) = mini_slurp($dsock,'LOGIN~'.$first_user.'/'.$complexpass))
  {
   if (my ($shutdown_response) = mini_slurp($dsock,'SHUTDOWN'))
   {
    &infomessbox("Shutdown message successfuly transmitted to server !\nLogin response: ".$login_response."\nShutdown response: ".$shutdown_response);
    $mw->after(1000,\&process_UIstate);
   } else { &infomessbox("No response after sending shutdown message.\nLogin_Response: ".$login_response); }
  } else { &infomessbox('Cant send login to server or no response.'); }
 } else { &infomessbox('Cant send login to server or no response.'); }
 close $dsock;
}
sub kill_server_process()
{
 return if (!&quesmessbox("Not recommend !\n(Use it only when the server stuck)\n\n Do you really want to kill the process ?"));
 &infomessbox("Cant kill process id '".$running_pid."'.") unless (Win32::Process::KillProcess($running_pid,0));
 $mw->after(500,\&process_UIstate);
}
sub server_autostart()
{
 $HKEY_CURRENT_USER->Open('Software\Microsoft\Windows\CurrentVersion\Run',my $hkey) or return &infomessbox('Error: No "Run" directory found in registry.');
 if($hkey->QueryValueEx('VDM_Server_Process',my $type,my $value))
 {
  $hkey->DeleteValue('VDM_Server_Process');
  $button_autostart->configure(-text => 'Register Server Autostart');
 }
 else
 {
  my $mycwd = Cwd::getcwd;
  $mycwd =~ s/\//\\/g;
  $hkey->SetValueEx('VDM_Server_Process',1,1,$mycwd.'\perl\bin\vdm_server_process.exe -x'.$mycwd.' '.$mycwd.'\server_process.pl');
  $button_autostart->configure(-text => 'Server Autostart Remove');
 }
 $hkey->Close();
}
$HKEY_CURRENT_USER->Open('Software\Microsoft\Windows\CurrentVersion\Run',my $hkey) or warn 'Error: No "Run" directory found in registry.';
$button_autostart->configure(-text => ($hkey->QueryValueEx('VDM_Server_Process',my $type,my $value))?'Server Autostart Remove':'Register Server Autostart');
$hkey->Close();
sub test_server()
{
 my $dsock = IO::Socket::INET->new(PeerAddr => ($config{addr} ne '0.0.0.0')?$config{addr}:'127.0.0.1',PeerPort => $config{port},Proto => 'tcp');
 &infomessbox("Can't connect to server ".$config{addr}.":".$config{port}." !\nError: $!") && return if (!$dsock);
 my $publickey;
 if (my ($publickey) = mini_slurp($dsock,'LOGINGETPUBLIC'))
 {
  my ($first_user) = keys %user_settings;
  my $complexpass = $user_settings{$first_user}.$publickey;
  $complexpass = uc(Digest::SHA::sha1_hex($complexpass)) for (1 .. 7);
  if (my ($login_response) = mini_slurp($dsock,'LOGIN~'.$first_user.'/'.$complexpass))
  {
   if (my ($server_response) = mini_slurp($dsock,'TEST'))
   {
    &infomessbox("Login response: ".$login_response."\nServer response: ".$server_response);
   } else { &infomessbox("No response after sending shutdown message.\nLogin_Response: ".$login_response); }
  } else { &infomessbox('Cant send login to server or no response.'); }
 } else { &infomessbox('Cant send login to server or no response.'); }
 close $dsock;
}
my %log_cachesize;
my %log_textbox;
my %log_lastpath;
sub log_updater($)
{
 my $log_id = $_[0];
 my ($date,$time) = &datetime;
 my $logfilepath = 'server_log\\'.$date.'.txt';
 $log_cachesize{$log_id} = 0 if ($logfilepath ne $log_lastpath{$log_id});
 $log_lastpath{$log_id} = $logfilepath;
 #return &infomessbox("No Logfile: ".$logfilepath) if (! -f $logfilepath);
 return if (! -f $logfilepath);
 my $log_actualsize = -s $logfilepath;
 if ($log_actualsize != $log_cachesize{$log_id})
 {
  sysopen(DATEI, $logfilepath, O_RDONLY) || return &infomessbox("cant_open($logfilepath): $!");
  sysseek(DATEI, $log_cachesize{$log_id}, 0);
  my $log_part = '';
  sysread(DATEI, $log_part, $log_actualsize-$log_cachesize{$log_id});
  close(DATEI);
  $log_part =~ s/\r//g; # xp symbol problem at lineend
  $log_cachesize{$log_id} = $log_actualsize;
  $log_textbox{$log_id}->insert("end", $log_part);
  $log_textbox{$log_id}->yviewMoveto(1);
 }
}
sub open_server_log()
{
 my $log_mw = MainWindow->new(-width=>"640",-height=>"480");
 #$log_mw->configure (-width=>"640",-height=>"480");
 $log_mw->setIcon(-file => 'images/Flip_interface.ico');
 $log_mw->title('VDM Server Log');
 $log_mw->geometry("640x480");
 my $log_id = $log_mw->id;
 $log_cachesize{$log_id} = 0;

 #---- balloon for this window
 my $log_b = $log_mw->Balloon(-initwait => 0);

 my $topframe          = $log_mw->Frame()->pack(-side=>'top',-expand => 1,-fill => 'both');
 my $bottomframe       = $log_mw->Frame()->pack(-side=>'bottom',-expand => 0,-fill => 'both');
 my $topframe_left     = $topframe->Frame()->pack(-side=>'left',-expand => 1,-fill => 'both');
 my $topframe_right    = $topframe->Frame()->pack(-side=>'right',-expand => 0,-fill => 'y');
 my $bottomframe_left  = $bottomframe->Frame()->pack(-side=>'left',-expand => 1,-fill => 'x');
 my $bottomframe_right = $bottomframe->Frame()->pack(-side=>'right',-expand => 0,-fill => 'x');

 $log_textbox{$log_id} = $topframe_left->Scrolled("Text",
                                              -scrollbars => "osoe",
                                              -height      => 20,   # 5 lines high
                                              -background  => 'black',
                                              -foreground  => 'white',
                                              -width       => 8,
                                              -wrap        => 'none')->pack(-expand => 1,-fill => 'both');

 my $clearbutton = $bottomframe_right->Label(-cursor => 'hand2',-text=>'clear',-underline=>1)->pack();
 $clearbutton->bind("<ButtonPress-1>", sub {$log_textbox{$log_id}->delete('1.0','end')});
 $log_b->attach($clearbutton,-balloonmsg => "Clears the Log-Window.\nThis does not delete the Log-File.\nYou can reopen the Log-Window to see all messages today.");

 &log_updater($log_id);
 $log_mw->repeat(2000,sub{&log_updater($log_id)});
}
sub process_UIstate()
{
 #my $mw_state = $mw->state;
 #return if ($mw_state ne 'normal' && $mw_state ne 'zoomed'); #return when window not shown
 if ($running_pid == 0) 
 { &process_UIshow(0); }
 else 
 {
  my $running_pid_old = $running_pid;
  my $exitcode;
  $ProcessObj->GetExitCode($exitcode);
  &process_UIshow(($exitcode==259)?1:0); 
  #print "code: $exitcode\n";
  if ($exitcode != 259)
  {
   $running_pid = 0;
   std::writefile('config/running_pid.dat',0);
   if ($exitcode != 7)
   {
    &server_log("pid ".$running_pid_old.": Warning: Interface detects abnormal server exit. (exitcode:".$exitcode.")");
    &infomessbox("Warning: Server process exits abnormally.\nExitcode: ".$exitcode."\nSee Log."); 
   }
  }
 }
}
my %process_UIdesc = (1 => 'Process running.',
		      0 => 'Process stopped.');
my %process_disablings = (#     IUSS
                          1 => 'xooo',
		          0 => 'oxxx');
my $xstate_last = -1;
sub process_UIshow($)
{
 my $xstate = $_[0];
 if ($xstate != $xstate_last)
 {
  if ($xstate == 0)
  {
   $running_pid = 0;
   std::writefile('config/running_pid.dat',0);
  }
  $Label_Statusbar = $process_UIdesc{$xstate};
  my @disablings = split('',$process_disablings{$xstate});
  $button_start->configure(-state => ($disablings[0] eq 'x')?'disabled':'normal');
  $button_stop ->configure(-state => ($disablings[1] eq 'x')?'disabled':'normal');
  $button_kill ->configure(-state => ($disablings[2] eq 'x')?'disabled':'normal');
  $button_test ->configure(-state => ($disablings[3] eq 'x')?'disabled':'normal');
  $systray_menu->{Systray_Start}->Change(-enabled => ($disablings[0] eq 'x')?0:1);
  $systray_menu->{Systray_Stop} ->Change(-enabled => ($disablings[1] eq 'x')?0:1);
  $systray_menu->{Systray_Kill} ->Change(-enabled => ($disablings[2] eq 'x')?0:1);
  $systray_menu->{Systray_Test} ->Change(-enabled => ($disablings[3] eq 'x')?0:1);
  $entry_addr->configure(-state => ($xstate == 1)?'disabled':'normal');
  $entry_port->configure(-state => ($xstate == 1)?'disabled':'normal');
 }
 $xstate_last = $xstate;
}
$mw->repeat(4000,\&process_UIstate); #run every x ms
&process_UIstate; #run yet too
#sub service_install()
#{
#    (my $server_file   = URI::file->new('server_service.pl','win32')->abs(URI::file->cwd)->file)=~s/\\/\//g;
#    (my $server_folder = URI::file->new('','win32')->abs(URI::file->cwd)->dir)=~s/\\/\//g;
#    if (! -e $server_file)
#    {
#     $mw->messageBox(-title   => 'Virtual Display Manager',
#                     -message => 'Can\'t find: '.$server_file,
#                     -type    => 'Ok',
#                     -icon    => 'info',
#                     -default => 'Ok');
#     return;
#    }
#    my %Hash = (
#                machine     => '',
#                name        => 'VDM_Server',
#                display     => 'VDM_Server',
#                path        => $^X,#path to perl.exe
#                user        => '',
#                pwd         => '',
#                description => 'Virtual Display Manager Server Service',
#                parameters  => '"-x'.$server_folder.'" "'.$server_file.'" -service'
#               );
#    if( Win32::Daemon::CreateService( \%Hash ) )
#    { $Label_Statusbar = "Successfully added."; }
#    else
#    {
#     my $errormess = "Failed to add service: ".Win32::FormatMessage(Win32::Daemon::GetLastError());
#     infomessbox($errormess);
#    }
#}
#sub service_delete()
#{
#    if( Win32::Daemon::DeleteService('','VDM_Server') )
#    { $Label_Statusbar = "Successfully removed."; }
#    else
#    {
#     my $errormess = "Failed to remove service: ".Win32::FormatMessage(Win32::Daemon::GetLastError());
#     infomessbox($errormess);
#    }
#}
#sub service_start()
#{
# if (user_size() == -1)
# {
#  $mw->state('normal');
#  $mw->deiconify();#this is the real - bring on top
#  $nb->raise('PageID-2');
#  infomessbox("There is no single user defined in the list.\nIt makes no sense to start the server.\nPleace add a User to the list.");
#  return;
# }
# my %state;
# if (!Win32::Service::GetStatus('', 'VDM_Server', \%state))
# { infomessbox("Cannot read service state.\nIs the service installed?"); return; }
# my $state = $state{CurrentState};
# if ($state != 1)
# { infomessbox("Can't Start Service.\nThis Needs State: SERVICE_STOPPED\nActual State: ".$service_UIstatedesc{$state}); return; }
# if (Win32::Service::StartService('', 'VDM_Server'))
# { $Label_Statusbar = "Service start pending."; $mw->after(1200,\&service_UIstate); }
# else
# { infomessbox("Can't Start Service.\nActual State: ".$service_UIstatedesc{$state}); }
#}
#sub service_stop()
#{
# my %state;
# if (!Win32::Service::GetStatus('', 'VDM_Server', \%state))
# { infomessbox("Cannot read service state.\nIs the service installed?"); return; }
# my $state = $state{CurrentState};
# if ($state == 1)
# { infomessbox("Can't Stop Service.\nService already stopped."); return; }
# if (Win32::Service::StopService('', 'VDM_Server'))
# { $Label_Statusbar = "Service stop pending."; $mw->after(1200,\&service_UIstate); }
# else
# { infomessbox("Can't Stop Service.\nActual State: ".$service_UIstatedesc{$state}); }
#}
#sub service_check()
#{
# my %state;
# if (!Win32::Service::GetStatus('', 'VDM_Server', \%state))
# { infomessbox("Cannot read service state.\nIs the service installed?"); return; }
# infomessbox($service_UIstatedesc{$state{CurrentState}});
#}
#sub service_UIstate()
#{
# my $mw_state = $mw->state;
# return if ($mw_state ne 'normal' && $mw_state ne 'zoomed'); #return when window not shown
# my %state;
# my $xstate;
# if (!Win32::Service::GetStatus('', 'VDM_Server', \%state))
# { $xstate = 0; }
# else
# { $xstate = $state{CurrentState}; }
# &service_UIshow($xstate);
#}
#my %service_UIdesc = (5 => 'Service continue pending.',
#                      6 => 'Service pause pending.',
#                      7 => 'Service paused.',
#                      4 => 'Service started.',
#                      2 => 'Service start pending.',
#                      3 => 'Service stop pending.',
#                      1 => 'Service stoped.',
#		      0 => 'Can\'t see service.');
#my %service_disablings = (#     IUSS
#                          5 => 'xxxo',
#                          6 => 'xxxo',
#                          7 => 'xxxo',
#                          4 => 'xxxo',
#                          2 => 'xxxo',
#                          3 => 'xxxo',
#                          1 => 'xoox',
#		          0 => 'oxxx');
#my $xstate_last = -1;
#sub service_UIshow($)
#{
# my $xstate = $_[0];
# if ($xstate != $xstate_last)
# {
#  $Label_Statusbar = $service_UIdesc{$xstate};
#  my @disablings = split('',$service_disablings{$xstate});
#  #($disablings[0] eq 'x')? $button_install  ->configure(-state => 'disabled'): $button_install  ->configure(-state => 'normal');
#  #($disablings[1] eq 'x')? $button_uninstall->configure(-state => 'disabled'): $button_uninstall->configure(-state => 'normal');
#  #($disablings[2] eq 'x')? $button_start    ->configure(-state => 'disabled'): $button_start    ->configure(-state => 'normal');
#  #($disablings[3] eq 'x')? $button_stop     ->configure(-state => 'disabled'): $button_stop     ->configure(-state => 'normal');
#  $button_install  ->configure(-state => ($disablings[0] eq 'x')?'disabled':'normal');
#  $button_uninstall->configure(-state => ($disablings[1] eq 'x')?'disabled':'normal');
#  $button_start    ->configure(-state => ($disablings[2] eq 'x')?'disabled':'normal');
#  $button_stop     ->configure(-state => ($disablings[3] eq 'x')?'disabled':'normal');
#  $systray_menu->{Systray_Install}  ->Change(-enabled => ($disablings[0] eq 'x')?0:1);
#  $systray_menu->{Systray_Uninstall}->Change(-enabled => ($disablings[1] eq 'x')?0:1);
#  $systray_menu->{Systray_Start}    ->Change(-enabled => ($disablings[2] eq 'x')?0:1);
#  $systray_menu->{Systray_Stop}     ->Change(-enabled => ($disablings[3] eq 'x')?0:1);
# }
# $xstate_last = $xstate;
#}
#$mw->repeat(4000,\&service_UIstate); #run every x ms
#&service_UIstate; #run yet too

#------------------------- config save
sub config_save()
{
 my @lines;
 push(@lines,$_."\t".$config{$_}) foreach(keys %config);
 std::writefile('config/config_server.dat',join("\n",@lines));
 print "config_saved\n";
}

#================================================================== PAGE 2 (user)
#------------------ add or edit user
my $labframe_user = $page2->LabFrame(-label => "Add or Edit User",
                                     -labelside => "acrosstop")->pack(-fill => 'x');
my $frame_namepass = $labframe_user->Frame()->pack(-expand => 1,-fill => 'x');

$frame_namepass->Label(-text => "Name -> ")->grid(-column => 0,-row => 0,-sticky => 'w');
my $variable_name;
$entry_name = $frame_namepass->Entry(-width => 22,
                                     -textvariable => \$variable_name)->grid(-column => 1,-row => 0,-sticky => 'e');
$b->attach($entry_name,-balloonmsg => "Server login name.");

$frame_namepass->Label(-text => "Pass -> ")->grid(-column => 0,-row => 1,-sticky => 'w');
my $variable_pass;
my $entry_pass = $frame_namepass->Entry(-width => 22,
                                        -textvariable => \$variable_pass)->grid(-column => 1,-row => 1,-sticky => 'e');
$b->attach($entry_pass,-balloonmsg => "Server login password.");

#------------------ saved user
my $labframe_saveduser = $page2->LabFrame(-label => "Saved User",
                                          -labelside => "acrosstop")->pack(-expand => 1,-fill => 'both');
#my $variable_savename;
#my $entry_password  = $labframe_saveduser->Entry(-width => 10,
#                                                 -textvariable => \$variable_savename)->pack(-fill => 'x');
#$b->attach($entry_password,-balloonmsg => "Write here the Savename if needed.\nIf blank the Username will be used.");
my $list = $labframe_saveduser->Scrolled('Listbox',
                                         -width => 20,
                                         -height => 5,
                                         -setgrid => 0,
                                         -scrollbars => 'e')->pack(-side => 'top',-expand => 1,-fill => 'both');
$list->bind('<Double-1>' => sub{ &user_edit; });
$list->bind("<Enter>", sub { $list->focus });
$b->attach($list,-balloonmsg => "Saved User List.\n(Doubleclick to edit a saved user.)\n\nInfo: You must restart the Server after change.");

$labframe_saveduser->Button(-text  => 'Save',
                            -width => 6,
                            -command => [\&user_save])->pack(-expand => 1,-side => 'left',-fill => 'x');
$labframe_saveduser->Button(-text  => 'Delete',
                            -width => 6,
                            -command => [\&user_delete])->pack(-expand => 1,-side => 'left',-fill => 'x');
$labframe_saveduser->Button(-text  => 'Edit',
                            -width => 6,
                            -command => [\&user_edit])->pack(-expand => 1,-side => 'right',-fill => 'x');

#------------------ user subs
sub user_loadhash()
{
 foreach my $line (std::readfile_array('config/config_server_users.dat'))
 {
  #my ($savename,$data) = split("\t",$line,2);
  #$user_settings{$savename} = {split("\t",$data)};
  my ($name,$pass) = split("\t",$line);
  $user_settings{$name} = $pass;
 }
}
user_loadhash();
sub user_savehash()
{
 #std::writefile('config/user.dat',join("\n",map($_."\t".join("\t",%{$user_settings{$_}}),keys(%user_settings))));
 std::writefile('config/config_server_users.dat',join("\n",map($_."\t".$user_settings{$_}."\t",keys(%user_settings))));
}
sub user_showlist()
{
 $list->delete(0,'end');
 $list->insert(0,sort(keys(%user_settings)));
}
sub user_save
{
 return if ($variable_name eq '' && infomessbox('Pleace enter a name.'));
 return if ($variable_pass eq '' && !quesmessbox('Do you really want to set an empty password ?'));
 if ($variable_pass !~ m/^KEY-/)
 {
  my $sha1 = $variable_pass;
  for(1..20)
  {
   $sha1 = uc(Digest::SHA::sha1_hex($sha1));
   $variable_pass = 'KEY-'.$sha1;
   $mw->update;
   Time::HiRes::sleep(0.02);
  }
 }
 #my $savename = ($variable_savename eq '')? $variable_name: $variable_savename;
 return if (defined $user_settings{$variable_name} && !quesmessbox("Name '".$variable_name."' already exists.\nDo you want to overwrite it ?"));
 $user_settings{$variable_name} = $variable_pass;
 &user_showlist;
 &user_savehash;
 ($variable_name,$variable_pass) = ('','');
}
sub user_delete()
{
 my $active = $list->get('active');
 return if ($active eq '');
 return if (!quesmessbox('Really delete \''.$active.'\' ?'));
 delete $user_settings{$active};
 &user_showlist;
 &user_savehash;
}
sub user_edit()
{
 my $active = $list->get('active');
 return if ($active eq '');
 #$variable_savename = $active;
 $variable_name     = $active;
 $variable_pass     = $user_settings{$active};
}
sub user_size()
{
 return $#{[keys %user_settings]};
}

###################################################################################
######################################################################## Mainloop #
###################################################################################
MainLoop();
exit 7;
__END__



