#!/usr/bin/perl

#---- CHDIR to script-dir (no -x needed) / With BEGIN block to write error-log in the right directory
use Cwd;
#BEGIN # begin subs wont work with bytecoded
#{
# my $abs_file = Cwd::abs_path($0); $abs_file =~ s/\\/\//g;
# chdir(substr($abs_file,0,rindex($abs_file,"/")+1));
#}
my $abs_file = Cwd::abs_path($0); $abs_file =~ s/\\/\//g;
chdir(substr($abs_file,0,rindex($abs_file,"/")+1));

#---- server_log_write muss vor stderr_redirect sein damit errors vor der laufzeit (zb: "use nonexistent;") die subroutine finden
sub server_log_write($)
{
 my ($Sekunden, $Minuten, $Stunden, $Monatstag, $Monat, $Jahr, $Wochentag, $Jahrestag, $Sommerzeit) = localtime(time); $Monat+=1; $Monat = $Monat < 10 ? $Monat = "0".$Monat : $Monat; $Monatstag = $Monatstag < 10 ? $Monatstag = "0".$Monatstag : $Monatstag; $Stunden = $Stunden < 10 ? $Stunden = "0".$Stunden : $Stunden; $Minuten = $Minuten < 10 ? $Minuten = "0".$Minuten : $Minuten; $Sekunden = $Sekunden < 10 ? $Sekunden = "0".$Sekunden : $Sekunden; $Jahr+=1900;
 my ($date,$time) = ("$Jahr-$Monat-$Monatstag","$Stunden:$Minuten:$Sekunden");
 open(DATEI, '>>'.'server_log\\'.$date.'.txt') || print "Error: Cant append error to logfile.\n"; 
 print DATEI $time.' pid '.$$.': '.$_[0]."\n"; 
 close(DATEI);
}

#---- stderr_redirect (must be as early as possible)
use stderr;
sub errors { foreach(map(split("\n",$_),@_)) { print "$_ !\n"; server_log_write("WARN: ".$_); } }
#BEGIN { tie(*STDERR => 'stderr', \&errors); }
tie(*STDERR => 'stderr', \&errors);

#==== my Use's
require std;

#---- Server Use's
#use Socket;
use IO::Socket;
#use IO::Socket::INET;
#use IO::Socket::INET::Daemon;
use IO::Select;
#use MIME::Base64;
use Time::HiRes;
#use Compress::Zlib;
#use IPC::Run3; #for_djpeg.exe
use Win32API::Process;
use Digest::SHA;
#use Cwd;
#use Getopt::Long;
#my %h; GetOptions (\%h, 'service+');

#---------------- GUI Use's
use Win32::GuiTest;# qw(FindWindowLike IsWindowVisible GetWindowRect ShowWindow SetForegroundWindow SendKeys ScreenToClient);
use Win32::GUI;
use Win32::GUI::DIBitmap;
use Win32::GUI::Constants qw(WM_PAINT WM_SETREDRAW);

##---- CHDIR to script-dir (no -x needed)
#my $abs_file = std::rx_g(Cwd::abs_path(__FILE__),"\\\\","/");
#chdir(substr($abs_file,0,rindex($abs_file,"/")+1));

#---------------- API Use's
use Win32::API;
use Win32::API::Callback; 
my @api_errorlog;
sub API($$$$)
{
 #my ($api_dll,$api_name,$api_in,$api_out) = @_;
 my $api_handle = Win32::API->new(@_);
 push(@api_errorlog,'Can\'t import API '.$_[1].'('.$_[0].'): '.$!) if (not defined $api_handle);
 return $api_handle;
}
my $bmpshrink2                 = API('./bin/bmpshrink2/bmpshrink2.dll','bmpshrink2','PPPPP', 'I');
my $bmpshrink3                 = API('./bin/bmpshrink3/bmpshrink3.dll','bmpshrink3','PPPPP', 'I');
#my $rep_movsb                  = API('./bin/move_dll/move.dll','rep_movsb','III','I');
my $CreateBitmap               = API('Gdi32.dll','CreateBitmap','IIIII','I');
my $CreateCompatibleDC         = API('Gdi32.dll','CreateCompatibleDC','I','I');
my $CreateSolidBrush           = API('Gdi32.dll','CreateSolidBrush','I','I');
my $DeleteDC                   = API('Gdi32.dll','DeleteDC','I','I');
my $DeleteObject               = API('Gdi32.dll','DeleteObject','I','I');
my $SelectObject               = API('Gdi32.dll','SelectObject','II','I');
my $GetModuleFileNameEx        = API('Psapi.dll','GetModuleFileNameEx','IIPI','I');
my $GetClassLong               = API('User32.dll','GetClassLong','II','I');
my $DrawIconEx                 = API('User32.dll','DrawIconEx','IIIIIIIII','I');
my $FillRect                   = API('User32.dll','FillRect','IPI','I');
my $GetAncestor                = API('User32.dll','GetAncestor','II','I');
my $SetLayeredWindowAttributes = API('User32.dll','SetLayeredWindowAttributes','IIII','I');
my $GetUpdateRect              = API('User32.dll','GetUpdateRect','IPI','I');
my $EnumDisplayMonitors        = API('User32.dll', 'EnumDisplayMonitors', 'IIKI', 'I');
my $GetMonitorInfo             = API('User32.dll', 'GetMonitorInfo', 'IP', 'I');
my $CreateDC                   = API('Gdi32.dll','CreateDCA','PIII','I');
my $CreateCompatibleBitmap     = API('Gdi32.dll','CreateCompatibleBitmap','III','I');
my $BitBlt                     = API('Gdi32.dll','BitBlt','IIIIIIIII','I');
my $GetDIBits                  = API('Gdi32.dll', 'GetDIBits', 'IIIIIPI', 'I');
my $GetDIBits2                 = API('Gdi32.dll', 'GetDIBits', 'IIIIIII', 'I');
#my $RedrawWindow               = API('User32.dll','RedrawWindow','IPII','I');
my $ReleaseDC                  = API('User32.dll' , 'ReleaseDC', 'II', 'I');
#my $RealChildWindowFromPoint   = API('User32.dll','RealChildWindowFromPoint','III','I');
#my $ChildWindowFromPointEx     = API('User32.dll','ChildWindowFromPointEx','IIII','I');
#my $ChildWindowFromPoint       = API('User32.dll','ChildWindowFromPoint','III','I');
#my $DrawIcon                   = API('User32.dll','DrawIcon','IIII','I');
#my $GetDC                      = API('User32.dll','GetDC','I','I');
my $GetWindowDC                = API('User32.dll','GetWindowDC','I','I');
#my $PrintWindow                = API('User32.dll','PrintWindow','III','I');
#my $GetWindowLong              = API('Gdi32.dll','GetWindowLong','II','I');
#my $OpenWindowStation       = API('User32.dll','OpenWindowStation','PII','I');
#my $SetProcessWindowStation = API('User32.dll','SetProcessWindowStation','I','I');
#my $OpenDesktop             = API('User32.dll','OpenDesktop','PIII','I');
#my $SetThreadDesktop        = API('User32.dll','SetThreadDesktop','I','I');
#my $DefWindowProc           = API('User32.dll','DefWindowProc','IIII','I');

my $GetKeyboardState = API('User32.dll','GetKeyboardState','P','I');
my $SetKeyboardState = API('User32.dll','SetKeyboardState','P','I');
my $keybd_event = API('User32.dll','keybd_event','IIII','I');
my $GetFocus = API('User32.dll','GetFocus','','I');
my $SendMessage = API('User32.dll','SendMessage','IIII','I');
my $GetCurrentThreadId = API('Kernel32.dll','GetCurrentThreadId','','I');

my $DwmIsCompositionEnabled = API('Dwmapi.dll','DwmIsCompositionEnabled','P'   ,'I') if ((Win32::GetOSVersion())[1] > 5);
my $DwmGetWindowAttribute   = API('Dwmapi.dll','DwmGetWindowAttribute'  ,'IIPI','I') if ((Win32::GetOSVersion())[1] > 5);
my $DwmSetWindowAttribute   = API('Dwmapi.dll','DwmSetWindowAttribute'  ,'IIPI','I') if ((Win32::GetOSVersion())[1] > 5);

#======================================================= WindowTolient
#sub WindowToClient($)
#{
# my $hwnd = $_[0];
# my ($clientX,$clientY) = ScreenToClient($hwnd,0,0);
# my ($wl,$wt,$wr,$wb) = Win32::GUI::GetWindowRect($hwnd);
# my ($cl,$ct,$cr,$cb) = Win32::GUI::GetClientRect($hwnd);
# return ($clientX*-1-$wl,$clientY*-1-$wt,$cr,$cb);
#}

#======================================================= Start Stop Stream
my %ancestors_layered;
my @bmpcache;
my @fileno_ancestor;
my @fileno_tested;
my $buffer = "";
sub start_stream($$)
{
 my $fileno = $_[0];
 my $hWnd   = $_[1];
 #return if (defined $bmpcache[$fileno]);
 return if (defined $fileno_tested[$fileno]);
 $fileno_tested[$fileno] = 1;

 #---- switch window to layered or count up
 my $ancestor = $GetAncestor->Call($hWnd,2);
 if (not defined $ancestors_layered{$ancestor})
 {
  my $oldlongext = Win32::GUI::GetWindowLong($ancestor,-20);
  if (($oldlongext & 0x80000) != 0x80000)
  {
   Win32::GUI::SendMessage($hWnd,WM_SETREDRAW,0,0);
   Win32::GUI::SetWindowLong($ancestor,-20,$oldlongext|0x00080000);
   Win32::GUI::SendMessage($hWnd,WM_SETREDRAW,1,0);
   $SetLayeredWindowAttributes->Call($ancestor,0,255,2);
   $ancestors_layered{$ancestor} = 1;#$oldlongext;
   $fileno_ancestor[$fileno] = $ancestor;
   Time::HiRes::sleep(0.2);
  }
 }
 else
 { $ancestors_layered{$ancestor}++; }
}
sub stop_stream($)
{
 my $fileno = $_[0];
 delete $bmpcache[$fileno];
 delete $fileno_tested[$fileno];
 undef $buffer;

 return if (not defined $fileno_ancestor[$fileno]);
 my $ancestor = $fileno_ancestor[$fileno];
 if (defined $ancestors_layered{$ancestor})
 {
  if (--$ancestors_layered{$ancestor} <= 0)
  {
   #hash loeschen und fenster unlayern
   delete $ancestors_layered{$ancestor};
   Win32::GUI::SetWindowLong($ancestor,-20,Win32::GUI::GetWindowLong($ancestor,-20)&0xFFF7FFFF);
  }
 }
}

#======================================================= ShootWindow
sub ShootWindow
{
 my $fileno      = $_[0];
 my $hWnd        = $_[1];
 my $jpg_quality = $_[2];

 #---- switch window to layered
 start_stream($fileno,$hWnd);

 ##---- switch window to layered
 #my $ancestor = $GetAncestor->Call($hWnd,2);
 #if (not defined $ancestors_layered{$ancestor})
 #{
 # my $oldlongext = Win32::GUI::GetWindowLong($ancestor,-20);
 # if (($oldlongext & 0x80000) != 0x80000)
 # {
 #  Win32::GUI::SetWindowLong($ancestor,-20,$oldlongext|0x00080000);
 #  $SetLayeredWindowAttributes->Call($ancestor,0,255,2);
 #  $ancestors_layered{$ancestor} = $oldlongext;
 #  Time::HiRes::sleep(0.2);
 # }
 #}

 if (Win32::GuiTest::IsWindowVisible($hWnd) && (my $dib = Win32::GUI::DIBitmap->newFromWindow($hWnd,1)))
 #if (my $dib = Win32::GUI::DIBitmap->newFromWindow($hWnd))
 {
  #$dib->SaveToFile("test.jpeg");
  my $data = $dib->_saveToData(FIF_BMP,0);
  undef $dib;

  #---- bmpshrink_moreperl
  my $bmp_left = pack('I',0);
  my $bmp_top = pack('I',0);
  my $bmp_size = pack('I',0);
  my $bmp_shrinkstate = 0;
  if (not defined $bmpcache[$fileno])
  {
   $bmp_shrinkstate = 0;
   $bmpcache[$fileno] = $data;
  }
  else
  {
   #my ($bmpcache_x,$bmpcache_y) = unpack('I2',substr($bmpcache[$fileno],18,8));
   #my ($bmpdata_x,$bmpdata_y) = unpack('I2',substr($data,18,8));
   #if ($bmpcache_x != $bmpdata_x || $bmpcache_y != $bmpdata_y)
   my $bmpcache_xydata = substr($bmpcache[$fileno],18,8);
   my $bmpdata_xydata  = substr($data,18,8);
   if ($bmpcache_xydata ne $bmpdata_xydata)
   {
    $bmp_shrinkstate = 0;
    $bmpcache[$fileno] = $data;
   }
   else
   {
    $bmp_shrinkstate = $bmpshrink2->Call($bmpcache[$fileno],$data,$bmp_left,$bmp_top,$bmp_size);
    #$data = substr($data,0,unpack('I',$bmp_size)) if ($bmp_shrinkstate == 2);#un-needed when libjpg cuts it
    #print "bmp_shrinkstate: ".$bmp_shrinkstate."\n";
    #print "bmp_left: ".unpack('I',$bmp_left)."\n";
    #print "bmp_top: ".unpack('I',$bmp_top)."\n";
    #print "bmp_size: ".unpack('I',$bmp_size)."\n";
   }
  }

  #---- Make Jpeg
  #my $output = Win32::GUI::DIBitmap->newFromData($data)->SaveToData(FIF_JPEG,$jpg_quality) if ($bmp_shrinkstate != 1);
  my $output; if ($bmp_shrinkstate != 1 && (my $dib = Win32::GUI::DIBitmap->_newFromData(FIF_BMP,$data,0))) { $output = $dib->_saveToData(FIF_JPEG,$jpg_quality); undef $dib; }
  #my $output;
  #if ($bmp_shrinkstate != 1)#when not 'not changed'
  #{
  # #my %opts = (binmode_stdin=>1,binmode_stdout=>1);
  # #my $h = run3 './bin/libjpeg/cjpeg.exe', \$data, \$output, \%opts;
  # ##$output = Compress::Zlib::compress($output);
  #}

  return(join('~',0,0,0,$output)) if ($bmp_shrinkstate == 0);#window-size changed (like all changed)
  return(join('~',1,0,0,0)) if ($bmp_shrinkstate == 1);#nothing changed
  return(join('~',2,unpack('I',$bmp_left),unpack('I',$bmp_top),$output)) if ($bmp_shrinkstate == 2);#partially changed
  return(join('~',3,0,0,$output)) if ($bmp_shrinkstate == 3);#all changed
 }
 return -1;
}

#==== ShootWindow_ONCE
sub ShootWindow_ONCE
{
 my $hWnd = $_[0];
 my $newx = 190;#$_[1];

 #---- log
 &server_log("Shoot-Thumb: ".$hWnd.", '".&GetWindowFileName($hWnd)."', '".Win32::GUI::GetClassName($hWnd)."', '".Win32::GuiTest::GetWindowText($hWnd)."'");

 #---- if dwm is disabled use layered system else set nc-rendering to off
 my $pfEnabled = pack("I",0); $DwmIsCompositionEnabled->Call($pfEnabled) if ((Win32::GetOSVersion())[1] > 5); $pfEnabled = unpack("I",$pfEnabled);
 my ($ancestor_waslayered,$oldlongext,$ancestor);
 my $ncRendering;
 if ($pfEnabled)
 {
  $ncRendering = pack("I",0); $DwmGetWindowAttribute->Call($hWnd,0x1,$ncRendering,4); $ncRendering = unpack("I",$ncRendering); # ncRendering is 0 for childs in wdm, thats good.
  if ($ncRendering)
  {
   $DwmSetWindowAttribute->Call($hWnd,0x2,pack("I",1),4);
   Time::HiRes::sleep(0.01); # call must be complete or following things are buggy
   if (Win32::GUI::IsIconic($hWnd))
   {
    Win32::GUI::Redraw($hWnd,0x441); # needed for minimized windows to draw frame
    Time::HiRes::sleep(0.01); # redraw needs time
   }
  }
 }
 else
 {
  #---- switch window to layered
  $ancestor = $GetAncestor->Call($hWnd,2);
  $oldlongext = Win32::GUI::GetWindowLong($ancestor,-20);
  $ancestor_waslayered = $oldlongext & 0x80000;
  if (! $ancestor_waslayered)
  {
   Win32::GUI::SendMessage($hWnd,WM_SETREDRAW,0,0);
   Win32::GUI::SetWindowLong($ancestor,-20,$oldlongext|0x00080000);
   Win32::GUI::SendMessage($hWnd,WM_SETREDRAW,1,0);
   $SetLayeredWindowAttributes->Call($ancestor,0,255,2);
   Time::HiRes::sleep(0.2);
  }
 }

# my $hDC = $GetWindowDC->Call($hWnd);
# my $hTargetDC = $CreateCompatibleDC->Call($hDC);
# my ($xpos,$ypos,$width,$height) = Win32::GUI::GetWindowRect($hWnd);
# $width = $width-$xpos; $height = $height-$ypos;
# my $hBitmap = $CreateCompatibleBitmap->Call($hDC,$width,$height);
# $SelectObject->Call($hTargetDC, $hBitmap);
# #$BitBlt->Call($hTargetDC,0,0,$width,$height,$hDC,$xpos,$ypos,0x40CC0020 | 0x0);
# #$BitBlt->Call($hTargetDC,0,0,$width,$height,$hDC,0,0,0x40CC0020 | 0x0);
# $PrintWindow->Call($hWnd,$hTargetDC,0);

 my $output = "";
 if (my $dib = Win32::GUI::DIBitmap->newFromWindow($hWnd))
 #if (my $dib = Win32::GUI::DIBitmap->newFromDC($hTargetDC))
 {
  my $w = $dib->Width;
  my $h = $dib->Height;
  #---- scale window
  if (defined $newx && $dib->Width != 0)
  {
   my $newy = ($dib->Height)/($dib->Width)*$newx;
   $newy = $newx*3 if ($newy > $newx*3); #stop overheight in client preview
   $dib = $dib->Rescale($newx,$newy);
  }
  #$output = $dib->SaveToData(FIF_JPEG); undef $dib;
  if ($dib) {$output = $dib->_saveToData(FIF_JPEG,0); undef $dib;} 
  else {&server_log("Cannot rescale Image (".$w."x".$h."): ".$hWnd.", '".&GetWindowFileName($hWnd)."', '".Win32::GUI::GetClassName($hWnd)."', '".Win32::GuiTest::GetWindowText($hWnd)."'");}

  #---- Make Jpeg
  #my $output = Win32::GUI::DIBitmap->newFromData($data)->SaveToData(FIF_JPEG);
  #my %opts = (binmode_stdin=>1,binmode_stdout=>1);
  #my $h = run3 './bin/libjpeg/cjpeg.exe', \$data, \$output, \%opts;
  #$output = Compress::Zlib::compress($output);
 }
 #$DeleteObject->Call($hBitmap);
 #$ReleaseDC->Call($hWnd,$hDC);
 #$DeleteDC->Call($hTargetDC);

 $DwmSetWindowAttribute->Call($hWnd,0x2,pack("I",0),4) if ($pfEnabled && $ncRendering); 
 Win32::GUI::SetWindowLong($ancestor,-20,($oldlongext & 0xFF7FFFFF)) if (!$pfEnabled && !$ancestor_waslayered);
 return($output);
}

#==== ShootDisplay
my %filter_optlist = (
"24bit 16M Colors (LAN)"     => [24,"no-filter"],
"16bit 32K Colors"           => [16,"no-filter"],
" 8bit 256 Colors"           => [ 8,"no-filter"],
" 8bit Color Optimized"      => [24,"ColorQuantize",FIQ_WUQUANT,FIF_BMP,0],
" 8bit Color Opt. & Packed"  => [24,"ColorQuantize",FIQ_WUQUANT,FIF_BMP,BMP_SAVE_RLE],
" 8bit Greyscale"            => [24,"ConvertTo8Bits",undef,FIF_BMP,0],
" 8bit Greyscale Packed"     => [24,"ConvertTo8Bits",undef,FIF_BMP,BMP_SAVE_RLE],
" 4bit 16 Colors"            => [ 4,"no-filter"],
" 4bit Greyscale"            => [24,"ConvertTo4Bits",undef,FIF_BMP,0],
" 1bit Threshold 20%"        => [24,"Threshold",chr(49),FIF_BMP,0],
" 1bit Threshold 40%"        => [24,"Threshold",chr(99),FIF_BMP,0],
" 1bit Threshold 60%"        => [24,"Threshold",chr(149),FIF_BMP,0],
" 1bit Threshold 80%"        => [24,"Threshold",chr(199),FIF_BMP,0],
" 1bit Dither Fs"            => [24,"Dither",FID_FS,FIF_BMP,0],
" 1bit Dither Bayer4x4"      => [24,"Dither",FID_BAYER4x4,FIF_BMP,0],
" 1bit Dither Bayer8x8"      => [24,"Dither",FID_BAYER8x8,FIF_BMP,0],
" 1bit Dither Cluster6x6"    => [24,"Dither",FID_CLUSTER6x6,FIF_BMP,0],
" 1bit Dither Cluster8x8"    => [24,"Dither",FID_CLUSTER8x8,FIF_BMP,0],
" 1bit Dither Cluster16x16"  => [24,"Dither",FID_CLUSTER16x16,FIF_BMP,0],
"Jpeg Color q100"           => [24,"ConvertItNot",undef,FIF_JPEG,100],
"Jpeg Color q099"           => [24,"ConvertItNot",undef,FIF_JPEG,99],
"Jpeg Color q098"           => [24,"ConvertItNot",undef,FIF_JPEG,98],
"Jpeg Color q097"           => [24,"ConvertItNot",undef,FIF_JPEG,97],
"Jpeg Color q096"           => [24,"ConvertItNot",undef,FIF_JPEG,96],
"Jpeg Color q094"           => [24,"ConvertItNot",undef,FIF_JPEG,94],
"Jpeg Color q092"           => [24,"ConvertItNot",undef,FIF_JPEG,92],
"Jpeg Color q090"           => [24,"ConvertItNot",undef,FIF_JPEG,90],
"Jpeg Color q080"           => [24,"ConvertItNot",undef,FIF_JPEG,80],
"Jpeg Color q060"           => [24,"ConvertItNot",undef,FIF_JPEG,60],
"Jpeg Color q040"           => [24,"ConvertItNot",undef,FIF_JPEG,40],
"Jpeg Color q020"           => [24,"ConvertItNot",undef,FIF_JPEG,20],
"Jpeg Color q010"           => [24,"ConvertItNot",undef,FIF_JPEG,10],
"Jpeg Color q005"           => [24,"ConvertItNot",undef,FIF_JPEG,5],
"Jpeg Color q001"           => [24,"ConvertItNot",undef,FIF_JPEG,1],
"Jpeg Greyscale q100"       => [24,"ConvertTo8Bits",undef,FIF_JPEG,100],
"Jpeg Greyscale q099"       => [24,"ConvertTo8Bits",undef,FIF_JPEG,99],
"Jpeg Greyscale q098"       => [24,"ConvertTo8Bits",undef,FIF_JPEG,98],
"Jpeg Greyscale q097"       => [24,"ConvertTo8Bits",undef,FIF_JPEG,97],
"Jpeg Greyscale q096"       => [24,"ConvertTo8Bits",undef,FIF_JPEG,96],
"Jpeg Greyscale q094"       => [24,"ConvertTo8Bits",undef,FIF_JPEG,94],
"Jpeg Greyscale q092"       => [24,"ConvertTo8Bits",undef,FIF_JPEG,92],
"Jpeg Greyscale q090"       => [24,"ConvertTo8Bits",undef,FIF_JPEG,90],
"Jpeg Greyscale q080"       => [24,"ConvertTo8Bits",undef,FIF_JPEG,80],
"Jpeg Greyscale q060"       => [24,"ConvertTo8Bits",undef,FIF_JPEG,60],
"Jpeg Greyscale q040"       => [24,"ConvertTo8Bits",undef,FIF_JPEG,40],
"Jpeg Greyscale q020"       => [24,"ConvertTo8Bits",undef,FIF_JPEG,20],
"Jpeg Greyscale q010"       => [24,"ConvertTo8Bits",undef,FIF_JPEG,10],
"Jpeg Greyscale q005"       => [24,"ConvertTo8Bits",undef,FIF_JPEG,5],
"Jpeg Greyscale q001"       => [24,"ConvertTo8Bits",undef,FIF_JPEG,1],
);
my $BITMAPINFO = pack("L", 40). # DWORD biSize;
                 "\xFF\0\0\0".  # LONG  biWidth;
                 "\xFF\0\0\0".  # LONG  biHeight;
                 "\x01\0".      # WORD  biPlanes;
                 "\x18\0".      # WORD  biBitCount;
                 "\0\0\0\0".    # DWORD biCompression;
                 "\0\0\0\0".    # DWORD biSizeImage;
                 "\0\0\0\0".    # LONG  biXPelsPerMeter;
                 "\0\0\0\0".    # LONG  biYPelsPerMeter;
                 "\0\0\0\0".    # DWORD biClrUsed;
                 "\0\0\0\0".    # DWORD biClrImportant;
                 "\0\0\0\0";    # 4 BYTES RGBQUAD
my $bmphead = "\x42\x4D\xFF\0\0\0\0\0\0\0\x36\0\0\0\x28\0\0\0\xFF\0\0\0\xFF\0\0\0\1\0\x18\0\0\0\0\0\xFF\0\0\0\x13\x0B\0\0\x13\x0B\0\0\0\0\0\0\0\0\0\0"; # 24 bit
sub Win32::GUI::DIBitmap::ConvertItNot {$_[0];}
my $time = Time::HiRes::time;
sub timetest {my $newtime = Time::HiRes::time; print "timediff: ".int(($newtime-$time)*1000)." (".shift().")\n"; $time = $newtime;}
sub ShootDisplay
{
 #timetest("start");
 my ($fileno,$xpos,$ypos,$width,$height,$jpg_quality,$forcefullscreen) = @_;
 my ($bpp,$filter_function,$filter_flag,$filter_imgformat,$filter_jpgquality) = @{$filter_optlist{$jpg_quality}};
 #print join(" + ",$fileno,$xpos,$ypos,$width,$height,$jpg_quality,$forcefullscreen)."\n";
 my $hDC = $CreateDC->Call("DISPLAY",0,0,0);
 my $hTargetDC = $CreateCompatibleDC->Call($hDC);
 my $hBitmap = $CreateCompatibleBitmap->Call($hDC,$width,$height);
 $SelectObject->Call($hTargetDC, $hBitmap);
 $BitBlt->Call($hTargetDC,0,0,$width,$height,$hDC,$xpos,$ypos,0x40CC0020);

 #---- enhance buffer if too short
 my $data_offset = ($bpp > 8)?54:54+2**$bpp*4;
 my $data_size   = int(($width*$bpp+31) / 32) * 4 * $height; # v2: (((($width*$bpp)+31) & -31) >> 3) * $height
 if (length($buffer) < $data_offset + $data_size + 100)
 {
  vec($buffer,$data_offset + $data_size + 100 - 1,8)=0; #trick to grow w.o. double malloc
  substr($buffer,0,54,$bmphead);
 }

 #---- make bmp-head into buffer
 my $compression = 0;
 #substr($buffer,14,4,pack("L1",40)); 
 substr($buffer,14+4,8,pack("L2",$width,$height));
 substr($buffer,14+14,2,pack("S1",$bpp)); #bpp
 substr($buffer,14+16,4,pack("L1",$compression)); #compression
 substr($buffer,14+20,4,pack("L1",$data_size)) if ($compression); #img-size -> needed for compression predefined (strange) -> die formel berechnet das bugbit gut
 substr($buffer,10,4,pack("L1",$data_offset)); #data-offset
 #substr($buffer,14+32,4,pack("L1",4)); #clrUsed
 #substr($buffer,14+36,4,pack("L1",4)); #biClrImportant

 #---- getdibits
 my $pbuffer = unpack("I",pack("P",$buffer));
 if (($GetDIBits2->Call($hTargetDC,$hBitmap,0,$height,$pbuffer+$data_offset,$pbuffer+14,0),$DeleteDC->Call($hTargetDC),$DeleteObject->Call($hBitmap))[2])
 {
  #std::writefile_binmode("test_image\\TEST.bmp",$buffer); print "len: ".unpack("I",substr($buffer,34,4))."\n"; system("test_image\\TEST.bmp"); exit;

  #---- bmpshrink_moreperl
  my $bmp_left = pack('I',0);
  my $bmp_top  = pack('I',0);
  my $bmp_size = pack('I',$data_offset+$data_size);
  my $bmp_shrinkstate = 0; # (0: first run (all changed)) (1: nothing changed) (2: partially changed) (3: all changed)
  if (not(defined $bmpcache[$fileno]) || $forcefullscreen)
  {
   $bmp_shrinkstate = 0;
   $bmpcache[$fileno] = ($data_offset+$data_size < length($buffer))?substr($buffer,0,$data_offset+$data_size):$buffer; # wuerde ohne substr viel zu viel speicher belegen bei kleinen fenstern sobald $buffer auch bei shootwindow eingesetzt wird
  }
  else
  {
   $bmp_shrinkstate = $bmpshrink3->Call($bmpcache[$fileno],$buffer,$bmp_left,$bmp_top,$bmp_size);
  }

  #---- image convert if needed & return
  my $dib;
  #return(join('~',$bmp_shrinkstate,unpack('I',$bmp_left),unpack('I',$bmp_top),($bmp_shrinkstate != 1)?($filter_function eq "no-filter")?substr($buffer,0,unpack("I",$bmp_size)):(($dib = Win32::GUI::DIBitmap->_newFromData(FIF_BMP,$buffer,0)) && ($dib = $dib->$filter_function((defined $filter_flag)?$filter_flag:())) && $dib->_saveToData($filter_imgformat,$filter_jpgquality)):0));
  return(join('~',$bmp_shrinkstate,unpack('I',$bmp_left),unpack('I',$bmp_top),(1)?($filter_function eq "no-filter")?substr($buffer,0,unpack("I",$bmp_size)):(($dib = Win32::GUI::DIBitmap->_newFromData(FIF_BMP,$buffer,0)) && ($dib = $dib->$filter_function((defined $filter_flag)?$filter_flag:())) && $dib->_saveToData($filter_imgformat,$filter_jpgquality)):0));
 }
 $DeleteObject->Call($hBitmap);
 $DeleteDC->Call($hDC);
 $DeleteDC->Call($hTargetDC);
 return -1;
}





#==== zum erhalten der Bilddaten eines Fenstericons
sub myDrawIcon(@)
{
 my $hWnd = $_[0];

 my $hTargetDC = $CreateCompatibleDC->Call(0);
 my $hBitmap = $CreateBitmap->Call(32,32,1,32,0);
 my $return = $SelectObject->Call($hTargetDC, $hBitmap);
 my $hBrush = $CreateSolidBrush->Call(0x00FFFFFF);
 my $return = $FillRect->Call($hTargetDC,pack('I4',0,0,32,32),$hBrush);

 my $iconhandle = Win32::GUI::SendMessage($hWnd,0x7F,1,0);# (WM_GETICON)
 my $return = $DrawIconEx->Call($hTargetDC,0,0,$iconhandle,0,0,0,0,3);

 if (my $dib = Win32::GUI::DIBitmap->newFromDC($hTargetDC))
 {
  $DeleteObject->Call($hBitmap);
  $DeleteObject->Call($hBrush);
  $DeleteDC->Call($hTargetDC);

  #$dib->SaveToFile("myyyicon.ico");
  my $data = $dib->SaveToData(FIF_ICO) if ($dib);
  undef $dib;
  return $data;
 }
 else
 {
  $DeleteObject->Call($hBitmap) if ($hBitmap);
  $DeleteObject->Call($hBrush) if ($hBrush);
  $DeleteDC->Call($hTargetDC) if ($hTargetDC);
  #undef $dib;
  return 0;
 }
}

#==== zum ermitteln des Exenames einer Fensterapplikation
my $QueryFullProcessImageName = API('Kernel32.dll','QueryFullProcessImageName','IIPP','I') if ((Win32::GetOSVersion())[1] > 5);
sub LastError { return substr(Win32::FormatMessage(Win32::GetLastError()),0,-2); }
sub GetWindowFileName($)
{
 my $hwnd = $_[0];
 unless (Win32::GUI::IsWindow($hwnd)) { &server_log("GetWindowFileName: Window does not exists. (closed?)"); return "NULL0"; }
 my $processID = (Win32::GUI::GetWindowThreadProcessId($hwnd))[1];
 my $modulefilename = ' ' x 200;
 if ((Win32::GetOSVersion())[1] <= 5) # W2k-XP-win2003 https://msdn.microsoft.com/en-us/library/windows/desktop/ms724832%28v=vs.85%29.aspx
 {
  my $processhandle = Win32API::Process::OpenProcess(0x410, 0, $processID);
  unless ($processhandle) { &server_log("GetWindowFileName: Cant open Process ($hwnd,$processID,".Win32::GUI::IsWindow($hwnd)."): ".LastError); return "NULL3"; }
  my $buffersize = $GetModuleFileNameEx->Call($processhandle,0,$modulefilename,200);
  Win32API::Process::CloseProcess($processhandle);
  unless ($buffersize) { &server_log("GetWindowFileNameEx Error: ".LastError); return "NULL4"; }
  $modulefilename = substr($modulefilename,0,$buffersize);
  #print "GetWindowFileName($hwnd) = $modulefilename;\n";
 }
 else
 {
  #my $processhandle = Win32API::Process::OpenProcess(0x410, 0, $processID);
  my $processhandle = Win32API::Process::OpenProcess(0x1000, 0, $processID);
  unless ($processhandle) { &server_log("GetWindowFileName: Cant open Process ($hwnd,$processID,".Win32::GUI::IsWindow($hwnd)."): ".LastError); return "NULL1"; }
  my $buffersize = pack("I",200);
  my $return = $QueryFullProcessImageName->Call($processhandle,0,$modulefilename,$buffersize);
  Win32API::Process::CloseProcess($processhandle);
  unless ($return) { &server_log("QueryFullProcessImageName Error: ".LastError); return "NULL2"; }
  $modulefilename = substr($modulefilename,0,unpack('I',$buffersize));
  #print "GetWindowFileName($hwnd) = $modulefilename;\n";
 }
 return $modulefilename;
}
#sub GetWindowFileName($)
#{
# my $hwnd = $_[0];
# #my $processhandle = Win32API::Process::OpenProcess(1040, 0, (Win32::GUI::GetWindowThreadProcessId($hwnd))[1]);
# my $processhandle = Win32API::Process::OpenProcess(0x410, 0, (Win32::GUI::GetWindowThreadProcessId($hwnd))[1]);
# return '' unless ($processhandle);
# my $modulefilename = ' ' x 100;
# my $buffersize = $GetModuleFileNameEx->Call($processhandle,0,$modulefilename,100);
# Win32API::Process::CloseProcess($processhandle);
# $modulefilename = substr($modulefilename,0,$buffersize);
# #print "GetWindowFileName($hwnd) = $modulefilename;\n";
# return $modulefilename;
#}

#==== zum ermitteln der Distanz zwischen Childwindow und Parent-0
sub GetHwndDeep($)
{
 my $hwnd = $_[0];
 my $deep = 0;
 while ($hwnd = Win32::GUI::GetWindowLong($hwnd,-8))
 {
  $deep++;
 }
 return $deep;
}

#==== zum ermitteln der diversen Fenstereigenschaften
sub Add_Info_To_Hwnd(@)
{
 &server_log("Get-hWnd-Info: START");
 my @foundwindows;
 foreach my $hwnd (@_)
 {
  next unless (Win32::GuiTest::IsWindowVisible($hwnd)); # faster and saver as in next if
  my $exename    = GetWindowFileName($hwnd);
  my $classname  = Win32::GUI::GetClassName($hwnd);
  my $windowname = Win32::GuiTest::GetWindowText($hwnd);
  if (#Win32::GuiTest::IsWindowVisible($hwnd) &&
      #index($classname,'VDM_Client_') != 0 &&
      #index($windowname,'VDM: ') != 0 &&
      #$windowname ne 'VDM Server Interface')
      not($classname eq "Button" && $windowname eq "Start" && $exename eq "C:\\Windows\\explorer.exe") &&
      $exename !~ m/\\vdm_appdata\\perl\\bin\\(perl|vdm[^\.]*)\.exe$/i)
  {
   #print substr("hWnd: ".sprintf('%08x',$hwnd).", $exename, '".$windowname."'",0,79)."\n";
   &server_log(sprintf("Get-hWnd-Info: %08x, '$exename', '$classname', '$windowname'",$hwnd));
   my ($left_w,$top_w,$right_w,$bottom_w) = Win32::GUI::GetWindowRect($hwnd);
   my ($left_c,$top_c,$right_c,$bottom_c) = Win32::GUI::GetClientRect($hwnd);
   my ($clientX,$clientY) = Win32::GUI::ClientToScreen($hwnd,0,0);
   my ($threadid,$processid) = Win32::GUI::GetWindowThreadProcessId($hwnd);
   push(@foundwindows,join(':',$hwnd,
                               std::fileable($windowname),
                               std::fileable($classname),
                               $left_w,$top_w,$right_w,$bottom_w,
                               $clientX,$clientY,$right_c+$clientX,$bottom_c+$clientY,
                               $GetClassLong->Call($hwnd,-26),#class-style
                               Win32::GUI::GetWindowLong($hwnd,-16),#style
                               Win32::GUI::GetWindowLong($hwnd,-20),#exstyle
                               Win32::GUI::GetWindowLong($hwnd,-8), #getparent
                               GetHwndDeep($hwnd),
                               std::fileable($exename),
                               $threadid,$processid));
  }
 }
 &server_log("Get-hWnd-Info: END");
 return @foundwindows;
}

#==== SendmessageDown
#Down Means not ButtonDown it means Down to the Handles ....
sub SendMouseDown($$$$$$)
{
 my $hwnd    = $_[0];
 my $command = $_[1];
 my $posX    = $_[2];
 my $posY    = $_[3];
 my $flags   = $_[4];
 my $debug   = $_[5];

 #my ($main_l,$main_t,$main_r,$main_b) = Win32::GUI::GetWindowRect($hwnd);
 my ($main_l,$main_t) = Win32::GUI::ClientToScreen($hwnd,0,0);
 my $screenposX = $posX+$main_l;
 my $screenposY = $posY+$main_t;

 #---- zum finden des mausklickempfaengers
 my $window = $hwnd;
 unless ($debug)
 {
  foreach my $testwin (Win32::GuiTest::GetChildWindows($hwnd))
  {
   next if ( !Win32::GuiTest::IsWindowVisible($testwin) || Win32::GUI::GetWindowLong($testwin,-8) != $window || Win32::GuiTest::GetClassName($testwin) eq "Static");
   #next if ( Win32::GUI::GetWindowLong($testwin,-8) != $window || Win32::GuiTest::GetClassName($testwin) eq "Static");
   my ($clientX,$clientY) = Win32::GUI::ClientToScreen($testwin,0,0);
   my ($clientL,$clientT,$clientR,$clientB) = Win32::GUI::GetClientRect($testwin);
   next unless ($screenposX >= $clientX && $screenposY >= $clientY && $screenposX <= $clientX+$clientR && $screenposY <= $clientY+$clientB);
   #print "--- $testwin\n";
   $window = $testwin;
  }
 }
 my ($clientX,$clientY) = Win32::GUI::ClientToScreen($window,0,0);
 my ($clientL,$clientT,$clientR,$clientB) = Win32::GUI::GetClientRect($window);
 if ($screenposX >= $clientX && $screenposY >= $clientY && $screenposX <= $clientX+$clientR && $screenposY <= $clientY+$clientB) 
 {
  #==== CLIENT
   #my ($l,$t,$r,$b) = Win32::GUI::GetClientRect($window);
   #my ($cscreen_l,$cscreen_t,$cscreen_r,$cscreen_b) = ($clientX,$clientY,$clientX+$r,$clientY+$b);
    my $classname  = Win32::GUI::GetClassName($window);
    my $newX = ($command == 0x020A || $classname eq "#32768")? $screenposX: $posX-($clientX-$main_l);
    my $newY = ($command == 0x020A || $classname eq "#32768")? $screenposY: $posY-($clientY-$main_t);
    #---- hittest raushauen sollte immer htclient sein
    my $lParam = $newY * 0x10000 + $newX;
    #ori my $hittestflag = Win32::GUI::SendMessage($hwnd,0x0084,0,$screenposY*0x10000+$screenposX); #WM_NCHITTEST
    #my $hittestflag = Win32::GUI::SendMessage($window,0x0084,0,$screenposY*0x10000+$screenposX); #WM_NCHITTEST
    #print "hit: $hittestflag\n";
    #ori Win32::GUI::PostMessage($hwnd,0x0020,$window,$command*0x10000+$hittestflag); #WM_SETCURSOR
    #Win32::GUI::PostMessage($hwnd,0x0020,$window,$command*0x10000+$hittestflag); #WM_SETCURSOR
    #Win32::GUI::PostMessage($hwnd,0x0020,$window,$command*0x10000+1); #WM_SETCURSOR
    #Win32::GUI::PostMessage($hwnd,0x0020,$window,$command*0x10000+1); #WM_MOUSEACTIVATE
    Win32::GUI::PostMessage($window,0x02A1,$flags,$lParam);#WM_MOUSEHOVER (hilight in paint-menu) (vor main-mess senden)
    Win32::GUI::PostMessage($window,$command,$flags,$lParam); # main-message
    #Win32::GUI::PostMessage($window,0x0215,0,0); # WM_CAPTURECHANGED
    #Win32::GUI::SendMessage($window,0x0021,$hwnd,$command*0x10000+1); #WM_MOUSEACTIVATE
    #Win32::GUI::PostMessage($window,0x000F,0,0);#WM_PAINT
    #Win32::GUI::PostMessage($window,0x0215,0,$window);#WM_CAPTURECHANGED
    #Win32::GUI::PostMessage($window,0x0014,Win32::GUI::Window::GetDC($window),0);#WM_ERASEBKGND
    print "Sendmouse($window,$command,$flags,$lParam)($newX,$newY); Name: ".Win32::GuiTest::GetWindowText($window)."\n";
    return $window; # keyboard_focus_handle
 }
 else # NON-CLIENT
 {


 #my %syscommand = (0x00A2."/".8 => 0xF020, #nc_up/minimize
 #                  0x00A2."/".9 => 0xF030);#nc_up/maximize
 #    if ($command != 0x020A && $command >= 0x0200 && $command <= 0x020D)# && $command == 0x0201) # if a known nc command
 #    {
 #     my $originalcommand = $command;
 #     $command -= 0x160;# if ($originalcommand != 0x0202);
 #  #my ($clientX,$clientY) = Win32::GUI::ClientToScreen($hwnd,0,0);
 #  #my ($l,$t,$r,$b) = Win32::GUI::GetClientRect($hwnd);
 #  #my ($cscreen_l,$cscreen_t,$cscreen_r,$cscreen_b) = ($clientX,$clientY,$clientX+$r,$clientY+$b);
 #     #my $newX = ($originalcommand != 0x0202)? $screenposX: $posX-($cscreen_l-$main_l);
 #     #my $newY = ($originalcommand != 0x0202)? $screenposY: $posY-($cscreen_t-$main_t);
 #     my $lParam = $screenposY * 0x10000 + $screenposX;
 #     my $hittestflag = Win32::GUI::SendMessage($hwnd,0x0084,0,$lParam); #WM_NCHITTEST
 #     #$hittestflag = 0 if ($command == 0x0202);
 #     #printf("hittest:%.4x\n",$hittestflag);
 #     #Win32::GUI::SendMessage($hwnd,0x020,$hwnd,$originalcommand*0x10000+$hittestflag); #WM_SETCURSOR
 #     Win32::GUI::PostMessage($hwnd,$command,$hittestflag,$lParam);
 #     if (defined $syscommand{$command."/".$hittestflag}) #wm_syscommand
 #     {
 #      Win32::GUI::PostMessage($hwnd,0x112,$syscommand{$command."/".$hittestflag},$screenposY*0x10000+$screenposX);
 #      Win32::GUI::PostMessage($hwnd,0x202,$flags,$lParam);
 #     }
 #     #Win32::GUI::PostMessage($hwnd,0x0112,0xF020,$lParam) if ($command == 0xA2 && $hittestflag == 8);

 #     #$DefWindowProc->Call($hwnd,$command,$hittestflag,$lParam);
 #     #Win32::GUI::SendMessage($hwnd,$command,$hittestflag,$lParam);
 #     print "NC_PostMessage($hwnd,$command,$hittestflag,$lParam)($screenposX,$screenposY); Name: ".Win32::GuiTest::GetWindowText($hwnd)."\n";
    return $hwnd; # keyboard_focus_handle
 #    }

 }

 #Win32::GUI::Redraw($hwnd,Win32::GUI::GetClientRect($hwnd),0x0085);
 #return $focushwnd;
}

#==== zum verarbeiten der Maus und Keyboardinputs
sub INPUT_EVENT($$)
{
 if ($_[0] == 1) #---- Window_KeyEvent
 {
  my ($hwnd,$hwnd_mousefocus,$event,$keycode,$flags,$kb_state) = split("~",$_[1]);
  if (Win32::GUI::GetClassName($hwnd) eq "ConsoleWindowClass")
  {
   return if ($keycode == 0x10 || $keycode == 0x11 || $keycode == 0x12);
   my @sammelkeys = grep(ord(substr($kb_state,$_,1)) & 128,0x10,0x11,0x12);
   $keybd_event->Call($_,0,0,0) foreach (@sammelkeys);
   Time::HiRes::sleep(0.05);
   Win32::GUI::PostMessage($hwnd_mousefocus,$event,$keycode,int $flags);
   Time::HiRes::sleep(0.05);
   $keybd_event->Call($_,0,2,0) foreach (@sammelkeys);
  }
  else
  {
   my $threadID = $GetCurrentThreadId->Call();
   my $threadIDwin = (Win32::GUI::GetWindowThreadProcessId($hwnd_mousefocus || $hwnd))[0];
   Win32::GUI::AttachThreadInput($threadID,$threadIDwin,1);
   $SetKeyboardState->Call($kb_state);
   my $kb_focus = Win32::GUI::GetFocus();
   unless ($kb_focus) { Win32::GUI::SetFocus($hwnd_mousefocus); $kb_focus = $hwnd_mousefocus; } # fuer fenster die nicht bei mausklick selber den focus setzten
   Win32::GUI::PostMessage($kb_focus,$event,$keycode,int $flags);
   Time::HiRes::sleep(0.05);
   Win32::GUI::AttachThreadInput($threadID,$threadIDwin,0);
  }
 }
 elsif ($_[0] == 2) #---- Desktop_KeyEvent
 {
  my ($event,$keycode,$flags) = split("~",$_[1]);
  my ($repeat_count,$scan_code,$extended_key) = unpack('S1 C1 b1',pack('I1',$flags));
  $keybd_event->Call($keycode,$scan_code,($event == 0x100 || $event == 0x104)?0:2,$extended_key) while ($repeat_count--);
 }
 elsif ($_[0] == 3) #---- Desktop_MouseEvent
 {
  my ($event,$xcor,$ycor,$flags) = split("~",$_[1]);
  if ($event == 0x200) { Win32::GUI::SetCursorPos($xcor,$ycor); }
  elsif ($event == 0x201) { Win32::GuiTest::SendLButtonDown(); }
  elsif ($event == 0x202) { Win32::GuiTest::SendLButtonUp(); }
  elsif ($event == 0x204) { Win32::GuiTest::SendRButtonDown(); }
  elsif ($event == 0x205) { Win32::GuiTest::SendRButtonUp(); }
  elsif ($event == 0x207) { Win32::GuiTest::SendMButtonDown(); }
  elsif ($event == 0x208) { Win32::GuiTest::SendMButtonUp(); }
  elsif ($event == 0x20A) { my $scroll_ID = int($flags / 0x10000); Win32::GuiTest::MouseMoveWheel($scroll_ID / 120); }
 }
}

#==== zum laden der "brauchbaren" toplevel windows fr auto-window-open funktion
sub windowlist_4openwindow(@)
{
 my @winlist;
 foreach my $hwnd (@_)
 {
  next unless (Win32::GuiTest::IsWindowVisible($hwnd)); # faster and saver as in next if
  my $exename    = GetWindowFileName($hwnd);
  my $classname  = Win32::GUI::GetClassName($hwnd);
  my $windowname = Win32::GuiTest::GetWindowText($hwnd);
  my ($threadID,$processID) = Win32::GUI::GetWindowThreadProcessId($hwnd);
  my $exstyle = Win32::GUI::GetWindowLong($hwnd,-20);

  if (#Win32::GuiTest::IsWindowVisible($hwnd)
      #&& $classname ne 'RealTimeMagnifier1'   #Onelupe
      #&& index($classname,'VDM_Client_') != 0 #Client-Loader-Windows
      #&& not($classname eq 'TkTopLevel' && ($windowname eq 'Balloon' || $windowname eq 'Toplevel')) #Tk-Balloon-Popups and Tk-Listbox-Popups
      #&& not(index($classname,'#') == 0 && index($windowname,'VDM: ') == 0)) #VDM-Messageboxes
      $exename !~ m/\\vdm_appdata\\perl\\bin\\(perl|vdm[^\.]*)\.exe$/i &&
      not($exstyle & 0x00000020)) #ws_ex_transparent disabled because flicker while loader writes
  {
   push(@winlist,join(':',$hwnd,std::fileable($exename),std::fileable($classname),std::fileable($windowname),$threadID,$processID));
  }
 }
 return join("\t",@winlist);
}

#==== zum holen der monitorinfos fuer das desktopstreaming
my @displayinfo_array;
my $MONITORINFOEX = pack("I", 72).("\x00" x 72);
my $MonitorEnumProc = Win32::API::Callback->new(sub{ $GetMonitorInfo->Call($_[0],$MONITORINFOEX); push(@displayinfo_array,join("\t",$_[0],unpack("i4",unpack("P16",pack("I",$_[2]))),substr($MONITORINFOEX,40,index($MONITORINFOEX,"\x00",40)-40))); }, "NNNN", "I");
sub GetMonitorInfos()
{
 @displayinfo_array = ();
 $EnumDisplayMonitors->Call(0,0,$MonitorEnumProc,0);
 return join("\n",@displayinfo_array);
}
#print "Monitor: ".join(",",split("\t",$_))."\n" foreach (split("\n",GetMonitorInfos));

#==== subs zum erstellen eines menue abbildes
my $GetMenuItemInfo = Win32::API->new('User32.dll','GetMenuItemInfo','IIIP','I');
my $GetMenuItemCount = Win32::API->new('User32.dll','GetMenuItemCount','I','I');
sub menu_getdata($)
{
 #---- leere menu daten arrays
 my @menu_string;
 my @menu_data;

 #---- arrays mit daten fuellen
 my @menuarray = (Win32::GUI::GetMenu($_[0]));
 return "" unless $menuarray[0];
 my $menucount = 0;
 foreach my $menuhandle (@menuarray)
 {
  my $itemcount = $GetMenuItemCount->Call($menuhandle);
  for(my $i=0; $i<$itemcount; $i++)
  {
   #---- mii struct vorbereiten
   my $MENUITEMINFO = pack("I", 48).("\x00" x 48);
   my $menu_string = "\x00" x 100;
   substr($MENUITEMINFO,4,4,pack("I",0x147));
   substr($MENUITEMINFO,36,4,pack("P",$menu_string));
   substr($MENUITEMINFO,40,4,pack("I",100));

   #---- get struct
   $GetMenuItemInfo->Call($menuhandle,$i,1,$MENUITEMINFO);

   #---- save data
   $menu_string = substr($menu_string,0,unpack("I",substr($MENUITEMINFO,40,4)));
   $menu_data[$menucount][$i] = $MENUITEMINFO;
   $menu_string[$menucount][$i] = $menu_string;

   #---- submenues auch durchsuchen
   my $hSubMenu = unpack("I",substr($MENUITEMINFO,20,4));
   push(@menuarray,$hSubMenu) if ($hSubMenu);
  }
  $menucount++;
 }

 #---- menu daten arrays stringifizieren und return
 return join('#CC#',join('#BB#',map(join('#AA#',@$_),@menu_string)),
                    join('#BB#',map(join('#AA#',@$_),@menu_data)));
}

#==== zum setzen der clientsize bei topwindow
sub ClientResize($$$)
{
 #---- get nonclient size
 #my ($main_l,$main_t,$main_r,$main_b) = Win32::GUI::GetWindowRect($_[0]);
 #my ($clientX,$clientY) = (Win32::GUI::GetClientRect($_[0]))[2,3];
 #my $nonclient_w = $main_r-$main_l-$clientX;
 #my $nonclient_h = $main_b-$main_t-$clientY;
 #Win32::GUI::Resize($_[0],$_[1]+$nonclient_w,$_[2]+$nonclient_h);
 Win32::GUI::Resize($_[0],$_[1]+(Win32::GUI::Width($_[0])-Win32::GUI::ScaleWidth($_[0])),$_[2]+(Win32::GUI::Height($_[0])-Win32::GUI::ScaleHeight($_[0])));
}

#==== zum ersetzen der fehlenden API schnittstelle des servers
sub GetAncestor()
{
 $GetAncestor->Call($_[0],$_[1]);
}

#==== zum ermitteln der relativen fensterposition neuer fenster
sub CalcRelWinPos()
{
 my ($newopen_hwnd,$running_list) = @_;
 return(0,0,0) if ($running_list eq ""); #when nothing open serverside

 my $newopen_exename = GetWindowFileName($newopen_hwnd);
 if ($newopen_exename !~ m/^NULL\d$/)
 {
  #---- exename ok -> passendes subfenster suchen
  foreach (split(",",$running_list))
  {
   my ($running_client_hwnd,$running_server_hwnd) = split("/",$_);
   my $running_exename = GetWindowFileName($running_server_hwnd);
   if ($running_exename eq $newopen_exename)
   {
    my ($rX,$rY) = Win32::GUI::ClientToScreen($running_server_hwnd,0,0);
    my ($nX,$nY) = Win32::GUI::ClientToScreen($newopen_hwnd,0,0);
    return($running_client_hwnd,$nX-$rX,$nY-$rY);
   }
  }
 }
 #---- kein exename od. passendes subfenster -> oberstes fenster nutzen
 my ($running_client_hwnd,$running_server_hwnd) = split("/",(split(",",$running_list))[0]);
 my ($rX,$rY) = Win32::GUI::ClientToScreen($running_server_hwnd,0,0);
 my ($nX,$nY) = Win32::GUI::ClientToScreen($newopen_hwnd,0,0);
 #my ($nL,$nT,$nR,$nB) = Win32::GUI::GetWindowRect($newopen_hwnd);
 #my ($rL,$rT,$rR,$rB) = Win32::GUI::GetWindowRect($running_server_hwnd);
 return($running_client_hwnd,$nX-$rX,$nY-$rY);
}

##======================================================== daemonthread
#sub tcp_slurpin($)
#{
# my $dsock  = $_[0];
# #my $tosend = $_[1];
#
# my $theselect = IO::Select->new($dsock);
# if($theselect->can_read())
# {
#  my $sammelrequest;
#  my $data;
#  while(my $readstate = sysread($dsock,$data,1024))
#  {
#   return(0) if ($readstate eq undef);
#   $sammelrequest .= $data;
#   if ($sammelrequest =~ s/~END$//)
#   {
#    return $sammelrequest;
#    #last;
#   }
#   sleep(0.1);
#   print "must-reread\n";
#  }
#  #if($theselect->can_write())
#  #{
#  # syswrite($dsock,"GETWINDOWS\n");
#  #}
# }
# #print "PROBLEM_TO_LOAD:end_slurpin\n";
# return 0;
#}
#sub tcp_slurpout($$)
#{
# my $dsock  = $_[0];
# my $data   = $_[1];
# my $theselect = IO::Select->new($dsock);
# if($theselect->can_write())
# {
#  syswrite($dsock,$data.'~END');
#  return;
# }
# print "PROBLEM_TO_SEND:end_slurpout\n";
#}
#sub startdaemon()
#{
# my $portid = 5000;#+$camidentifier;
# my $dsock = IO::Socket::INET->new(Listen    => SOMAXCONN,
#                                   LocalAddr => inet_ntoa(INADDR_ANY),
#                                   LocalPort => $portid,
#                                   #Broadcast => 1,
#                                   #Type => SOCK_STREAM,
#                                   #Blocking => 1,
#                                   Proto     => 'tcp');
# die "Could not create socket: $!\n" unless $dsock;
# print ">Daemon waiting on 'INADDR_ANY:$portid'\n";
#
# #-------------------------------------- accept while
# while (my $new_dsock = $dsock->accept())
# {
#  while (my $request = tcp_slurpin($new_dsock))
#  {
#   #print "Request: ".$request."\n";
#   if($request =~ m/^GETCHILDWINDOWS~(\d+)/)
#   {
#    tcp_slurpout($new_dsock,GetChildWindows($1));
#   }
#   elsif($request =~ m/^SHOOTWINDOW_SMALL~(\d+)/)
#   {
#    tcp_slurpout($new_dsock,ShootWindow_ONCE($1,190));
#   }
#   elsif($request =~ m/^SHOOTWINDOW~(\d+)/)
#   {
#    tcp_slurpout($new_dsock,ShootWindow($1));
#   }
#   elsif($request =~ m/^GetWindowSize~(\d+)/)
#   {
#    tcp_slurpout($new_dsock,Win32::GUI::Width($1).'~'.Win32::GUI::Height($1));
#   }
#   elsif($request =~ m/^SendMouseDown~(\d+)~([^~]+)~([^~]+)~([^~]+)/)
#   {
#    sendmousedown($1,$2,$3,$4);
#    tcp_slurpout($new_dsock,'');
#   }
#   elsif($request =~ m/^SendMessage~(\d+)~([^~]+)~([^~]+)~([^~]+)/)
#   {
#    tcp_slurpout($new_dsock,Win32::GUI::SendMessage($1,$2,$3,$4));
#   }
#   elsif($request =~ m/^PostMessage~(\d+)~([^~]+)~([^~]+)~([^~]+)/)
#   {
#    tcp_slurpout($new_dsock,Win32::GUI::PostMessage($1,$2,$3,$4));
#   }
#   elsif($request =~ m/^myDrawIcon~(\d+)/)
#   {
#    tcp_slurpout($new_dsock,myDrawIcon($1));
#   }
#   #elsif($request =~ m/^ShowWindow~(\d+)~(\d+)/)
#   #{
#   # tcp_slurpout($new_dsock,Win32::GuiTest::ShowWindow($1,$2));
#   #}
#   elsif($request =~ m/^EVAL~(.+)/)
#   {
#    tcp_slurpout($new_dsock,eval($1));
#   }
#  }
#
#
#
# }
# print "http:really dead\n";
# close($dsock);
#}
##my $daemonthread = threads->create('startdaemon');
##startdaemon();



#==== zum erstellen des passwort-sha1-hash
sub generate_password_hash($)
{
 my $key = $_[0];
 if ($key !~ m/^KEY-/)
 {
   $key = uc(Digest::SHA::sha1_hex($key)) for (1..20);
   return 'KEY-'.$key;
 }
 return $key;
}

#==== load user.dat
my %userpass_hash;
my @fileno_hasaccess;
my @fileno_publichash;
foreach my $line (split("\n",std::readfile('config/config_server_users.dat')))
{
 my ($user_name,$user_pass) = split("\t",$line);
 #$userpass_hash{$user_name.'/'.$user_pass} = 1;
 $userpass_hash{$user_name} = generate_password_hash($user_pass);
}

#==== load server_config.dat
my %server_config;
foreach my $line (split("\n",std::readfile('config/config_server.dat')))
{
 my ($key_name,$key_value) = split("\t",$line);
 $server_config{$key_name} = $key_value;
}

#==== um commandline-schalter in die config hashs laden
use Getopt::Long;
my @userpasslist;
GetOptions ("ip=s{1}" => \$server_config{addr},"port=i" => \$server_config{port},"users=s{1,}" => \@userpasslist);
#print "addr: ".$server_config{addr}."\n";
#print "port: ".$server_config{port}."\n";
if ($#userpasslist != -1)
{
 %userpass_hash = ();
 #print "Only this Users will be used(".$#userpasslist."):\n";
}
foreach my $userpass (@userpasslist)
{
 my ($user,$pass) = split("/",$userpass);
 $userpass_hash{$user} = generate_password_hash($pass);
 #print "User: $user / Pass: $pass\n";
}

###########################################################
################################## Server Socket System ###
#---- slurpout2
my $stream_terminator = "~#END#";
sub tcp_slurpout2($$)
{
 my $dsock  = $_[0];
 my $data   = $_[1];
 #my $theselect = IO::Select->new($dsock);
 if(IO::Select->new($dsock)->can_write(0))
 {
  #print "can_write\n";
  syswrite($dsock,$data.$stream_terminator);
  return;
 }
 my $fileno = fileno($dsock);
 &server_log('SLURPOUT_CONNECTION_BROKEN('.$fileno.'/'.inet_ntoa($dsock->peeraddr()).':'.$dsock->peerport().'->'.$dsock->sockhost().':'.$dsock->sockport().')');
 $sel->remove($dsock);
 $dsock->close;
 delete $sock_cache[$fileno];
}
#---- Server RUN
&server_log("-------------------- START");
&server_log("User Can Login: ".join(", ",map {"'".$_."'"} (keys %userpass_hash)));
if ($#{[keys %userpass_hash]} == -1) { &server_log("Please create a user first -> SERVER_STOPPED"); &server_log("-------------------- STOP"); exit 12; }
my $lsn;
my $sel;
my @sock_cache;
sub server_run()
{
 #my $fallout_time = time;
 while(@ready = $sel->can_read(7))
 {
  #last if (time-$fallout_time > 5);
  #print "can_read\n";
  foreach $fh (@ready)
  {
   if($fh == $lsn)
   {
    # Create a new socket
    my $newsock = $lsn->accept;
    $sel->add($newsock);
    &server_log('SOCKET_ACCEPTED('.fileno($newsock).'/'.inet_ntoa($newsock->peeraddr()).':'.$newsock->peerport().'->'.$newsock->sockhost().':'.$newsock->sockport().')');
    $fileno_hasaccess[fileno($newsock)] = 0;
    $fileno_publichash[fileno($newsock)] = uc(Digest::SHA::sha1_hex(rand()));
   }
   else
   {
    my $fileno = fileno($fh);
    my $data;
    if (! sysread($fh,$data,1000000))
    {
     # Connection Corrupted
     &server_log('CONNECTION_BROKEN('.$fileno.'/'.inet_ntoa($fh->peeraddr()).':'.$fh->peerport().'->'.$fh->sockhost().':'.$fh->sockport().')');
     $sel->remove($fh);
     $fh->close;
     delete $sock_cache[$fileno];
     $fileno_hasaccess[$fileno] = 0;
     $fileno_publichash[$fileno] = uc(Digest::SHA::sha1_hex(rand()));
     stop_stream($fileno);
    }
    else
    {
     #print "opened\n" if ($fh->opened);
     #print "NOT-opened\n" if (! $fh->opened);
     $sock_cache[$fileno] .= $data;
     if ($sock_cache[$fileno] =~ s/$stream_terminator$//)
     {
      #print "iread(".$fileno."): ".$sock_cache[$fileno]."\n";
      #tcp_slurpout2($fh,$sock_cache[$fileno]);

      #------ LOGIN
      if($sock_cache[$fileno] =~ m/^LOGINGETPUBLIC/)
      {
        tcp_slurpout2($fh,$fileno_publichash[$fileno]);
      }
      elsif($sock_cache[$fileno] =~ m/^LOGIN~(.+)\/(.+)/)
      {
       if (defined $userpass_hash{$1})
       {
        my $complexpass = $userpass_hash{$1}.$fileno_publichash[$fileno];
        $complexpass = uc(Digest::SHA::sha1_hex($complexpass)) for (1 .. 7);
        if ($complexpass eq $2)
        {
         &server_log('LOGIN_OK('.$fileno.','.$1.')');
         $fileno_hasaccess[$fileno] = 1;
         tcp_slurpout2($fh,'LOGIN_OK');
        }
        else
        {
         &server_log('LOGIN_ERROR/WRONG_NAME_OR_PASS('.$fileno.','.$1.')');
         tcp_slurpout2($fh,'LOGIN_ERROR/WRONG_NAME_OR_PASS');
        }
       }
       else
       {
        &server_log('LOGIN_ERROR/WRONG_NAME_OR_PASS('.$fileno.')');
        tcp_slurpout2($fh,'LOGIN_ERROR/WRONG_NAME_OR_PASS');
       }
      }
      elsif ($fileno_hasaccess[$fileno] == 1)
      {
       #&server_log("command: ".substr($sock_cache[$fileno],0,20));
       #------- COMMAND_IF
       if($sock_cache[$fileno] =~ m/^SHOOTWINDOW~([^~]*)~([^~]*)/)
       {
        tcp_slurpout2($fh,ShootWindow($fileno,$1,$2));
       }
       elsif($sock_cache[$fileno] =~ m/^SHOOTDISPLAY~([^~]*)~([^~]*)~([^~]*)~([^~]*)~([^~]*)~([^~]*)/)
       {
        tcp_slurpout2($fh,ShootDisplay($fileno,$1,$2,$3,$4,$5,$6));
       }
       elsif($sock_cache[$fileno] =~ m/^GETCHILDWINDOWS_FULLINFO~([^~]*)/)
       {
        tcp_slurpout2($fh,join("\t",Add_Info_To_Hwnd Win32::GuiTest::GetChildWindows($1)));
       }
       elsif($sock_cache[$fileno] =~ m/^GETCHILDWINDOWS_4OPENWINDOW~([^~]*)/) #auto-open
       {
        tcp_slurpout2($fh,windowlist_4openwindow Win32::GuiTest::GetChildWindows(0));
       }
       #elsif($sock_cache[$fileno] =~ m/^FINDWINDOWLIKE~([^~]*)~([^~]*)/)
       #{
       # tcp_slurpout2($fh,join("\t",Win32::GuiTest::FindWindowLike(0,$2,$1,undef,1)));
       #}
       elsif($sock_cache[$fileno] =~ m/^FINDWINDOWLIKE_URI~([^:]*):?([^:]*):?([^:]*):?([^:]*)/)
       {
        tcp_slurpout2($fh,join("\t",grep(Win32::GuiTest::IsWindowVisible($_) && ($1 eq "" || GetWindowFileName($_) =~ m/$1/i) && GetWindowFileName($_) !~ m/\\vdm_appdata\\perl\\bin\\(perl|vdm[^\.]*)\.exe$/i,Win32::GuiTest::FindWindowLike(0,$3,$2,undef,$4+1))));
       }
       elsif($sock_cache[$fileno] =~ m/^FINDWINDOWLIKE_URI_FULLINFO~([^:]*):?([^:]*):?([^:]*):?([^:]*)/)
       {
        # achtung: the empty pattern // or /$empty/ evaluates the last successfully matched regular expression (daher: eq "")
        tcp_slurpout2($fh,join("\t",Add_Info_To_Hwnd(grep($1 eq "" || GetWindowFileName($_) =~ m/$1/i,Win32::GuiTest::FindWindowLike(0,$3,$2,undef,$4+1)))));
       }
       #elsif($sock_cache[$fileno] =~ m/^SHOOTWINDOW_SMALL~([^~]*)/)
       #{
       # tcp_slurpout2($fh,ShootWindow_ONCE($1,190));
       #}
       #elsif($sock_cache[$fileno] =~ m/^GetClientSize~([^~]*)/)
       #{
       # tcp_slurpout2($fh,Win32::GUI::ScaleWidth($1).'~'.Win32::GUI::ScaleHeight($1));
       #}
       #elsif($sock_cache[$fileno] =~ m/^SendMouseDown~([^~]*)~([^~]+)~([^~]+)~([^~]+)~([^~]+)~([^~]+)/)
       #{
       # tcp_slurpout2($fh,sendmousedown($1,$2,$3,$4,$5,$6));
       #}
       elsif($sock_cache[$fileno] =~ m/^INPUT_EVENT~([^~]*)~(.*)/)
       {
        tcp_slurpout2($fh,INPUT_EVENT($1,$2));
       }
       #elsif($sock_cache[$fileno] =~ m/^menu_getdata~([^~]*)/)
       #{
       # tcp_slurpout2($fh,menu_getdata($1));
       #}
       #elsif($sock_cache[$fileno] =~ m/^ClientResize~([^~]*)~([^~]*)~([^~]*)/)
       #{
       # tcp_slurpout2($fh,ClientResize($1,$2,$3));
       #}
       #elsif($sock_cache[$fileno] =~ m/^SendMessage~([^~]*)~([^~]+)~([^~]+)~([^~]+)/)
       #{
       # tcp_slurpout2($fh,Win32::GUI::SendMessage($1,$2,$3,$4));
       #}
       #elsif($sock_cache[$fileno] =~ m/^PostMessage~([^~]*)~([^~]+)~([^~]+)~([^~]+)/)
       #{
       # tcp_slurpout2($fh,Win32::GUI::PostMessage($1,$2,$3,$4));
       #}
       elsif($sock_cache[$fileno] =~ m/^GETDISPLAYINFO/)
       {
        tcp_slurpout2($fh,GetMonitorInfos());
       }
       #elsif($sock_cache[$fileno] =~ m/^myDrawIcon~([^~]*)/)
       #{
       # tcp_slurpout2($fh,myDrawIcon($1));
       #}
       #elsif($sock_cache[$fileno] =~ m/^ShowWindow~(\d+)~(\d+)/)
       #{
       # tcp_slurpout2($fh,Win32::GuiTest::ShowWindow($1,$2));
       #}
       elsif($sock_cache[$fileno] =~ m/^EVAL~(.*)/s)
       {
        tcp_slurpout2($fh,eval($1));
       }
       #---- Dynamic Subsystem (todo: delete all above commands)
       elsif($sock_cache[$fileno] =~ m/^([^~|]*)~(.*)/)
       {
        if (defined &$1)
        {
         tcp_slurpout2($fh,join("~",&$1(split("~",$2))));
        }
        else
        {
	 &server_log("Fatal: Undefined subroutine \&$1.");
         tcp_slurpout2($fh,"UNDEFINED_SUBROUTINE");
        }
       }
       #---- Multicommand
       elsif($sock_cache[$fileno] =~ m/^MultiCommand\|(.*)/)
       {
        my @retlist;
        foreach(split(/\|/,$1))
        {
         if(m/^([^~]*)~(.*)/)
         {
          if(defined &$1)
          {
           my @sublist = &$1(split("~",$2));
           if ($#sublist > 0) {s/~//g for @sublist;}
           push(@retlist,join("~",@sublist));
          }
          else
          {&server_log("Fatal: Undefined subroutine \&$1.");push(@retlist,"");}
         }
         else
         {&server_log("Fatal: MultiCommand syntax. ($_)");push(@retlist,"");}
        }
        if ($#retlist > 0) {s/\|//g for @retlist;}
        tcp_slurpout2($fh,join("|",@retlist));
       }
       #---- Shutdown
       elsif($sock_cache[$fileno] =~ m/^SHUTDOWN/)
       {
        tcp_slurpout2($fh,'OK');
        my @anc_layered = keys %ancestors_layered;
        Win32::GUI::SetWindowLong($_,-20,Win32::GUI::GetWindowLong($_,-20)&0xFFF7FFFF) foreach (@anc_layered);
	&server_log("SHUTDOWN/ancestors_unlayered: ".++$#anc_layered);
	$lsn->close;
       }
       #---- TEST
       elsif($sock_cache[$fileno] =~ m/^TEST/)
       {
        tcp_slurpout2($fh,'ALL_OK');
	&server_log("TEST: ALL_OK");
       }
       #---- Unknown
       else
       {
        &server_log('UNKNOWN_COMMAND('.$fileno.'): '.$sock_cache[$fileno]);
        tcp_slurpout2($fh,'UNKNOWN_COMMAND');
       }
      }
      else
      {
       &server_log('LOGIN_FIRST('.$fileno.')');
       tcp_slurpout2($fh,'LOGIN_FIRST');
      }
      #----- COMMAND_IF DONE ... delete cache
      delete $sock_cache[$fileno];
     }
    }
   }
  }
 }
}
#======================================================== Service Log
#sub datetime()
#{
# my ($Sekunden, $Minuten, $Stunden, $Monatstag, $Monat,
#     $Jahr, $Wochentag, $Jahrestag, $Sommerzeit) = localtime(time);
# $Monat+=1;
# $Monat = $Monat < 10 ? $Monat = "0".$Monat : $Monat;
# $Monatstag = $Monatstag < 10 ? $Monatstag = "0".$Monatstag : $Monatstag;
# $Stunden = $Stunden < 10 ? $Stunden = "0".$Stunden : $Stunden;
# $Minuten = $Minuten < 10 ? $Minuten = "0".$Minuten : $Minuten;
# $Sekunden = $Sekunden < 10 ? $Sekunden = "0".$Sekunden : $Sekunden;
# $Jahr+=1900;
# return("$Jahr-$Monat-$Monatstag","$Stunden:$Minuten:$Sekunden");
#}
#sub server_log_write($)
#{
# my ($date,$time) = &datetime;
# std::writefile_append('server_log\\'.$date.'.txt',$time.' pid '.$$.': '.$_[0]."\n");
#}
sub server_log($)
{
 print "Log: ".$_[0]."\n";
 server_log_write($_[0]);
}
#======================================================== INT Signal
$SIG{'INT'} = 'INT_handler';
sub INT_handler
{
        my @anc_layered = keys %ancestors_layered;
        Win32::GUI::SetWindowLong($_,-20,Win32::GUI::GetWindowLong($_,-20)&0xFFF7FFFF) foreach (@anc_layered);
	&server_log("CONSOLE_INTERUPT/ancestors_unlayered: ".++$#anc_layered);
	$lsn->close;
}
#======================================================== Server Loop
# API Error
&server_log($_) foreach (@api_errorlog);
# Open Socket
$lsn = new IO::Socket::INET(Listen => 1,LocalAddr => $server_config{addr},LocalPort => $server_config{port});
if ($lsn)
{
 $sel = new IO::Select( $lsn );
 &server_log("SERVER_START_PENDING -> SERVER_RUNNING on $server_config{addr}:$server_config{port}");
 std::writefile('config/running_pid.dat',$$);
 server_run() while ($lsn->listen);
}
else
{
 &server_log("Cant create Socket($server_config{addr}:$server_config{port}): $! -> SERVER_STOPPED");
 &server_log("-------------------- STOP");
 exit 11;
}
std::writefile('config/running_pid.dat',0);
&server_log("-------------------- STOP");
exit 7;
########################################################################
__END__
